# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['DeploymentArgs', 'Deployment']

@pulumi.input_type
class DeploymentArgs:
    def __init__(__self__, *,
                 compartment_id: pulumi.Input[builtins.str],
                 gateway_id: pulumi.Input[builtins.str],
                 path_prefix: pulumi.Input[builtins.str],
                 specification: pulumi.Input['DeploymentSpecificationArgs'],
                 defined_tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 display_name: Optional[pulumi.Input[builtins.str]] = None,
                 freeform_tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None):
        """
        The set of arguments for constructing a Deployment resource.
        :param pulumi.Input[builtins.str] compartment_id: (Updatable) The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment in which the resource is created.
        :param pulumi.Input[builtins.str] gateway_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the resource.
        :param pulumi.Input[builtins.str] path_prefix: A path on which to deploy all routes contained in the API deployment specification. For more information, see [Deploying an API on an API Gateway by Creating an API Deployment](https://docs.cloud.oracle.com/iaas/Content/APIGateway/Tasks/apigatewaycreatingdeployment.htm).
        :param pulumi.Input['DeploymentSpecificationArgs'] specification: (Updatable) The logical configuration of the API exposed by a deployment.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] defined_tags: (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        :param pulumi.Input[builtins.str] display_name: (Updatable) A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.  Example: `My new resource`
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] freeform_tags: (Updatable) Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        """
        pulumi.set(__self__, "compartment_id", compartment_id)
        pulumi.set(__self__, "gateway_id", gateway_id)
        pulumi.set(__self__, "path_prefix", path_prefix)
        pulumi.set(__self__, "specification", specification)
        if defined_tags is not None:
            pulumi.set(__self__, "defined_tags", defined_tags)
        if display_name is not None:
            pulumi.set(__self__, "display_name", display_name)
        if freeform_tags is not None:
            pulumi.set(__self__, "freeform_tags", freeform_tags)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> pulumi.Input[builtins.str]:
        """
        (Updatable) The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment in which the resource is created.
        """
        return pulumi.get(self, "compartment_id")

    @compartment_id.setter
    def compartment_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "compartment_id", value)

    @property
    @pulumi.getter(name="gatewayId")
    def gateway_id(self) -> pulumi.Input[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the resource.
        """
        return pulumi.get(self, "gateway_id")

    @gateway_id.setter
    def gateway_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "gateway_id", value)

    @property
    @pulumi.getter(name="pathPrefix")
    def path_prefix(self) -> pulumi.Input[builtins.str]:
        """
        A path on which to deploy all routes contained in the API deployment specification. For more information, see [Deploying an API on an API Gateway by Creating an API Deployment](https://docs.cloud.oracle.com/iaas/Content/APIGateway/Tasks/apigatewaycreatingdeployment.htm).
        """
        return pulumi.get(self, "path_prefix")

    @path_prefix.setter
    def path_prefix(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "path_prefix", value)

    @property
    @pulumi.getter
    def specification(self) -> pulumi.Input['DeploymentSpecificationArgs']:
        """
        (Updatable) The logical configuration of the API exposed by a deployment.
        """
        return pulumi.get(self, "specification")

    @specification.setter
    def specification(self, value: pulumi.Input['DeploymentSpecificationArgs']):
        pulumi.set(self, "specification", value)

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        """
        return pulumi.get(self, "defined_tags")

    @defined_tags.setter
    def defined_tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "defined_tags", value)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Updatable) A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.  Example: `My new resource`
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        (Updatable) Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        """
        return pulumi.get(self, "freeform_tags")

    @freeform_tags.setter
    def freeform_tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "freeform_tags", value)


@pulumi.input_type
class _DeploymentState:
    def __init__(__self__, *,
                 compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 defined_tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 display_name: Optional[pulumi.Input[builtins.str]] = None,
                 endpoint: Optional[pulumi.Input[builtins.str]] = None,
                 freeform_tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 gateway_id: Optional[pulumi.Input[builtins.str]] = None,
                 lifecycle_details: Optional[pulumi.Input[builtins.str]] = None,
                 path_prefix: Optional[pulumi.Input[builtins.str]] = None,
                 specification: Optional[pulumi.Input['DeploymentSpecificationArgs']] = None,
                 state: Optional[pulumi.Input[builtins.str]] = None,
                 time_created: Optional[pulumi.Input[builtins.str]] = None,
                 time_updated: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering Deployment resources.
        :param pulumi.Input[builtins.str] compartment_id: (Updatable) The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment in which the resource is created.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] defined_tags: (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        :param pulumi.Input[builtins.str] display_name: (Updatable) A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.  Example: `My new resource`
        :param pulumi.Input[builtins.str] endpoint: The endpoint to access this deployment on the gateway.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] freeform_tags: (Updatable) Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        :param pulumi.Input[builtins.str] gateway_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the resource.
        :param pulumi.Input[builtins.str] lifecycle_details: A message describing the current state in more detail. For example, can be used to provide actionable information for a resource in a Failed state.
        :param pulumi.Input[builtins.str] path_prefix: A path on which to deploy all routes contained in the API deployment specification. For more information, see [Deploying an API on an API Gateway by Creating an API Deployment](https://docs.cloud.oracle.com/iaas/Content/APIGateway/Tasks/apigatewaycreatingdeployment.htm).
        :param pulumi.Input['DeploymentSpecificationArgs'] specification: (Updatable) The logical configuration of the API exposed by a deployment.
        :param pulumi.Input[builtins.str] state: The current state of the deployment.
        :param pulumi.Input[builtins.str] time_created: The time this resource was created. An RFC3339 formatted datetime string.
        :param pulumi.Input[builtins.str] time_updated: The time this resource was last updated. An RFC3339 formatted datetime string.
        """
        if compartment_id is not None:
            pulumi.set(__self__, "compartment_id", compartment_id)
        if defined_tags is not None:
            pulumi.set(__self__, "defined_tags", defined_tags)
        if display_name is not None:
            pulumi.set(__self__, "display_name", display_name)
        if endpoint is not None:
            pulumi.set(__self__, "endpoint", endpoint)
        if freeform_tags is not None:
            pulumi.set(__self__, "freeform_tags", freeform_tags)
        if gateway_id is not None:
            pulumi.set(__self__, "gateway_id", gateway_id)
        if lifecycle_details is not None:
            pulumi.set(__self__, "lifecycle_details", lifecycle_details)
        if path_prefix is not None:
            pulumi.set(__self__, "path_prefix", path_prefix)
        if specification is not None:
            pulumi.set(__self__, "specification", specification)
        if state is not None:
            pulumi.set(__self__, "state", state)
        if time_created is not None:
            pulumi.set(__self__, "time_created", time_created)
        if time_updated is not None:
            pulumi.set(__self__, "time_updated", time_updated)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Updatable) The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment in which the resource is created.
        """
        return pulumi.get(self, "compartment_id")

    @compartment_id.setter
    def compartment_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "compartment_id", value)

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        """
        return pulumi.get(self, "defined_tags")

    @defined_tags.setter
    def defined_tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "defined_tags", value)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Updatable) A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.  Example: `My new resource`
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter
    def endpoint(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The endpoint to access this deployment on the gateway.
        """
        return pulumi.get(self, "endpoint")

    @endpoint.setter
    def endpoint(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "endpoint", value)

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        (Updatable) Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        """
        return pulumi.get(self, "freeform_tags")

    @freeform_tags.setter
    def freeform_tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "freeform_tags", value)

    @property
    @pulumi.getter(name="gatewayId")
    def gateway_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the resource.
        """
        return pulumi.get(self, "gateway_id")

    @gateway_id.setter
    def gateway_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "gateway_id", value)

    @property
    @pulumi.getter(name="lifecycleDetails")
    def lifecycle_details(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        A message describing the current state in more detail. For example, can be used to provide actionable information for a resource in a Failed state.
        """
        return pulumi.get(self, "lifecycle_details")

    @lifecycle_details.setter
    def lifecycle_details(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "lifecycle_details", value)

    @property
    @pulumi.getter(name="pathPrefix")
    def path_prefix(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        A path on which to deploy all routes contained in the API deployment specification. For more information, see [Deploying an API on an API Gateway by Creating an API Deployment](https://docs.cloud.oracle.com/iaas/Content/APIGateway/Tasks/apigatewaycreatingdeployment.htm).
        """
        return pulumi.get(self, "path_prefix")

    @path_prefix.setter
    def path_prefix(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "path_prefix", value)

    @property
    @pulumi.getter
    def specification(self) -> Optional[pulumi.Input['DeploymentSpecificationArgs']]:
        """
        (Updatable) The logical configuration of the API exposed by a deployment.
        """
        return pulumi.get(self, "specification")

    @specification.setter
    def specification(self, value: Optional[pulumi.Input['DeploymentSpecificationArgs']]):
        pulumi.set(self, "specification", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The current state of the deployment.
        """
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "state", value)

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The time this resource was created. An RFC3339 formatted datetime string.
        """
        return pulumi.get(self, "time_created")

    @time_created.setter
    def time_created(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "time_created", value)

    @property
    @pulumi.getter(name="timeUpdated")
    def time_updated(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The time this resource was last updated. An RFC3339 formatted datetime string.
        """
        return pulumi.get(self, "time_updated")

    @time_updated.setter
    def time_updated(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "time_updated", value)


@pulumi.type_token("oci:ApiGateway/deployment:Deployment")
class Deployment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 defined_tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 display_name: Optional[pulumi.Input[builtins.str]] = None,
                 freeform_tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 gateway_id: Optional[pulumi.Input[builtins.str]] = None,
                 path_prefix: Optional[pulumi.Input[builtins.str]] = None,
                 specification: Optional[pulumi.Input[Union['DeploymentSpecificationArgs', 'DeploymentSpecificationArgsDict']]] = None,
                 __props__=None):
        """
        This resource provides the Deployment resource in Oracle Cloud Infrastructure API Gateway service.

        Creates a new deployment.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_deployment = oci.api_gateway.Deployment("test_deployment",
            compartment_id=compartment_id,
            gateway_id=test_gateway["id"],
            path_prefix=deployment_path_prefix,
            specification={
                "logging_policies": {
                    "access_log": {
                        "is_enabled": deployment_specification_logging_policies_access_log_is_enabled,
                    },
                    "execution_log": {
                        "is_enabled": deployment_specification_logging_policies_execution_log_is_enabled,
                        "log_level": deployment_specification_logging_policies_execution_log_log_level,
                    },
                },
                "request_policies": {
                    "authentication": {
                        "type": deployment_specification_request_policies_authentication_type,
                        "audiences": deployment_specification_request_policies_authentication_audiences,
                        "cache_keys": deployment_specification_request_policies_authentication_cache_key,
                        "function_id": test_function["id"],
                        "is_anonymous_access_allowed": deployment_specification_request_policies_authentication_is_anonymous_access_allowed,
                        "issuers": deployment_specification_request_policies_authentication_issuers,
                        "max_clock_skew_in_seconds": deployment_specification_request_policies_authentication_max_clock_skew_in_seconds,
                        "parameters": deployment_specification_request_policies_authentication_parameters,
                        "public_keys": {
                            "type": deployment_specification_request_policies_authentication_public_keys_type,
                            "is_ssl_verify_disabled": deployment_specification_request_policies_authentication_public_keys_is_ssl_verify_disabled,
                            "keys": [{
                                "format": deployment_specification_request_policies_authentication_public_keys_keys_format,
                                "alg": deployment_specification_request_policies_authentication_public_keys_keys_alg,
                                "e": deployment_specification_request_policies_authentication_public_keys_keys_e,
                                "key": deployment_specification_request_policies_authentication_public_keys_keys_key,
                                "key_ops": deployment_specification_request_policies_authentication_public_keys_keys_key_ops,
                                "kid": deployment_specification_request_policies_authentication_public_keys_keys_kid,
                                "kty": deployment_specification_request_policies_authentication_public_keys_keys_kty,
                                "n": deployment_specification_request_policies_authentication_public_keys_keys_n,
                                "use": deployment_specification_request_policies_authentication_public_keys_keys_use,
                            }],
                            "max_cache_duration_in_hours": deployment_specification_request_policies_authentication_public_keys_max_cache_duration_in_hours,
                            "uri": deployment_specification_request_policies_authentication_public_keys_uri,
                        },
                        "token_auth_scheme": deployment_specification_request_policies_authentication_token_auth_scheme,
                        "token_header": deployment_specification_request_policies_authentication_token_header,
                        "token_query_param": deployment_specification_request_policies_authentication_token_query_param,
                        "validation_failure_policy": {
                            "type": deployment_specification_request_policies_authentication_validation_failure_policy_type,
                            "client_details": {
                                "type": deployment_specification_request_policies_authentication_validation_failure_policy_client_details_type,
                                "client_id": test_client["id"],
                                "client_secret_id": test_secret["id"],
                                "client_secret_version_number": deployment_specification_request_policies_authentication_validation_failure_policy_client_details_client_secret_version_number,
                            },
                            "fallback_redirect_path": deployment_specification_request_policies_authentication_validation_failure_policy_fallback_redirect_path,
                            "logout_path": deployment_specification_request_policies_authentication_validation_failure_policy_logout_path,
                            "max_expiry_duration_in_hours": deployment_specification_request_policies_authentication_validation_failure_policy_max_expiry_duration_in_hours,
                            "response_code": deployment_specification_request_policies_authentication_validation_failure_policy_response_code,
                            "response_header_transformations": {
                                "filter_headers": {
                                    "items": [{
                                        "name": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_filter_headers_items_name,
                                    }],
                                    "type": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_filter_headers_type,
                                },
                                "rename_headers": {
                                    "items": [{
                                        "from_": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_rename_headers_items_from,
                                        "to": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_rename_headers_items_to,
                                    }],
                                },
                                "set_headers": {
                                    "items": [{
                                        "if_exists": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_set_headers_items_if_exists,
                                        "name": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_set_headers_items_name,
                                        "values": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_set_headers_items_values,
                                    }],
                                },
                            },
                            "response_message": deployment_specification_request_policies_authentication_validation_failure_policy_response_message,
                            "response_type": deployment_specification_request_policies_authentication_validation_failure_policy_response_type,
                            "scopes": deployment_specification_request_policies_authentication_validation_failure_policy_scopes,
                            "source_uri_details": {
                                "type": deployment_specification_request_policies_authentication_validation_failure_policy_source_uri_details_type,
                                "uri": deployment_specification_request_policies_authentication_validation_failure_policy_source_uri_details_uri,
                            },
                            "use_cookies_for_intermediate_steps": deployment_specification_request_policies_authentication_validation_failure_policy_use_cookies_for_intermediate_steps,
                            "use_cookies_for_session": deployment_specification_request_policies_authentication_validation_failure_policy_use_cookies_for_session,
                            "use_pkce": deployment_specification_request_policies_authentication_validation_failure_policy_use_pkce,
                        },
                        "validation_policy": {
                            "type": deployment_specification_request_policies_authentication_validation_policy_type,
                            "additional_validation_policy": {
                                "audiences": deployment_specification_request_policies_authentication_validation_policy_additional_validation_policy_audiences,
                                "issuers": deployment_specification_request_policies_authentication_validation_policy_additional_validation_policy_issuers,
                                "verify_claims": [{
                                    "is_required": deployment_specification_request_policies_authentication_validation_policy_additional_validation_policy_verify_claims_is_required,
                                    "key": deployment_specification_request_policies_authentication_validation_policy_additional_validation_policy_verify_claims_key,
                                    "values": deployment_specification_request_policies_authentication_validation_policy_additional_validation_policy_verify_claims_values,
                                }],
                            },
                            "client_details": {
                                "type": deployment_specification_request_policies_authentication_validation_policy_client_details_type,
                                "client_id": test_client["id"],
                                "client_secret_id": test_secret["id"],
                                "client_secret_version_number": deployment_specification_request_policies_authentication_validation_policy_client_details_client_secret_version_number,
                            },
                            "is_ssl_verify_disabled": deployment_specification_request_policies_authentication_validation_policy_is_ssl_verify_disabled,
                            "keys": [{
                                "format": deployment_specification_request_policies_authentication_validation_policy_keys_format,
                                "alg": deployment_specification_request_policies_authentication_validation_policy_keys_alg,
                                "e": deployment_specification_request_policies_authentication_validation_policy_keys_e,
                                "key": deployment_specification_request_policies_authentication_validation_policy_keys_key,
                                "key_ops": deployment_specification_request_policies_authentication_validation_policy_keys_key_ops,
                                "kid": deployment_specification_request_policies_authentication_validation_policy_keys_kid,
                                "kty": deployment_specification_request_policies_authentication_validation_policy_keys_kty,
                                "n": deployment_specification_request_policies_authentication_validation_policy_keys_n,
                                "use": deployment_specification_request_policies_authentication_validation_policy_keys_use,
                            }],
                            "max_cache_duration_in_hours": deployment_specification_request_policies_authentication_validation_policy_max_cache_duration_in_hours,
                            "source_uri_details": {
                                "type": deployment_specification_request_policies_authentication_validation_policy_source_uri_details_type,
                                "uri": deployment_specification_request_policies_authentication_validation_policy_source_uri_details_uri,
                            },
                            "uri": deployment_specification_request_policies_authentication_validation_policy_uri,
                        },
                        "verify_claims": [{
                            "is_required": deployment_specification_request_policies_authentication_verify_claims_is_required,
                            "key": deployment_specification_request_policies_authentication_verify_claims_key,
                            "values": deployment_specification_request_policies_authentication_verify_claims_values,
                        }],
                    },
                    "cors": {
                        "allowed_origins": deployment_specification_request_policies_cors_allowed_origins,
                        "allowed_headers": deployment_specification_request_policies_cors_allowed_headers,
                        "allowed_methods": deployment_specification_request_policies_cors_allowed_methods,
                        "exposed_headers": deployment_specification_request_policies_cors_exposed_headers,
                        "is_allow_credentials_enabled": deployment_specification_request_policies_cors_is_allow_credentials_enabled,
                        "max_age_in_seconds": deployment_specification_request_policies_cors_max_age_in_seconds,
                    },
                    "dynamic_authentication": {
                        "authentication_servers": [{
                            "authentication_server_detail": {
                                "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_type,
                                "audiences": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_audiences,
                                "function_id": test_function["id"],
                                "is_anonymous_access_allowed": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_is_anonymous_access_allowed,
                                "issuers": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_issuers,
                                "max_clock_skew_in_seconds": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_max_clock_skew_in_seconds,
                                "public_keys": {
                                    "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_type,
                                    "is_ssl_verify_disabled": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_is_ssl_verify_disabled,
                                    "keys": [{
                                        "format": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_format,
                                        "alg": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_alg,
                                        "e": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_e,
                                        "key": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_key,
                                        "key_ops": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_key_ops,
                                        "kid": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_kid,
                                        "kty": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_kty,
                                        "n": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_n,
                                        "use": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_use,
                                    }],
                                    "max_cache_duration_in_hours": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_max_cache_duration_in_hours,
                                    "uri": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_uri,
                                },
                                "token_auth_scheme": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_token_auth_scheme,
                                "token_header": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_token_header,
                                "token_query_param": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_token_query_param,
                                "validation_failure_policy": {
                                    "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_type,
                                    "client_details": {
                                        "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_client_details_type,
                                        "client_id": test_client["id"],
                                        "client_secret_id": test_secret["id"],
                                        "client_secret_version_number": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_client_details_client_secret_version_number,
                                    },
                                    "fallback_redirect_path": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_fallback_redirect_path,
                                    "logout_path": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_logout_path,
                                    "max_expiry_duration_in_hours": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_max_expiry_duration_in_hours,
                                    "response_code": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_code,
                                    "response_header_transformations": {
                                        "filter_headers": {
                                            "items": [{
                                                "name": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_filter_headers_items_name,
                                            }],
                                            "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_filter_headers_type,
                                        },
                                        "rename_headers": {
                                            "items": [{
                                                "from_": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_rename_headers_items_from,
                                                "to": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_rename_headers_items_to,
                                            }],
                                        },
                                        "set_headers": {
                                            "items": [{
                                                "if_exists": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_set_headers_items_if_exists,
                                                "name": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_set_headers_items_name,
                                                "values": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_set_headers_items_values,
                                            }],
                                        },
                                    },
                                    "response_message": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_message,
                                    "response_type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_type,
                                    "scopes": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_scopes,
                                    "source_uri_details": {
                                        "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_source_uri_details_type,
                                        "uri": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_source_uri_details_uri,
                                    },
                                    "use_cookies_for_intermediate_steps": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_use_cookies_for_intermediate_steps,
                                    "use_cookies_for_session": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_use_cookies_for_session,
                                    "use_pkce": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_use_pkce,
                                },
                                "validation_policy": {
                                    "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_type,
                                    "additional_validation_policy": {
                                        "audiences": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_additional_validation_policy_audiences,
                                        "issuers": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_additional_validation_policy_issuers,
                                        "verify_claims": [{
                                            "is_required": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_additional_validation_policy_verify_claims_is_required,
                                            "key": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_additional_validation_policy_verify_claims_key,
                                            "values": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_additional_validation_policy_verify_claims_values,
                                        }],
                                    },
                                    "client_details": {
                                        "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_client_details_type,
                                        "client_id": test_client["id"],
                                        "client_secret_id": test_secret["id"],
                                        "client_secret_version_number": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_client_details_client_secret_version_number,
                                    },
                                    "is_ssl_verify_disabled": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_is_ssl_verify_disabled,
                                    "keys": [{
                                        "format": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_format,
                                        "alg": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_alg,
                                        "e": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_e,
                                        "key": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_key,
                                        "key_ops": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_key_ops,
                                        "kid": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_kid,
                                        "kty": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_kty,
                                        "n": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_n,
                                        "use": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_use,
                                    }],
                                    "max_cache_duration_in_hours": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_max_cache_duration_in_hours,
                                    "source_uri_details": {
                                        "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_source_uri_details_type,
                                        "uri": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_source_uri_details_uri,
                                    },
                                    "uri": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_uri,
                                },
                                "verify_claims": [{
                                    "is_required": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_verify_claims_is_required,
                                    "key": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_verify_claims_key,
                                    "values": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_verify_claims_values,
                                }],
                            },
                            "key": {
                                "name": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_name,
                                "expression": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_expression,
                                "is_default": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_is_default,
                                "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_type,
                                "values": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_values,
                            },
                        }],
                        "selection_source": {
                            "selector": deployment_specification_request_policies_dynamic_authentication_selection_source_selector,
                            "type": deployment_specification_request_policies_dynamic_authentication_selection_source_type,
                        },
                    },
                    "mutual_tls": {
                        "allowed_sans": deployment_specification_request_policies_mutual_tls_allowed_sans,
                        "is_verified_certificate_required": deployment_specification_request_policies_mutual_tls_is_verified_certificate_required,
                    },
                    "rate_limiting": {
                        "rate_in_requests_per_second": deployment_specification_request_policies_rate_limiting_rate_in_requests_per_second,
                        "rate_key": deployment_specification_request_policies_rate_limiting_rate_key,
                    },
                    "usage_plans": {
                        "token_locations": deployment_specification_request_policies_usage_plans_token_locations,
                    },
                },
                "routes": [{
                    "backend": {
                        "type": deployment_specification_routes_backend_type,
                        "allowed_post_logout_uris": deployment_specification_routes_backend_allowed_post_logout_uris,
                        "body": deployment_specification_routes_backend_body,
                        "connect_timeout_in_seconds": deployment_specification_routes_backend_connect_timeout_in_seconds,
                        "function_id": test_function["id"],
                        "headers": [{
                            "name": deployment_specification_routes_backend_headers_name,
                            "value": deployment_specification_routes_backend_headers_value,
                        }],
                        "is_ssl_verify_disabled": deployment_specification_routes_backend_is_ssl_verify_disabled,
                        "post_logout_state": deployment_specification_routes_backend_post_logout_state,
                        "read_timeout_in_seconds": deployment_specification_routes_backend_read_timeout_in_seconds,
                        "routing_backends": [{
                            "backend": {
                                "type": deployment_specification_routes_backend_routing_backends_backend_type,
                                "body": deployment_specification_routes_backend_routing_backends_backend_body,
                                "connect_timeout_in_seconds": deployment_specification_routes_backend_routing_backends_backend_connect_timeout_in_seconds,
                                "function_id": test_function["id"],
                                "headers": [{
                                    "name": deployment_specification_routes_backend_routing_backends_backend_headers_name,
                                    "value": deployment_specification_routes_backend_routing_backends_backend_headers_value,
                                }],
                                "is_ssl_verify_disabled": deployment_specification_routes_backend_routing_backends_backend_is_ssl_verify_disabled,
                                "read_timeout_in_seconds": deployment_specification_routes_backend_routing_backends_backend_read_timeout_in_seconds,
                                "send_timeout_in_seconds": deployment_specification_routes_backend_routing_backends_backend_send_timeout_in_seconds,
                                "status": deployment_specification_routes_backend_routing_backends_backend_status,
                                "url": deployment_specification_routes_backend_routing_backends_backend_url,
                            },
                            "key": {
                                "name": deployment_specification_routes_backend_routing_backends_key_name,
                                "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_type,
                                "expression": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_expression,
                                "is_default": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_is_default,
                                "values": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_values,
                            },
                        }],
                        "selection_source": {
                            "selector": deployment_specification_routes_backend_selection_source_selector,
                            "type": deployment_specification_routes_backend_selection_source_type,
                        },
                        "send_timeout_in_seconds": deployment_specification_routes_backend_send_timeout_in_seconds,
                        "status": deployment_specification_routes_backend_status,
                        "url": deployment_specification_routes_backend_url,
                    },
                    "path": deployment_specification_routes_path,
                    "logging_policies": {
                        "access_log": {
                            "is_enabled": deployment_specification_routes_logging_policies_access_log_is_enabled,
                        },
                        "execution_log": {
                            "is_enabled": deployment_specification_routes_logging_policies_execution_log_is_enabled,
                            "log_level": deployment_specification_routes_logging_policies_execution_log_log_level,
                        },
                    },
                    "methods": deployment_specification_routes_methods,
                    "request_policies": {
                        "authorization": {
                            "allowed_scopes": deployment_specification_routes_request_policies_authorization_allowed_scope,
                            "type": deployment_specification_routes_request_policies_authorization_type,
                        },
                        "body_validation": {
                            "contents": [{
                                "media_type": deployment_specification_routes_request_policies_body_validation_content_media_type,
                                "validation_type": deployment_specification_routes_request_policies_body_validation_content_validation_type,
                            }],
                            "required": deployment_specification_routes_request_policies_body_validation_required,
                            "validation_mode": deployment_specification_routes_request_policies_body_validation_validation_mode,
                        },
                        "cors": {
                            "allowed_origins": deployment_specification_routes_request_policies_cors_allowed_origins,
                            "allowed_headers": deployment_specification_routes_request_policies_cors_allowed_headers,
                            "allowed_methods": deployment_specification_routes_request_policies_cors_allowed_methods,
                            "exposed_headers": deployment_specification_routes_request_policies_cors_exposed_headers,
                            "is_allow_credentials_enabled": deployment_specification_routes_request_policies_cors_is_allow_credentials_enabled,
                            "max_age_in_seconds": deployment_specification_routes_request_policies_cors_max_age_in_seconds,
                        },
                        "header_transformations": {
                            "filter_headers": {
                                "items": [{
                                    "name": deployment_specification_routes_request_policies_header_transformations_filter_headers_items_name,
                                }],
                                "type": deployment_specification_routes_request_policies_header_transformations_filter_headers_type,
                            },
                            "rename_headers": {
                                "items": [{
                                    "from_": deployment_specification_routes_request_policies_header_transformations_rename_headers_items_from,
                                    "to": deployment_specification_routes_request_policies_header_transformations_rename_headers_items_to,
                                }],
                            },
                            "set_headers": {
                                "items": [{
                                    "name": deployment_specification_routes_request_policies_header_transformations_set_headers_items_name,
                                    "values": deployment_specification_routes_request_policies_header_transformations_set_headers_items_values,
                                    "if_exists": deployment_specification_routes_request_policies_header_transformations_set_headers_items_if_exists,
                                }],
                            },
                        },
                        "header_validations": {
                            "headers": [{
                                "name": deployment_specification_routes_request_policies_header_validations_headers_name,
                                "required": deployment_specification_routes_request_policies_header_validations_headers_required,
                            }],
                            "validation_mode": deployment_specification_routes_request_policies_header_validations_validation_mode,
                        },
                        "query_parameter_transformations": {
                            "filter_query_parameters": {
                                "items": [{
                                    "name": deployment_specification_routes_request_policies_query_parameter_transformations_filter_query_parameters_items_name,
                                }],
                                "type": deployment_specification_routes_request_policies_query_parameter_transformations_filter_query_parameters_type,
                            },
                            "rename_query_parameters": {
                                "items": [{
                                    "from_": deployment_specification_routes_request_policies_query_parameter_transformations_rename_query_parameters_items_from,
                                    "to": deployment_specification_routes_request_policies_query_parameter_transformations_rename_query_parameters_items_to,
                                }],
                            },
                            "set_query_parameters": {
                                "items": [{
                                    "name": deployment_specification_routes_request_policies_query_parameter_transformations_set_query_parameters_items_name,
                                    "values": deployment_specification_routes_request_policies_query_parameter_transformations_set_query_parameters_items_values,
                                    "if_exists": deployment_specification_routes_request_policies_query_parameter_transformations_set_query_parameters_items_if_exists,
                                }],
                            },
                        },
                        "query_parameter_validations": {
                            "parameters": [{
                                "name": deployment_specification_routes_request_policies_query_parameter_validations_parameters_name,
                                "required": deployment_specification_routes_request_policies_query_parameter_validations_parameters_required,
                            }],
                            "validation_mode": deployment_specification_routes_request_policies_query_parameter_validations_validation_mode,
                        },
                        "response_cache_lookup": {
                            "type": deployment_specification_routes_request_policies_response_cache_lookup_type,
                            "cache_key_additions": deployment_specification_routes_request_policies_response_cache_lookup_cache_key_additions,
                            "is_enabled": deployment_specification_routes_request_policies_response_cache_lookup_is_enabled,
                            "is_private_caching_enabled": deployment_specification_routes_request_policies_response_cache_lookup_is_private_caching_enabled,
                        },
                    },
                    "response_policies": {
                        "header_transformations": {
                            "filter_headers": {
                                "items": [{
                                    "name": deployment_specification_routes_response_policies_header_transformations_filter_headers_items_name,
                                }],
                                "type": deployment_specification_routes_response_policies_header_transformations_filter_headers_type,
                            },
                            "rename_headers": {
                                "items": [{
                                    "from_": deployment_specification_routes_response_policies_header_transformations_rename_headers_items_from,
                                    "to": deployment_specification_routes_response_policies_header_transformations_rename_headers_items_to,
                                }],
                            },
                            "set_headers": {
                                "items": [{
                                    "name": deployment_specification_routes_response_policies_header_transformations_set_headers_items_name,
                                    "values": deployment_specification_routes_response_policies_header_transformations_set_headers_items_values,
                                    "if_exists": deployment_specification_routes_response_policies_header_transformations_set_headers_items_if_exists,
                                }],
                            },
                        },
                        "response_cache_store": {
                            "time_to_live_in_seconds": deployment_specification_routes_response_policies_response_cache_store_time_to_live_in_seconds,
                            "type": deployment_specification_routes_response_policies_response_cache_store_type,
                        },
                    },
                }],
            },
            defined_tags={
                "Operations.CostCenter": "42",
            },
            display_name=deployment_display_name,
            freeform_tags={
                "Department": "Finance",
            })
        ```

        ## Import

        Deployments can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:ApiGateway/deployment:Deployment test_deployment "id"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] compartment_id: (Updatable) The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment in which the resource is created.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] defined_tags: (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        :param pulumi.Input[builtins.str] display_name: (Updatable) A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.  Example: `My new resource`
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] freeform_tags: (Updatable) Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        :param pulumi.Input[builtins.str] gateway_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the resource.
        :param pulumi.Input[builtins.str] path_prefix: A path on which to deploy all routes contained in the API deployment specification. For more information, see [Deploying an API on an API Gateway by Creating an API Deployment](https://docs.cloud.oracle.com/iaas/Content/APIGateway/Tasks/apigatewaycreatingdeployment.htm).
        :param pulumi.Input[Union['DeploymentSpecificationArgs', 'DeploymentSpecificationArgsDict']] specification: (Updatable) The logical configuration of the API exposed by a deployment.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DeploymentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource provides the Deployment resource in Oracle Cloud Infrastructure API Gateway service.

        Creates a new deployment.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_deployment = oci.api_gateway.Deployment("test_deployment",
            compartment_id=compartment_id,
            gateway_id=test_gateway["id"],
            path_prefix=deployment_path_prefix,
            specification={
                "logging_policies": {
                    "access_log": {
                        "is_enabled": deployment_specification_logging_policies_access_log_is_enabled,
                    },
                    "execution_log": {
                        "is_enabled": deployment_specification_logging_policies_execution_log_is_enabled,
                        "log_level": deployment_specification_logging_policies_execution_log_log_level,
                    },
                },
                "request_policies": {
                    "authentication": {
                        "type": deployment_specification_request_policies_authentication_type,
                        "audiences": deployment_specification_request_policies_authentication_audiences,
                        "cache_keys": deployment_specification_request_policies_authentication_cache_key,
                        "function_id": test_function["id"],
                        "is_anonymous_access_allowed": deployment_specification_request_policies_authentication_is_anonymous_access_allowed,
                        "issuers": deployment_specification_request_policies_authentication_issuers,
                        "max_clock_skew_in_seconds": deployment_specification_request_policies_authentication_max_clock_skew_in_seconds,
                        "parameters": deployment_specification_request_policies_authentication_parameters,
                        "public_keys": {
                            "type": deployment_specification_request_policies_authentication_public_keys_type,
                            "is_ssl_verify_disabled": deployment_specification_request_policies_authentication_public_keys_is_ssl_verify_disabled,
                            "keys": [{
                                "format": deployment_specification_request_policies_authentication_public_keys_keys_format,
                                "alg": deployment_specification_request_policies_authentication_public_keys_keys_alg,
                                "e": deployment_specification_request_policies_authentication_public_keys_keys_e,
                                "key": deployment_specification_request_policies_authentication_public_keys_keys_key,
                                "key_ops": deployment_specification_request_policies_authentication_public_keys_keys_key_ops,
                                "kid": deployment_specification_request_policies_authentication_public_keys_keys_kid,
                                "kty": deployment_specification_request_policies_authentication_public_keys_keys_kty,
                                "n": deployment_specification_request_policies_authentication_public_keys_keys_n,
                                "use": deployment_specification_request_policies_authentication_public_keys_keys_use,
                            }],
                            "max_cache_duration_in_hours": deployment_specification_request_policies_authentication_public_keys_max_cache_duration_in_hours,
                            "uri": deployment_specification_request_policies_authentication_public_keys_uri,
                        },
                        "token_auth_scheme": deployment_specification_request_policies_authentication_token_auth_scheme,
                        "token_header": deployment_specification_request_policies_authentication_token_header,
                        "token_query_param": deployment_specification_request_policies_authentication_token_query_param,
                        "validation_failure_policy": {
                            "type": deployment_specification_request_policies_authentication_validation_failure_policy_type,
                            "client_details": {
                                "type": deployment_specification_request_policies_authentication_validation_failure_policy_client_details_type,
                                "client_id": test_client["id"],
                                "client_secret_id": test_secret["id"],
                                "client_secret_version_number": deployment_specification_request_policies_authentication_validation_failure_policy_client_details_client_secret_version_number,
                            },
                            "fallback_redirect_path": deployment_specification_request_policies_authentication_validation_failure_policy_fallback_redirect_path,
                            "logout_path": deployment_specification_request_policies_authentication_validation_failure_policy_logout_path,
                            "max_expiry_duration_in_hours": deployment_specification_request_policies_authentication_validation_failure_policy_max_expiry_duration_in_hours,
                            "response_code": deployment_specification_request_policies_authentication_validation_failure_policy_response_code,
                            "response_header_transformations": {
                                "filter_headers": {
                                    "items": [{
                                        "name": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_filter_headers_items_name,
                                    }],
                                    "type": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_filter_headers_type,
                                },
                                "rename_headers": {
                                    "items": [{
                                        "from_": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_rename_headers_items_from,
                                        "to": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_rename_headers_items_to,
                                    }],
                                },
                                "set_headers": {
                                    "items": [{
                                        "if_exists": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_set_headers_items_if_exists,
                                        "name": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_set_headers_items_name,
                                        "values": deployment_specification_request_policies_authentication_validation_failure_policy_response_header_transformations_set_headers_items_values,
                                    }],
                                },
                            },
                            "response_message": deployment_specification_request_policies_authentication_validation_failure_policy_response_message,
                            "response_type": deployment_specification_request_policies_authentication_validation_failure_policy_response_type,
                            "scopes": deployment_specification_request_policies_authentication_validation_failure_policy_scopes,
                            "source_uri_details": {
                                "type": deployment_specification_request_policies_authentication_validation_failure_policy_source_uri_details_type,
                                "uri": deployment_specification_request_policies_authentication_validation_failure_policy_source_uri_details_uri,
                            },
                            "use_cookies_for_intermediate_steps": deployment_specification_request_policies_authentication_validation_failure_policy_use_cookies_for_intermediate_steps,
                            "use_cookies_for_session": deployment_specification_request_policies_authentication_validation_failure_policy_use_cookies_for_session,
                            "use_pkce": deployment_specification_request_policies_authentication_validation_failure_policy_use_pkce,
                        },
                        "validation_policy": {
                            "type": deployment_specification_request_policies_authentication_validation_policy_type,
                            "additional_validation_policy": {
                                "audiences": deployment_specification_request_policies_authentication_validation_policy_additional_validation_policy_audiences,
                                "issuers": deployment_specification_request_policies_authentication_validation_policy_additional_validation_policy_issuers,
                                "verify_claims": [{
                                    "is_required": deployment_specification_request_policies_authentication_validation_policy_additional_validation_policy_verify_claims_is_required,
                                    "key": deployment_specification_request_policies_authentication_validation_policy_additional_validation_policy_verify_claims_key,
                                    "values": deployment_specification_request_policies_authentication_validation_policy_additional_validation_policy_verify_claims_values,
                                }],
                            },
                            "client_details": {
                                "type": deployment_specification_request_policies_authentication_validation_policy_client_details_type,
                                "client_id": test_client["id"],
                                "client_secret_id": test_secret["id"],
                                "client_secret_version_number": deployment_specification_request_policies_authentication_validation_policy_client_details_client_secret_version_number,
                            },
                            "is_ssl_verify_disabled": deployment_specification_request_policies_authentication_validation_policy_is_ssl_verify_disabled,
                            "keys": [{
                                "format": deployment_specification_request_policies_authentication_validation_policy_keys_format,
                                "alg": deployment_specification_request_policies_authentication_validation_policy_keys_alg,
                                "e": deployment_specification_request_policies_authentication_validation_policy_keys_e,
                                "key": deployment_specification_request_policies_authentication_validation_policy_keys_key,
                                "key_ops": deployment_specification_request_policies_authentication_validation_policy_keys_key_ops,
                                "kid": deployment_specification_request_policies_authentication_validation_policy_keys_kid,
                                "kty": deployment_specification_request_policies_authentication_validation_policy_keys_kty,
                                "n": deployment_specification_request_policies_authentication_validation_policy_keys_n,
                                "use": deployment_specification_request_policies_authentication_validation_policy_keys_use,
                            }],
                            "max_cache_duration_in_hours": deployment_specification_request_policies_authentication_validation_policy_max_cache_duration_in_hours,
                            "source_uri_details": {
                                "type": deployment_specification_request_policies_authentication_validation_policy_source_uri_details_type,
                                "uri": deployment_specification_request_policies_authentication_validation_policy_source_uri_details_uri,
                            },
                            "uri": deployment_specification_request_policies_authentication_validation_policy_uri,
                        },
                        "verify_claims": [{
                            "is_required": deployment_specification_request_policies_authentication_verify_claims_is_required,
                            "key": deployment_specification_request_policies_authentication_verify_claims_key,
                            "values": deployment_specification_request_policies_authentication_verify_claims_values,
                        }],
                    },
                    "cors": {
                        "allowed_origins": deployment_specification_request_policies_cors_allowed_origins,
                        "allowed_headers": deployment_specification_request_policies_cors_allowed_headers,
                        "allowed_methods": deployment_specification_request_policies_cors_allowed_methods,
                        "exposed_headers": deployment_specification_request_policies_cors_exposed_headers,
                        "is_allow_credentials_enabled": deployment_specification_request_policies_cors_is_allow_credentials_enabled,
                        "max_age_in_seconds": deployment_specification_request_policies_cors_max_age_in_seconds,
                    },
                    "dynamic_authentication": {
                        "authentication_servers": [{
                            "authentication_server_detail": {
                                "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_type,
                                "audiences": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_audiences,
                                "function_id": test_function["id"],
                                "is_anonymous_access_allowed": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_is_anonymous_access_allowed,
                                "issuers": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_issuers,
                                "max_clock_skew_in_seconds": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_max_clock_skew_in_seconds,
                                "public_keys": {
                                    "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_type,
                                    "is_ssl_verify_disabled": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_is_ssl_verify_disabled,
                                    "keys": [{
                                        "format": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_format,
                                        "alg": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_alg,
                                        "e": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_e,
                                        "key": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_key,
                                        "key_ops": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_key_ops,
                                        "kid": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_kid,
                                        "kty": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_kty,
                                        "n": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_n,
                                        "use": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_keys_use,
                                    }],
                                    "max_cache_duration_in_hours": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_max_cache_duration_in_hours,
                                    "uri": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_public_keys_uri,
                                },
                                "token_auth_scheme": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_token_auth_scheme,
                                "token_header": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_token_header,
                                "token_query_param": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_token_query_param,
                                "validation_failure_policy": {
                                    "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_type,
                                    "client_details": {
                                        "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_client_details_type,
                                        "client_id": test_client["id"],
                                        "client_secret_id": test_secret["id"],
                                        "client_secret_version_number": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_client_details_client_secret_version_number,
                                    },
                                    "fallback_redirect_path": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_fallback_redirect_path,
                                    "logout_path": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_logout_path,
                                    "max_expiry_duration_in_hours": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_max_expiry_duration_in_hours,
                                    "response_code": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_code,
                                    "response_header_transformations": {
                                        "filter_headers": {
                                            "items": [{
                                                "name": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_filter_headers_items_name,
                                            }],
                                            "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_filter_headers_type,
                                        },
                                        "rename_headers": {
                                            "items": [{
                                                "from_": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_rename_headers_items_from,
                                                "to": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_rename_headers_items_to,
                                            }],
                                        },
                                        "set_headers": {
                                            "items": [{
                                                "if_exists": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_set_headers_items_if_exists,
                                                "name": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_set_headers_items_name,
                                                "values": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_header_transformations_set_headers_items_values,
                                            }],
                                        },
                                    },
                                    "response_message": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_message,
                                    "response_type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_response_type,
                                    "scopes": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_scopes,
                                    "source_uri_details": {
                                        "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_source_uri_details_type,
                                        "uri": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_source_uri_details_uri,
                                    },
                                    "use_cookies_for_intermediate_steps": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_use_cookies_for_intermediate_steps,
                                    "use_cookies_for_session": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_use_cookies_for_session,
                                    "use_pkce": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_failure_policy_use_pkce,
                                },
                                "validation_policy": {
                                    "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_type,
                                    "additional_validation_policy": {
                                        "audiences": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_additional_validation_policy_audiences,
                                        "issuers": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_additional_validation_policy_issuers,
                                        "verify_claims": [{
                                            "is_required": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_additional_validation_policy_verify_claims_is_required,
                                            "key": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_additional_validation_policy_verify_claims_key,
                                            "values": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_additional_validation_policy_verify_claims_values,
                                        }],
                                    },
                                    "client_details": {
                                        "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_client_details_type,
                                        "client_id": test_client["id"],
                                        "client_secret_id": test_secret["id"],
                                        "client_secret_version_number": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_client_details_client_secret_version_number,
                                    },
                                    "is_ssl_verify_disabled": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_is_ssl_verify_disabled,
                                    "keys": [{
                                        "format": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_format,
                                        "alg": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_alg,
                                        "e": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_e,
                                        "key": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_key,
                                        "key_ops": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_key_ops,
                                        "kid": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_kid,
                                        "kty": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_kty,
                                        "n": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_n,
                                        "use": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_keys_use,
                                    }],
                                    "max_cache_duration_in_hours": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_max_cache_duration_in_hours,
                                    "source_uri_details": {
                                        "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_source_uri_details_type,
                                        "uri": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_source_uri_details_uri,
                                    },
                                    "uri": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_validation_policy_uri,
                                },
                                "verify_claims": [{
                                    "is_required": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_verify_claims_is_required,
                                    "key": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_verify_claims_key,
                                    "values": deployment_specification_request_policies_dynamic_authentication_authentication_servers_authentication_server_detail_verify_claims_values,
                                }],
                            },
                            "key": {
                                "name": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_name,
                                "expression": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_expression,
                                "is_default": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_is_default,
                                "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_type,
                                "values": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_values,
                            },
                        }],
                        "selection_source": {
                            "selector": deployment_specification_request_policies_dynamic_authentication_selection_source_selector,
                            "type": deployment_specification_request_policies_dynamic_authentication_selection_source_type,
                        },
                    },
                    "mutual_tls": {
                        "allowed_sans": deployment_specification_request_policies_mutual_tls_allowed_sans,
                        "is_verified_certificate_required": deployment_specification_request_policies_mutual_tls_is_verified_certificate_required,
                    },
                    "rate_limiting": {
                        "rate_in_requests_per_second": deployment_specification_request_policies_rate_limiting_rate_in_requests_per_second,
                        "rate_key": deployment_specification_request_policies_rate_limiting_rate_key,
                    },
                    "usage_plans": {
                        "token_locations": deployment_specification_request_policies_usage_plans_token_locations,
                    },
                },
                "routes": [{
                    "backend": {
                        "type": deployment_specification_routes_backend_type,
                        "allowed_post_logout_uris": deployment_specification_routes_backend_allowed_post_logout_uris,
                        "body": deployment_specification_routes_backend_body,
                        "connect_timeout_in_seconds": deployment_specification_routes_backend_connect_timeout_in_seconds,
                        "function_id": test_function["id"],
                        "headers": [{
                            "name": deployment_specification_routes_backend_headers_name,
                            "value": deployment_specification_routes_backend_headers_value,
                        }],
                        "is_ssl_verify_disabled": deployment_specification_routes_backend_is_ssl_verify_disabled,
                        "post_logout_state": deployment_specification_routes_backend_post_logout_state,
                        "read_timeout_in_seconds": deployment_specification_routes_backend_read_timeout_in_seconds,
                        "routing_backends": [{
                            "backend": {
                                "type": deployment_specification_routes_backend_routing_backends_backend_type,
                                "body": deployment_specification_routes_backend_routing_backends_backend_body,
                                "connect_timeout_in_seconds": deployment_specification_routes_backend_routing_backends_backend_connect_timeout_in_seconds,
                                "function_id": test_function["id"],
                                "headers": [{
                                    "name": deployment_specification_routes_backend_routing_backends_backend_headers_name,
                                    "value": deployment_specification_routes_backend_routing_backends_backend_headers_value,
                                }],
                                "is_ssl_verify_disabled": deployment_specification_routes_backend_routing_backends_backend_is_ssl_verify_disabled,
                                "read_timeout_in_seconds": deployment_specification_routes_backend_routing_backends_backend_read_timeout_in_seconds,
                                "send_timeout_in_seconds": deployment_specification_routes_backend_routing_backends_backend_send_timeout_in_seconds,
                                "status": deployment_specification_routes_backend_routing_backends_backend_status,
                                "url": deployment_specification_routes_backend_routing_backends_backend_url,
                            },
                            "key": {
                                "name": deployment_specification_routes_backend_routing_backends_key_name,
                                "type": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_type,
                                "expression": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_expression,
                                "is_default": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_is_default,
                                "values": deployment_specification_request_policies_dynamic_authentication_authentication_servers_key_values,
                            },
                        }],
                        "selection_source": {
                            "selector": deployment_specification_routes_backend_selection_source_selector,
                            "type": deployment_specification_routes_backend_selection_source_type,
                        },
                        "send_timeout_in_seconds": deployment_specification_routes_backend_send_timeout_in_seconds,
                        "status": deployment_specification_routes_backend_status,
                        "url": deployment_specification_routes_backend_url,
                    },
                    "path": deployment_specification_routes_path,
                    "logging_policies": {
                        "access_log": {
                            "is_enabled": deployment_specification_routes_logging_policies_access_log_is_enabled,
                        },
                        "execution_log": {
                            "is_enabled": deployment_specification_routes_logging_policies_execution_log_is_enabled,
                            "log_level": deployment_specification_routes_logging_policies_execution_log_log_level,
                        },
                    },
                    "methods": deployment_specification_routes_methods,
                    "request_policies": {
                        "authorization": {
                            "allowed_scopes": deployment_specification_routes_request_policies_authorization_allowed_scope,
                            "type": deployment_specification_routes_request_policies_authorization_type,
                        },
                        "body_validation": {
                            "contents": [{
                                "media_type": deployment_specification_routes_request_policies_body_validation_content_media_type,
                                "validation_type": deployment_specification_routes_request_policies_body_validation_content_validation_type,
                            }],
                            "required": deployment_specification_routes_request_policies_body_validation_required,
                            "validation_mode": deployment_specification_routes_request_policies_body_validation_validation_mode,
                        },
                        "cors": {
                            "allowed_origins": deployment_specification_routes_request_policies_cors_allowed_origins,
                            "allowed_headers": deployment_specification_routes_request_policies_cors_allowed_headers,
                            "allowed_methods": deployment_specification_routes_request_policies_cors_allowed_methods,
                            "exposed_headers": deployment_specification_routes_request_policies_cors_exposed_headers,
                            "is_allow_credentials_enabled": deployment_specification_routes_request_policies_cors_is_allow_credentials_enabled,
                            "max_age_in_seconds": deployment_specification_routes_request_policies_cors_max_age_in_seconds,
                        },
                        "header_transformations": {
                            "filter_headers": {
                                "items": [{
                                    "name": deployment_specification_routes_request_policies_header_transformations_filter_headers_items_name,
                                }],
                                "type": deployment_specification_routes_request_policies_header_transformations_filter_headers_type,
                            },
                            "rename_headers": {
                                "items": [{
                                    "from_": deployment_specification_routes_request_policies_header_transformations_rename_headers_items_from,
                                    "to": deployment_specification_routes_request_policies_header_transformations_rename_headers_items_to,
                                }],
                            },
                            "set_headers": {
                                "items": [{
                                    "name": deployment_specification_routes_request_policies_header_transformations_set_headers_items_name,
                                    "values": deployment_specification_routes_request_policies_header_transformations_set_headers_items_values,
                                    "if_exists": deployment_specification_routes_request_policies_header_transformations_set_headers_items_if_exists,
                                }],
                            },
                        },
                        "header_validations": {
                            "headers": [{
                                "name": deployment_specification_routes_request_policies_header_validations_headers_name,
                                "required": deployment_specification_routes_request_policies_header_validations_headers_required,
                            }],
                            "validation_mode": deployment_specification_routes_request_policies_header_validations_validation_mode,
                        },
                        "query_parameter_transformations": {
                            "filter_query_parameters": {
                                "items": [{
                                    "name": deployment_specification_routes_request_policies_query_parameter_transformations_filter_query_parameters_items_name,
                                }],
                                "type": deployment_specification_routes_request_policies_query_parameter_transformations_filter_query_parameters_type,
                            },
                            "rename_query_parameters": {
                                "items": [{
                                    "from_": deployment_specification_routes_request_policies_query_parameter_transformations_rename_query_parameters_items_from,
                                    "to": deployment_specification_routes_request_policies_query_parameter_transformations_rename_query_parameters_items_to,
                                }],
                            },
                            "set_query_parameters": {
                                "items": [{
                                    "name": deployment_specification_routes_request_policies_query_parameter_transformations_set_query_parameters_items_name,
                                    "values": deployment_specification_routes_request_policies_query_parameter_transformations_set_query_parameters_items_values,
                                    "if_exists": deployment_specification_routes_request_policies_query_parameter_transformations_set_query_parameters_items_if_exists,
                                }],
                            },
                        },
                        "query_parameter_validations": {
                            "parameters": [{
                                "name": deployment_specification_routes_request_policies_query_parameter_validations_parameters_name,
                                "required": deployment_specification_routes_request_policies_query_parameter_validations_parameters_required,
                            }],
                            "validation_mode": deployment_specification_routes_request_policies_query_parameter_validations_validation_mode,
                        },
                        "response_cache_lookup": {
                            "type": deployment_specification_routes_request_policies_response_cache_lookup_type,
                            "cache_key_additions": deployment_specification_routes_request_policies_response_cache_lookup_cache_key_additions,
                            "is_enabled": deployment_specification_routes_request_policies_response_cache_lookup_is_enabled,
                            "is_private_caching_enabled": deployment_specification_routes_request_policies_response_cache_lookup_is_private_caching_enabled,
                        },
                    },
                    "response_policies": {
                        "header_transformations": {
                            "filter_headers": {
                                "items": [{
                                    "name": deployment_specification_routes_response_policies_header_transformations_filter_headers_items_name,
                                }],
                                "type": deployment_specification_routes_response_policies_header_transformations_filter_headers_type,
                            },
                            "rename_headers": {
                                "items": [{
                                    "from_": deployment_specification_routes_response_policies_header_transformations_rename_headers_items_from,
                                    "to": deployment_specification_routes_response_policies_header_transformations_rename_headers_items_to,
                                }],
                            },
                            "set_headers": {
                                "items": [{
                                    "name": deployment_specification_routes_response_policies_header_transformations_set_headers_items_name,
                                    "values": deployment_specification_routes_response_policies_header_transformations_set_headers_items_values,
                                    "if_exists": deployment_specification_routes_response_policies_header_transformations_set_headers_items_if_exists,
                                }],
                            },
                        },
                        "response_cache_store": {
                            "time_to_live_in_seconds": deployment_specification_routes_response_policies_response_cache_store_time_to_live_in_seconds,
                            "type": deployment_specification_routes_response_policies_response_cache_store_type,
                        },
                    },
                }],
            },
            defined_tags={
                "Operations.CostCenter": "42",
            },
            display_name=deployment_display_name,
            freeform_tags={
                "Department": "Finance",
            })
        ```

        ## Import

        Deployments can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:ApiGateway/deployment:Deployment test_deployment "id"
        ```

        :param str resource_name: The name of the resource.
        :param DeploymentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DeploymentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 defined_tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 display_name: Optional[pulumi.Input[builtins.str]] = None,
                 freeform_tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 gateway_id: Optional[pulumi.Input[builtins.str]] = None,
                 path_prefix: Optional[pulumi.Input[builtins.str]] = None,
                 specification: Optional[pulumi.Input[Union['DeploymentSpecificationArgs', 'DeploymentSpecificationArgsDict']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DeploymentArgs.__new__(DeploymentArgs)

            if compartment_id is None and not opts.urn:
                raise TypeError("Missing required property 'compartment_id'")
            __props__.__dict__["compartment_id"] = compartment_id
            __props__.__dict__["defined_tags"] = defined_tags
            __props__.__dict__["display_name"] = display_name
            __props__.__dict__["freeform_tags"] = freeform_tags
            if gateway_id is None and not opts.urn:
                raise TypeError("Missing required property 'gateway_id'")
            __props__.__dict__["gateway_id"] = gateway_id
            if path_prefix is None and not opts.urn:
                raise TypeError("Missing required property 'path_prefix'")
            __props__.__dict__["path_prefix"] = path_prefix
            if specification is None and not opts.urn:
                raise TypeError("Missing required property 'specification'")
            __props__.__dict__["specification"] = specification
            __props__.__dict__["endpoint"] = None
            __props__.__dict__["lifecycle_details"] = None
            __props__.__dict__["state"] = None
            __props__.__dict__["time_created"] = None
            __props__.__dict__["time_updated"] = None
        super(Deployment, __self__).__init__(
            'oci:ApiGateway/deployment:Deployment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            compartment_id: Optional[pulumi.Input[builtins.str]] = None,
            defined_tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
            display_name: Optional[pulumi.Input[builtins.str]] = None,
            endpoint: Optional[pulumi.Input[builtins.str]] = None,
            freeform_tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
            gateway_id: Optional[pulumi.Input[builtins.str]] = None,
            lifecycle_details: Optional[pulumi.Input[builtins.str]] = None,
            path_prefix: Optional[pulumi.Input[builtins.str]] = None,
            specification: Optional[pulumi.Input[Union['DeploymentSpecificationArgs', 'DeploymentSpecificationArgsDict']]] = None,
            state: Optional[pulumi.Input[builtins.str]] = None,
            time_created: Optional[pulumi.Input[builtins.str]] = None,
            time_updated: Optional[pulumi.Input[builtins.str]] = None) -> 'Deployment':
        """
        Get an existing Deployment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] compartment_id: (Updatable) The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment in which the resource is created.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] defined_tags: (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        :param pulumi.Input[builtins.str] display_name: (Updatable) A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.  Example: `My new resource`
        :param pulumi.Input[builtins.str] endpoint: The endpoint to access this deployment on the gateway.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] freeform_tags: (Updatable) Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        :param pulumi.Input[builtins.str] gateway_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the resource.
        :param pulumi.Input[builtins.str] lifecycle_details: A message describing the current state in more detail. For example, can be used to provide actionable information for a resource in a Failed state.
        :param pulumi.Input[builtins.str] path_prefix: A path on which to deploy all routes contained in the API deployment specification. For more information, see [Deploying an API on an API Gateway by Creating an API Deployment](https://docs.cloud.oracle.com/iaas/Content/APIGateway/Tasks/apigatewaycreatingdeployment.htm).
        :param pulumi.Input[Union['DeploymentSpecificationArgs', 'DeploymentSpecificationArgsDict']] specification: (Updatable) The logical configuration of the API exposed by a deployment.
        :param pulumi.Input[builtins.str] state: The current state of the deployment.
        :param pulumi.Input[builtins.str] time_created: The time this resource was created. An RFC3339 formatted datetime string.
        :param pulumi.Input[builtins.str] time_updated: The time this resource was last updated. An RFC3339 formatted datetime string.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DeploymentState.__new__(_DeploymentState)

        __props__.__dict__["compartment_id"] = compartment_id
        __props__.__dict__["defined_tags"] = defined_tags
        __props__.__dict__["display_name"] = display_name
        __props__.__dict__["endpoint"] = endpoint
        __props__.__dict__["freeform_tags"] = freeform_tags
        __props__.__dict__["gateway_id"] = gateway_id
        __props__.__dict__["lifecycle_details"] = lifecycle_details
        __props__.__dict__["path_prefix"] = path_prefix
        __props__.__dict__["specification"] = specification
        __props__.__dict__["state"] = state
        __props__.__dict__["time_created"] = time_created
        __props__.__dict__["time_updated"] = time_updated
        return Deployment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> pulumi.Output[builtins.str]:
        """
        (Updatable) The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment in which the resource is created.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> pulumi.Output[Mapping[str, builtins.str]]:
        """
        (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        """
        return pulumi.get(self, "defined_tags")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> pulumi.Output[builtins.str]:
        """
        (Updatable) A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.  Example: `My new resource`
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def endpoint(self) -> pulumi.Output[builtins.str]:
        """
        The endpoint to access this deployment on the gateway.
        """
        return pulumi.get(self, "endpoint")

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> pulumi.Output[Mapping[str, builtins.str]]:
        """
        (Updatable) Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        """
        return pulumi.get(self, "freeform_tags")

    @property
    @pulumi.getter(name="gatewayId")
    def gateway_id(self) -> pulumi.Output[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the resource.
        """
        return pulumi.get(self, "gateway_id")

    @property
    @pulumi.getter(name="lifecycleDetails")
    def lifecycle_details(self) -> pulumi.Output[builtins.str]:
        """
        A message describing the current state in more detail. For example, can be used to provide actionable information for a resource in a Failed state.
        """
        return pulumi.get(self, "lifecycle_details")

    @property
    @pulumi.getter(name="pathPrefix")
    def path_prefix(self) -> pulumi.Output[builtins.str]:
        """
        A path on which to deploy all routes contained in the API deployment specification. For more information, see [Deploying an API on an API Gateway by Creating an API Deployment](https://docs.cloud.oracle.com/iaas/Content/APIGateway/Tasks/apigatewaycreatingdeployment.htm).
        """
        return pulumi.get(self, "path_prefix")

    @property
    @pulumi.getter
    def specification(self) -> pulumi.Output['outputs.DeploymentSpecification']:
        """
        (Updatable) The logical configuration of the API exposed by a deployment.
        """
        return pulumi.get(self, "specification")

    @property
    @pulumi.getter
    def state(self) -> pulumi.Output[builtins.str]:
        """
        The current state of the deployment.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> pulumi.Output[builtins.str]:
        """
        The time this resource was created. An RFC3339 formatted datetime string.
        """
        return pulumi.get(self, "time_created")

    @property
    @pulumi.getter(name="timeUpdated")
    def time_updated(self) -> pulumi.Output[builtins.str]:
        """
        The time this resource was last updated. An RFC3339 formatted datetime string.
        """
        return pulumi.get(self, "time_updated")

