# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetCrossConnectGroupsResult',
    'AwaitableGetCrossConnectGroupsResult',
    'get_cross_connect_groups',
    'get_cross_connect_groups_output',
]

@pulumi.output_type
class GetCrossConnectGroupsResult:
    """
    A collection of values returned by getCrossConnectGroups.
    """
    def __init__(__self__, compartment_id=None, cross_connect_groups=None, display_name=None, filters=None, id=None, state=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if cross_connect_groups and not isinstance(cross_connect_groups, list):
            raise TypeError("Expected argument 'cross_connect_groups' to be a list")
        pulumi.set(__self__, "cross_connect_groups", cross_connect_groups)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment containing the cross-connect group.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="crossConnectGroups")
    def cross_connect_groups(self) -> Sequence['outputs.GetCrossConnectGroupsCrossConnectGroupResult']:
        """
        The list of cross_connect_groups.
        """
        return pulumi.get(self, "cross_connect_groups")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[builtins.str]:
        """
        A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetCrossConnectGroupsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def state(self) -> Optional[builtins.str]:
        """
        The cross-connect group's current state.
        """
        return pulumi.get(self, "state")


class AwaitableGetCrossConnectGroupsResult(GetCrossConnectGroupsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCrossConnectGroupsResult(
            compartment_id=self.compartment_id,
            cross_connect_groups=self.cross_connect_groups,
            display_name=self.display_name,
            filters=self.filters,
            id=self.id,
            state=self.state)


def get_cross_connect_groups(compartment_id: Optional[builtins.str] = None,
                             display_name: Optional[builtins.str] = None,
                             filters: Optional[Sequence[Union['GetCrossConnectGroupsFilterArgs', 'GetCrossConnectGroupsFilterArgsDict']]] = None,
                             state: Optional[builtins.str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCrossConnectGroupsResult:
    """
    This data source provides the list of Cross Connect Groups in Oracle Cloud Infrastructure Core service.

    Lists the cross-connect groups in the specified compartment.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_cross_connect_groups = oci.Core.get_cross_connect_groups(compartment_id=compartment_id,
        display_name=cross_connect_group_display_name,
        state=cross_connect_group_state)
    ```


    :param builtins.str compartment_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
    :param builtins.str display_name: A filter to return only resources that match the given display name exactly.
    :param builtins.str state: A filter to return only resources that match the specified lifecycle state. The value is case insensitive.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['state'] = state
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Core/getCrossConnectGroups:getCrossConnectGroups', __args__, opts=opts, typ=GetCrossConnectGroupsResult).value

    return AwaitableGetCrossConnectGroupsResult(
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        cross_connect_groups=pulumi.get(__ret__, 'cross_connect_groups'),
        display_name=pulumi.get(__ret__, 'display_name'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        state=pulumi.get(__ret__, 'state'))
def get_cross_connect_groups_output(compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                                    display_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                    filters: Optional[pulumi.Input[Optional[Sequence[Union['GetCrossConnectGroupsFilterArgs', 'GetCrossConnectGroupsFilterArgsDict']]]]] = None,
                                    state: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                    opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetCrossConnectGroupsResult]:
    """
    This data source provides the list of Cross Connect Groups in Oracle Cloud Infrastructure Core service.

    Lists the cross-connect groups in the specified compartment.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_cross_connect_groups = oci.Core.get_cross_connect_groups(compartment_id=compartment_id,
        display_name=cross_connect_group_display_name,
        state=cross_connect_group_state)
    ```


    :param builtins.str compartment_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
    :param builtins.str display_name: A filter to return only resources that match the given display name exactly.
    :param builtins.str state: A filter to return only resources that match the specified lifecycle state. The value is case insensitive.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['state'] = state
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Core/getCrossConnectGroups:getCrossConnectGroups', __args__, opts=opts, typ=GetCrossConnectGroupsResult)
    return __ret__.apply(lambda __response__: GetCrossConnectGroupsResult(
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        cross_connect_groups=pulumi.get(__response__, 'cross_connect_groups'),
        display_name=pulumi.get(__response__, 'display_name'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        state=pulumi.get(__response__, 'state')))
