# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetApplicationVipsResult',
    'AwaitableGetApplicationVipsResult',
    'get_application_vips',
    'get_application_vips_output',
]

@pulumi.output_type
class GetApplicationVipsResult:
    """
    A collection of values returned by getApplicationVips.
    """
    def __init__(__self__, application_vips=None, cloud_vm_cluster_id=None, compartment_id=None, filters=None, id=None, state=None):
        if application_vips and not isinstance(application_vips, list):
            raise TypeError("Expected argument 'application_vips' to be a list")
        pulumi.set(__self__, "application_vips", application_vips)
        if cloud_vm_cluster_id and not isinstance(cloud_vm_cluster_id, str):
            raise TypeError("Expected argument 'cloud_vm_cluster_id' to be a str")
        pulumi.set(__self__, "cloud_vm_cluster_id", cloud_vm_cluster_id)
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="applicationVips")
    def application_vips(self) -> Sequence['outputs.GetApplicationVipsApplicationVipResult']:
        """
        The list of application_vips.
        """
        return pulumi.get(self, "application_vips")

    @property
    @pulumi.getter(name="cloudVmClusterId")
    def cloud_vm_cluster_id(self) -> builtins.str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the cloud VM cluster associated with the application virtual IP (VIP) address.
        """
        return pulumi.get(self, "cloud_vm_cluster_id")

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetApplicationVipsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def state(self) -> Optional[builtins.str]:
        """
        The current lifecycle state of the application virtual IP (VIP) address.
        """
        return pulumi.get(self, "state")


class AwaitableGetApplicationVipsResult(GetApplicationVipsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetApplicationVipsResult(
            application_vips=self.application_vips,
            cloud_vm_cluster_id=self.cloud_vm_cluster_id,
            compartment_id=self.compartment_id,
            filters=self.filters,
            id=self.id,
            state=self.state)


def get_application_vips(cloud_vm_cluster_id: Optional[builtins.str] = None,
                         compartment_id: Optional[builtins.str] = None,
                         filters: Optional[Sequence[Union['GetApplicationVipsFilterArgs', 'GetApplicationVipsFilterArgsDict']]] = None,
                         state: Optional[builtins.str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetApplicationVipsResult:
    """
    This data source provides the list of Application Vips in Oracle Cloud Infrastructure Database service.

    Gets a list of application virtual IP (VIP) addresses on a cloud VM cluster.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_application_vips = oci.Database.get_application_vips(cloud_vm_cluster_id=test_cloud_vm_cluster["id"],
        compartment_id=compartment_id,
        state=application_vip_state)
    ```


    :param builtins.str cloud_vm_cluster_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the cloud VM cluster associated with the application virtual IP (VIP) address.
    :param builtins.str compartment_id: The compartment [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm).
    :param builtins.str state: A filter to return only resources that match the given lifecycle state exactly.
    """
    __args__ = dict()
    __args__['cloudVmClusterId'] = cloud_vm_cluster_id
    __args__['compartmentId'] = compartment_id
    __args__['filters'] = filters
    __args__['state'] = state
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Database/getApplicationVips:getApplicationVips', __args__, opts=opts, typ=GetApplicationVipsResult).value

    return AwaitableGetApplicationVipsResult(
        application_vips=pulumi.get(__ret__, 'application_vips'),
        cloud_vm_cluster_id=pulumi.get(__ret__, 'cloud_vm_cluster_id'),
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        state=pulumi.get(__ret__, 'state'))
def get_application_vips_output(cloud_vm_cluster_id: Optional[pulumi.Input[builtins.str]] = None,
                                compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                                filters: Optional[pulumi.Input[Optional[Sequence[Union['GetApplicationVipsFilterArgs', 'GetApplicationVipsFilterArgsDict']]]]] = None,
                                state: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetApplicationVipsResult]:
    """
    This data source provides the list of Application Vips in Oracle Cloud Infrastructure Database service.

    Gets a list of application virtual IP (VIP) addresses on a cloud VM cluster.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_application_vips = oci.Database.get_application_vips(cloud_vm_cluster_id=test_cloud_vm_cluster["id"],
        compartment_id=compartment_id,
        state=application_vip_state)
    ```


    :param builtins.str cloud_vm_cluster_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the cloud VM cluster associated with the application virtual IP (VIP) address.
    :param builtins.str compartment_id: The compartment [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm).
    :param builtins.str state: A filter to return only resources that match the given lifecycle state exactly.
    """
    __args__ = dict()
    __args__['cloudVmClusterId'] = cloud_vm_cluster_id
    __args__['compartmentId'] = compartment_id
    __args__['filters'] = filters
    __args__['state'] = state
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Database/getApplicationVips:getApplicationVips', __args__, opts=opts, typ=GetApplicationVipsResult)
    return __ret__.apply(lambda __response__: GetApplicationVipsResult(
        application_vips=pulumi.get(__response__, 'application_vips'),
        cloud_vm_cluster_id=pulumi.get(__response__, 'cloud_vm_cluster_id'),
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        state=pulumi.get(__response__, 'state')))
