# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetAutonomousExadataInfrastructureShapesResult',
    'AwaitableGetAutonomousExadataInfrastructureShapesResult',
    'get_autonomous_exadata_infrastructure_shapes',
    'get_autonomous_exadata_infrastructure_shapes_output',
]

@pulumi.output_type
class GetAutonomousExadataInfrastructureShapesResult:
    """
    A collection of values returned by getAutonomousExadataInfrastructureShapes.
    """
    def __init__(__self__, autonomous_exadata_infrastructure_shapes=None, availability_domain=None, compartment_id=None, filters=None, id=None):
        if autonomous_exadata_infrastructure_shapes and not isinstance(autonomous_exadata_infrastructure_shapes, list):
            raise TypeError("Expected argument 'autonomous_exadata_infrastructure_shapes' to be a list")
        pulumi.set(__self__, "autonomous_exadata_infrastructure_shapes", autonomous_exadata_infrastructure_shapes)
        if availability_domain and not isinstance(availability_domain, str):
            raise TypeError("Expected argument 'availability_domain' to be a str")
        pulumi.set(__self__, "availability_domain", availability_domain)
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter(name="autonomousExadataInfrastructureShapes")
    def autonomous_exadata_infrastructure_shapes(self) -> Sequence['outputs.GetAutonomousExadataInfrastructureShapesAutonomousExadataInfrastructureShapeResult']:
        """
        The list of autonomous_exadata_infrastructure_shapes.
        """
        return pulumi.get(self, "autonomous_exadata_infrastructure_shapes")

    @property
    @pulumi.getter(name="availabilityDomain")
    def availability_domain(self) -> builtins.str:
        return pulumi.get(self, "availability_domain")

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetAutonomousExadataInfrastructureShapesFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")


class AwaitableGetAutonomousExadataInfrastructureShapesResult(GetAutonomousExadataInfrastructureShapesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAutonomousExadataInfrastructureShapesResult(
            autonomous_exadata_infrastructure_shapes=self.autonomous_exadata_infrastructure_shapes,
            availability_domain=self.availability_domain,
            compartment_id=self.compartment_id,
            filters=self.filters,
            id=self.id)


def get_autonomous_exadata_infrastructure_shapes(availability_domain: Optional[builtins.str] = None,
                                                 compartment_id: Optional[builtins.str] = None,
                                                 filters: Optional[Sequence[Union['GetAutonomousExadataInfrastructureShapesFilterArgs', 'GetAutonomousExadataInfrastructureShapesFilterArgsDict']]] = None,
                                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAutonomousExadataInfrastructureShapesResult:
    """
    This data source provides the list of Autonomous Exadata Infrastructure Shapes in Oracle Cloud Infrastructure Database service.

    **Deprecated.**

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_autonomous_exadata_infrastructure_shapes = oci.Database.get_autonomous_exadata_infrastructure_shapes(availability_domain=autonomous_exadata_infrastructure_shape_availability_domain,
        compartment_id=compartment_id)
    ```


    :param builtins.str availability_domain: The name of the Availability Domain.
    :param builtins.str compartment_id: The compartment [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm).
    """
    __args__ = dict()
    __args__['availabilityDomain'] = availability_domain
    __args__['compartmentId'] = compartment_id
    __args__['filters'] = filters
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Database/getAutonomousExadataInfrastructureShapes:getAutonomousExadataInfrastructureShapes', __args__, opts=opts, typ=GetAutonomousExadataInfrastructureShapesResult).value

    return AwaitableGetAutonomousExadataInfrastructureShapesResult(
        autonomous_exadata_infrastructure_shapes=pulumi.get(__ret__, 'autonomous_exadata_infrastructure_shapes'),
        availability_domain=pulumi.get(__ret__, 'availability_domain'),
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'))
def get_autonomous_exadata_infrastructure_shapes_output(availability_domain: Optional[pulumi.Input[builtins.str]] = None,
                                                        compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                                                        filters: Optional[pulumi.Input[Optional[Sequence[Union['GetAutonomousExadataInfrastructureShapesFilterArgs', 'GetAutonomousExadataInfrastructureShapesFilterArgsDict']]]]] = None,
                                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetAutonomousExadataInfrastructureShapesResult]:
    """
    This data source provides the list of Autonomous Exadata Infrastructure Shapes in Oracle Cloud Infrastructure Database service.

    **Deprecated.**

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_autonomous_exadata_infrastructure_shapes = oci.Database.get_autonomous_exadata_infrastructure_shapes(availability_domain=autonomous_exadata_infrastructure_shape_availability_domain,
        compartment_id=compartment_id)
    ```


    :param builtins.str availability_domain: The name of the Availability Domain.
    :param builtins.str compartment_id: The compartment [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm).
    """
    __args__ = dict()
    __args__['availabilityDomain'] = availability_domain
    __args__['compartmentId'] = compartment_id
    __args__['filters'] = filters
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Database/getAutonomousExadataInfrastructureShapes:getAutonomousExadataInfrastructureShapes', __args__, opts=opts, typ=GetAutonomousExadataInfrastructureShapesResult)
    return __ret__.apply(lambda __response__: GetAutonomousExadataInfrastructureShapesResult(
        autonomous_exadata_infrastructure_shapes=pulumi.get(__response__, 'autonomous_exadata_infrastructure_shapes'),
        availability_domain=pulumi.get(__response__, 'availability_domain'),
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id')))
