# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetAutonomousVmClustersResult',
    'AwaitableGetAutonomousVmClustersResult',
    'get_autonomous_vm_clusters',
    'get_autonomous_vm_clusters_output',
]

@pulumi.output_type
class GetAutonomousVmClustersResult:
    """
    A collection of values returned by getAutonomousVmClusters.
    """
    def __init__(__self__, autonomous_vm_clusters=None, compartment_id=None, display_name=None, exadata_infrastructure_id=None, filters=None, id=None, state=None):
        if autonomous_vm_clusters and not isinstance(autonomous_vm_clusters, list):
            raise TypeError("Expected argument 'autonomous_vm_clusters' to be a list")
        pulumi.set(__self__, "autonomous_vm_clusters", autonomous_vm_clusters)
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if exadata_infrastructure_id and not isinstance(exadata_infrastructure_id, str):
            raise TypeError("Expected argument 'exadata_infrastructure_id' to be a str")
        pulumi.set(__self__, "exadata_infrastructure_id", exadata_infrastructure_id)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="autonomousVmClusters")
    def autonomous_vm_clusters(self) -> Sequence['outputs.GetAutonomousVmClustersAutonomousVmClusterResult']:
        """
        The list of autonomous_vm_clusters.
        """
        return pulumi.get(self, "autonomous_vm_clusters")

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[builtins.str]:
        """
        The user-friendly name for the Autonomous VM cluster. The name does not need to be unique.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="exadataInfrastructureId")
    def exadata_infrastructure_id(self) -> Optional[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Exadata infrastructure.
        """
        return pulumi.get(self, "exadata_infrastructure_id")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetAutonomousVmClustersFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def state(self) -> Optional[builtins.str]:
        """
        The current state of the Autonomous VM cluster.
        """
        return pulumi.get(self, "state")


class AwaitableGetAutonomousVmClustersResult(GetAutonomousVmClustersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAutonomousVmClustersResult(
            autonomous_vm_clusters=self.autonomous_vm_clusters,
            compartment_id=self.compartment_id,
            display_name=self.display_name,
            exadata_infrastructure_id=self.exadata_infrastructure_id,
            filters=self.filters,
            id=self.id,
            state=self.state)


def get_autonomous_vm_clusters(compartment_id: Optional[builtins.str] = None,
                               display_name: Optional[builtins.str] = None,
                               exadata_infrastructure_id: Optional[builtins.str] = None,
                               filters: Optional[Sequence[Union['GetAutonomousVmClustersFilterArgs', 'GetAutonomousVmClustersFilterArgsDict']]] = None,
                               state: Optional[builtins.str] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAutonomousVmClustersResult:
    """
    This data source provides the list of Autonomous Vm Clusters in Oracle Cloud Infrastructure Database service.

    Gets a list of Exadata Cloud@Customer Autonomous VM clusters in the specified compartment. To list Autonomous VM Clusters in the Oracle Cloud, see [ListCloudAutonomousVmClusters](https://docs.cloud.oracle.com/iaas/api/#/en/database/latest/CloudAutonomousVmCluster/ListCloudAutonomousVmClusters).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_autonomous_vm_clusters = oci.Database.get_autonomous_vm_clusters(compartment_id=compartment_id,
        display_name=autonomous_vm_cluster_display_name,
        exadata_infrastructure_id=test_exadata_infrastructure["id"],
        state=autonomous_vm_cluster_state)
    ```


    :param builtins.str compartment_id: The compartment [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm).
    :param builtins.str display_name: A filter to return only resources that match the entire display name given. The match is not case sensitive.
    :param builtins.str exadata_infrastructure_id: If provided, filters the results for the given Exadata Infrastructure.
    :param builtins.str state: A filter to return only resources that match the given lifecycle state exactly.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['exadataInfrastructureId'] = exadata_infrastructure_id
    __args__['filters'] = filters
    __args__['state'] = state
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Database/getAutonomousVmClusters:getAutonomousVmClusters', __args__, opts=opts, typ=GetAutonomousVmClustersResult).value

    return AwaitableGetAutonomousVmClustersResult(
        autonomous_vm_clusters=pulumi.get(__ret__, 'autonomous_vm_clusters'),
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        display_name=pulumi.get(__ret__, 'display_name'),
        exadata_infrastructure_id=pulumi.get(__ret__, 'exadata_infrastructure_id'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        state=pulumi.get(__ret__, 'state'))
def get_autonomous_vm_clusters_output(compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                                      display_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                      exadata_infrastructure_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                      filters: Optional[pulumi.Input[Optional[Sequence[Union['GetAutonomousVmClustersFilterArgs', 'GetAutonomousVmClustersFilterArgsDict']]]]] = None,
                                      state: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                      opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetAutonomousVmClustersResult]:
    """
    This data source provides the list of Autonomous Vm Clusters in Oracle Cloud Infrastructure Database service.

    Gets a list of Exadata Cloud@Customer Autonomous VM clusters in the specified compartment. To list Autonomous VM Clusters in the Oracle Cloud, see [ListCloudAutonomousVmClusters](https://docs.cloud.oracle.com/iaas/api/#/en/database/latest/CloudAutonomousVmCluster/ListCloudAutonomousVmClusters).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_autonomous_vm_clusters = oci.Database.get_autonomous_vm_clusters(compartment_id=compartment_id,
        display_name=autonomous_vm_cluster_display_name,
        exadata_infrastructure_id=test_exadata_infrastructure["id"],
        state=autonomous_vm_cluster_state)
    ```


    :param builtins.str compartment_id: The compartment [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm).
    :param builtins.str display_name: A filter to return only resources that match the entire display name given. The match is not case sensitive.
    :param builtins.str exadata_infrastructure_id: If provided, filters the results for the given Exadata Infrastructure.
    :param builtins.str state: A filter to return only resources that match the given lifecycle state exactly.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['exadataInfrastructureId'] = exadata_infrastructure_id
    __args__['filters'] = filters
    __args__['state'] = state
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Database/getAutonomousVmClusters:getAutonomousVmClusters', __args__, opts=opts, typ=GetAutonomousVmClustersResult)
    return __ret__.apply(lambda __response__: GetAutonomousVmClustersResult(
        autonomous_vm_clusters=pulumi.get(__response__, 'autonomous_vm_clusters'),
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        display_name=pulumi.get(__response__, 'display_name'),
        exadata_infrastructure_id=pulumi.get(__response__, 'exadata_infrastructure_id'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        state=pulumi.get(__response__, 'state')))
