# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetDatabaseMaintenanceRunHistoryResult',
    'AwaitableGetDatabaseMaintenanceRunHistoryResult',
    'get_database_maintenance_run_history',
    'get_database_maintenance_run_history_output',
]

@pulumi.output_type
class GetDatabaseMaintenanceRunHistoryResult:
    """
    A collection of values returned by getDatabaseMaintenanceRunHistory.
    """
    def __init__(__self__, current_execution_window=None, db_servers_history_details=None, granular_maintenance_histories=None, id=None, maintenance_run_details=None, maintenance_run_history_id=None):
        if current_execution_window and not isinstance(current_execution_window, str):
            raise TypeError("Expected argument 'current_execution_window' to be a str")
        pulumi.set(__self__, "current_execution_window", current_execution_window)
        if db_servers_history_details and not isinstance(db_servers_history_details, list):
            raise TypeError("Expected argument 'db_servers_history_details' to be a list")
        pulumi.set(__self__, "db_servers_history_details", db_servers_history_details)
        if granular_maintenance_histories and not isinstance(granular_maintenance_histories, list):
            raise TypeError("Expected argument 'granular_maintenance_histories' to be a list")
        pulumi.set(__self__, "granular_maintenance_histories", granular_maintenance_histories)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if maintenance_run_details and not isinstance(maintenance_run_details, list):
            raise TypeError("Expected argument 'maintenance_run_details' to be a list")
        pulumi.set(__self__, "maintenance_run_details", maintenance_run_details)
        if maintenance_run_history_id and not isinstance(maintenance_run_history_id, str):
            raise TypeError("Expected argument 'maintenance_run_history_id' to be a str")
        pulumi.set(__self__, "maintenance_run_history_id", maintenance_run_history_id)

    @property
    @pulumi.getter(name="currentExecutionWindow")
    def current_execution_window(self) -> builtins.str:
        """
        The OCID of the current execution window.
        """
        return pulumi.get(self, "current_execution_window")

    @property
    @pulumi.getter(name="dbServersHistoryDetails")
    def db_servers_history_details(self) -> Sequence['outputs.GetDatabaseMaintenanceRunHistoryDbServersHistoryDetailResult']:
        """
        List of database server history details.
        """
        return pulumi.get(self, "db_servers_history_details")

    @property
    @pulumi.getter(name="granularMaintenanceHistories")
    def granular_maintenance_histories(self) -> Sequence['outputs.GetDatabaseMaintenanceRunHistoryGranularMaintenanceHistoryResult']:
        """
        The list of granular maintenance history details.
        """
        return pulumi.get(self, "granular_maintenance_histories")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="maintenanceRunDetails")
    def maintenance_run_details(self) -> Sequence['outputs.GetDatabaseMaintenanceRunHistoryMaintenanceRunDetailResult']:
        """
        Details of a maintenance run.
        """
        return pulumi.get(self, "maintenance_run_details")

    @property
    @pulumi.getter(name="maintenanceRunHistoryId")
    def maintenance_run_history_id(self) -> builtins.str:
        return pulumi.get(self, "maintenance_run_history_id")


class AwaitableGetDatabaseMaintenanceRunHistoryResult(GetDatabaseMaintenanceRunHistoryResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDatabaseMaintenanceRunHistoryResult(
            current_execution_window=self.current_execution_window,
            db_servers_history_details=self.db_servers_history_details,
            granular_maintenance_histories=self.granular_maintenance_histories,
            id=self.id,
            maintenance_run_details=self.maintenance_run_details,
            maintenance_run_history_id=self.maintenance_run_history_id)


def get_database_maintenance_run_history(maintenance_run_history_id: Optional[builtins.str] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDatabaseMaintenanceRunHistoryResult:
    """
    This data source provides details about a specific Maintenance Run History resource in Oracle Cloud Infrastructure Database service.

    Gets information about the specified maintenance run history.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_maintenance_run_history = oci.Database.get_database_maintenance_run_history(maintenance_run_history_id=test_maintenance_run_history_oci_database_maintenance_run_history["id"])
    ```


    :param builtins.str maintenance_run_history_id: The maintenance run history OCID.
    """
    __args__ = dict()
    __args__['maintenanceRunHistoryId'] = maintenance_run_history_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Database/getDatabaseMaintenanceRunHistory:getDatabaseMaintenanceRunHistory', __args__, opts=opts, typ=GetDatabaseMaintenanceRunHistoryResult).value

    return AwaitableGetDatabaseMaintenanceRunHistoryResult(
        current_execution_window=pulumi.get(__ret__, 'current_execution_window'),
        db_servers_history_details=pulumi.get(__ret__, 'db_servers_history_details'),
        granular_maintenance_histories=pulumi.get(__ret__, 'granular_maintenance_histories'),
        id=pulumi.get(__ret__, 'id'),
        maintenance_run_details=pulumi.get(__ret__, 'maintenance_run_details'),
        maintenance_run_history_id=pulumi.get(__ret__, 'maintenance_run_history_id'))
def get_database_maintenance_run_history_output(maintenance_run_history_id: Optional[pulumi.Input[builtins.str]] = None,
                                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetDatabaseMaintenanceRunHistoryResult]:
    """
    This data source provides details about a specific Maintenance Run History resource in Oracle Cloud Infrastructure Database service.

    Gets information about the specified maintenance run history.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_maintenance_run_history = oci.Database.get_database_maintenance_run_history(maintenance_run_history_id=test_maintenance_run_history_oci_database_maintenance_run_history["id"])
    ```


    :param builtins.str maintenance_run_history_id: The maintenance run history OCID.
    """
    __args__ = dict()
    __args__['maintenanceRunHistoryId'] = maintenance_run_history_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Database/getDatabaseMaintenanceRunHistory:getDatabaseMaintenanceRunHistory', __args__, opts=opts, typ=GetDatabaseMaintenanceRunHistoryResult)
    return __ret__.apply(lambda __response__: GetDatabaseMaintenanceRunHistoryResult(
        current_execution_window=pulumi.get(__response__, 'current_execution_window'),
        db_servers_history_details=pulumi.get(__response__, 'db_servers_history_details'),
        granular_maintenance_histories=pulumi.get(__response__, 'granular_maintenance_histories'),
        id=pulumi.get(__response__, 'id'),
        maintenance_run_details=pulumi.get(__response__, 'maintenance_run_details'),
        maintenance_run_history_id=pulumi.get(__response__, 'maintenance_run_history_id')))
