# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetExternalNonContainerDatabasesResult',
    'AwaitableGetExternalNonContainerDatabasesResult',
    'get_external_non_container_databases',
    'get_external_non_container_databases_output',
]

@pulumi.output_type
class GetExternalNonContainerDatabasesResult:
    """
    A collection of values returned by getExternalNonContainerDatabases.
    """
    def __init__(__self__, compartment_id=None, display_name=None, external_non_container_databases=None, filters=None, id=None, state=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if external_non_container_databases and not isinstance(external_non_container_databases, list):
            raise TypeError("Expected argument 'external_non_container_databases' to be a list")
        pulumi.set(__self__, "external_non_container_databases", external_non_container_databases)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[builtins.str]:
        """
        The user-friendly name for the external database. The name does not have to be unique.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="externalNonContainerDatabases")
    def external_non_container_databases(self) -> Sequence['outputs.GetExternalNonContainerDatabasesExternalNonContainerDatabaseResult']:
        """
        The list of external_non_container_databases.
        """
        return pulumi.get(self, "external_non_container_databases")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetExternalNonContainerDatabasesFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def state(self) -> Optional[builtins.str]:
        """
        The current state of the Oracle Cloud Infrastructure external database resource.
        """
        return pulumi.get(self, "state")


class AwaitableGetExternalNonContainerDatabasesResult(GetExternalNonContainerDatabasesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetExternalNonContainerDatabasesResult(
            compartment_id=self.compartment_id,
            display_name=self.display_name,
            external_non_container_databases=self.external_non_container_databases,
            filters=self.filters,
            id=self.id,
            state=self.state)


def get_external_non_container_databases(compartment_id: Optional[builtins.str] = None,
                                         display_name: Optional[builtins.str] = None,
                                         filters: Optional[Sequence[Union['GetExternalNonContainerDatabasesFilterArgs', 'GetExternalNonContainerDatabasesFilterArgsDict']]] = None,
                                         state: Optional[builtins.str] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetExternalNonContainerDatabasesResult:
    """
    This data source provides the list of External Non Container Databases in Oracle Cloud Infrastructure Database service.

    Gets a list of the ExternalNonContainerDatabases in the specified compartment.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_external_non_container_databases = oci.Database.get_external_non_container_databases(compartment_id=compartment_id,
        display_name=external_non_container_database_display_name,
        state=external_non_container_database_state)
    ```


    :param builtins.str compartment_id: The compartment [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm).
    :param builtins.str display_name: A filter to return only resources that match the entire display name given. The match is not case sensitive.
    :param builtins.str state: A filter to return only resources that match the specified lifecycle state.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['state'] = state
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Database/getExternalNonContainerDatabases:getExternalNonContainerDatabases', __args__, opts=opts, typ=GetExternalNonContainerDatabasesResult).value

    return AwaitableGetExternalNonContainerDatabasesResult(
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        display_name=pulumi.get(__ret__, 'display_name'),
        external_non_container_databases=pulumi.get(__ret__, 'external_non_container_databases'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        state=pulumi.get(__ret__, 'state'))
def get_external_non_container_databases_output(compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                                                display_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                filters: Optional[pulumi.Input[Optional[Sequence[Union['GetExternalNonContainerDatabasesFilterArgs', 'GetExternalNonContainerDatabasesFilterArgsDict']]]]] = None,
                                                state: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetExternalNonContainerDatabasesResult]:
    """
    This data source provides the list of External Non Container Databases in Oracle Cloud Infrastructure Database service.

    Gets a list of the ExternalNonContainerDatabases in the specified compartment.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_external_non_container_databases = oci.Database.get_external_non_container_databases(compartment_id=compartment_id,
        display_name=external_non_container_database_display_name,
        state=external_non_container_database_state)
    ```


    :param builtins.str compartment_id: The compartment [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm).
    :param builtins.str display_name: A filter to return only resources that match the entire display name given. The match is not case sensitive.
    :param builtins.str state: A filter to return only resources that match the specified lifecycle state.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['state'] = state
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Database/getExternalNonContainerDatabases:getExternalNonContainerDatabases', __args__, opts=opts, typ=GetExternalNonContainerDatabasesResult)
    return __ret__.apply(lambda __response__: GetExternalNonContainerDatabasesResult(
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        display_name=pulumi.get(__response__, 'display_name'),
        external_non_container_databases=pulumi.get(__response__, 'external_non_container_databases'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        state=pulumi.get(__response__, 'state')))
