# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetExternalAsmUsersResult',
    'AwaitableGetExternalAsmUsersResult',
    'get_external_asm_users',
    'get_external_asm_users_output',
]

@pulumi.output_type
class GetExternalAsmUsersResult:
    """
    A collection of values returned by getExternalAsmUsers.
    """
    def __init__(__self__, external_asm_id=None, external_asm_user_collections=None, filters=None, id=None, opc_named_credential_id=None):
        if external_asm_id and not isinstance(external_asm_id, str):
            raise TypeError("Expected argument 'external_asm_id' to be a str")
        pulumi.set(__self__, "external_asm_id", external_asm_id)
        if external_asm_user_collections and not isinstance(external_asm_user_collections, list):
            raise TypeError("Expected argument 'external_asm_user_collections' to be a list")
        pulumi.set(__self__, "external_asm_user_collections", external_asm_user_collections)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if opc_named_credential_id and not isinstance(opc_named_credential_id, str):
            raise TypeError("Expected argument 'opc_named_credential_id' to be a str")
        pulumi.set(__self__, "opc_named_credential_id", opc_named_credential_id)

    @property
    @pulumi.getter(name="externalAsmId")
    def external_asm_id(self) -> builtins.str:
        return pulumi.get(self, "external_asm_id")

    @property
    @pulumi.getter(name="externalAsmUserCollections")
    def external_asm_user_collections(self) -> Sequence['outputs.GetExternalAsmUsersExternalAsmUserCollectionResult']:
        """
        The list of external_asm_user_collection.
        """
        return pulumi.get(self, "external_asm_user_collections")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetExternalAsmUsersFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="opcNamedCredentialId")
    def opc_named_credential_id(self) -> Optional[builtins.str]:
        return pulumi.get(self, "opc_named_credential_id")


class AwaitableGetExternalAsmUsersResult(GetExternalAsmUsersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetExternalAsmUsersResult(
            external_asm_id=self.external_asm_id,
            external_asm_user_collections=self.external_asm_user_collections,
            filters=self.filters,
            id=self.id,
            opc_named_credential_id=self.opc_named_credential_id)


def get_external_asm_users(external_asm_id: Optional[builtins.str] = None,
                           filters: Optional[Sequence[Union['GetExternalAsmUsersFilterArgs', 'GetExternalAsmUsersFilterArgsDict']]] = None,
                           opc_named_credential_id: Optional[builtins.str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetExternalAsmUsersResult:
    """
    This data source provides the list of External Asm Users in Oracle Cloud Infrastructure Database Management service.

    Lists ASM users for the external ASM specified by `externalAsmId`.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_external_asm_users = oci.DatabaseManagement.get_external_asm_users(external_asm_id=test_external_asm["id"],
        opc_named_credential_id=external_asm_user_opc_named_credential_id)
    ```


    :param builtins.str external_asm_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the external ASM.
    :param builtins.str opc_named_credential_id: The OCID of the Named Credential.
    """
    __args__ = dict()
    __args__['externalAsmId'] = external_asm_id
    __args__['filters'] = filters
    __args__['opcNamedCredentialId'] = opc_named_credential_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:DatabaseManagement/getExternalAsmUsers:getExternalAsmUsers', __args__, opts=opts, typ=GetExternalAsmUsersResult).value

    return AwaitableGetExternalAsmUsersResult(
        external_asm_id=pulumi.get(__ret__, 'external_asm_id'),
        external_asm_user_collections=pulumi.get(__ret__, 'external_asm_user_collections'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        opc_named_credential_id=pulumi.get(__ret__, 'opc_named_credential_id'))
def get_external_asm_users_output(external_asm_id: Optional[pulumi.Input[builtins.str]] = None,
                                  filters: Optional[pulumi.Input[Optional[Sequence[Union['GetExternalAsmUsersFilterArgs', 'GetExternalAsmUsersFilterArgsDict']]]]] = None,
                                  opc_named_credential_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetExternalAsmUsersResult]:
    """
    This data source provides the list of External Asm Users in Oracle Cloud Infrastructure Database Management service.

    Lists ASM users for the external ASM specified by `externalAsmId`.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_external_asm_users = oci.DatabaseManagement.get_external_asm_users(external_asm_id=test_external_asm["id"],
        opc_named_credential_id=external_asm_user_opc_named_credential_id)
    ```


    :param builtins.str external_asm_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the external ASM.
    :param builtins.str opc_named_credential_id: The OCID of the Named Credential.
    """
    __args__ = dict()
    __args__['externalAsmId'] = external_asm_id
    __args__['filters'] = filters
    __args__['opcNamedCredentialId'] = opc_named_credential_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:DatabaseManagement/getExternalAsmUsers:getExternalAsmUsers', __args__, opts=opts, typ=GetExternalAsmUsersResult)
    return __ret__.apply(lambda __response__: GetExternalAsmUsersResult(
        external_asm_id=pulumi.get(__response__, 'external_asm_id'),
        external_asm_user_collections=pulumi.get(__response__, 'external_asm_user_collections'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        opc_named_credential_id=pulumi.get(__response__, 'opc_named_credential_id')))
