# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetExternalDatabasesResult',
    'AwaitableGetExternalDatabasesResult',
    'get_external_databases',
    'get_external_databases_output',
]

@pulumi.output_type
class GetExternalDatabasesResult:
    """
    A collection of values returned by getExternalDatabases.
    """
    def __init__(__self__, compartment_id=None, display_name=None, external_database_collections=None, external_database_id=None, external_db_system_id=None, filters=None, id=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if external_database_collections and not isinstance(external_database_collections, list):
            raise TypeError("Expected argument 'external_database_collections' to be a list")
        pulumi.set(__self__, "external_database_collections", external_database_collections)
        if external_database_id and not isinstance(external_database_id, str):
            raise TypeError("Expected argument 'external_database_id' to be a str")
        pulumi.set(__self__, "external_database_id", external_database_id)
        if external_db_system_id and not isinstance(external_db_system_id, str):
            raise TypeError("Expected argument 'external_db_system_id' to be a str")
        pulumi.set(__self__, "external_db_system_id", external_db_system_id)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> Optional[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[builtins.str]:
        """
        The user-friendly name for the database. The name does not have to be unique.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="externalDatabaseCollections")
    def external_database_collections(self) -> Sequence['outputs.GetExternalDatabasesExternalDatabaseCollectionResult']:
        """
        The list of external_database_collection.
        """
        return pulumi.get(self, "external_database_collections")

    @property
    @pulumi.getter(name="externalDatabaseId")
    def external_database_id(self) -> Optional[builtins.str]:
        return pulumi.get(self, "external_database_id")

    @property
    @pulumi.getter(name="externalDbSystemId")
    def external_db_system_id(self) -> Optional[builtins.str]:
        return pulumi.get(self, "external_db_system_id")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetExternalDatabasesFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")


class AwaitableGetExternalDatabasesResult(GetExternalDatabasesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetExternalDatabasesResult(
            compartment_id=self.compartment_id,
            display_name=self.display_name,
            external_database_collections=self.external_database_collections,
            external_database_id=self.external_database_id,
            external_db_system_id=self.external_db_system_id,
            filters=self.filters,
            id=self.id)


def get_external_databases(compartment_id: Optional[builtins.str] = None,
                           display_name: Optional[builtins.str] = None,
                           external_database_id: Optional[builtins.str] = None,
                           external_db_system_id: Optional[builtins.str] = None,
                           filters: Optional[Sequence[Union['GetExternalDatabasesFilterArgs', 'GetExternalDatabasesFilterArgsDict']]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetExternalDatabasesResult:
    """
    This data source provides the list of External Databases in Oracle Cloud Infrastructure Database Management service.

    Lists the external databases in the specified compartment or in the specified DB system.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_external_databases = oci.DatabaseManagement.get_external_databases(compartment_id=compartment_id,
        display_name=external_database_display_name,
        external_database_id=test_external_database["id"],
        external_db_system_id=test_external_db_system["id"])
    ```


    :param builtins.str compartment_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
    :param builtins.str display_name: A filter to only return the resources that match the entire display name.
    :param builtins.str external_database_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the external database.
    :param builtins.str external_db_system_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the external DB system.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['externalDatabaseId'] = external_database_id
    __args__['externalDbSystemId'] = external_db_system_id
    __args__['filters'] = filters
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:DatabaseManagement/getExternalDatabases:getExternalDatabases', __args__, opts=opts, typ=GetExternalDatabasesResult).value

    return AwaitableGetExternalDatabasesResult(
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        display_name=pulumi.get(__ret__, 'display_name'),
        external_database_collections=pulumi.get(__ret__, 'external_database_collections'),
        external_database_id=pulumi.get(__ret__, 'external_database_id'),
        external_db_system_id=pulumi.get(__ret__, 'external_db_system_id'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'))
def get_external_databases_output(compartment_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                  display_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                  external_database_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                  external_db_system_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                  filters: Optional[pulumi.Input[Optional[Sequence[Union['GetExternalDatabasesFilterArgs', 'GetExternalDatabasesFilterArgsDict']]]]] = None,
                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetExternalDatabasesResult]:
    """
    This data source provides the list of External Databases in Oracle Cloud Infrastructure Database Management service.

    Lists the external databases in the specified compartment or in the specified DB system.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_external_databases = oci.DatabaseManagement.get_external_databases(compartment_id=compartment_id,
        display_name=external_database_display_name,
        external_database_id=test_external_database["id"],
        external_db_system_id=test_external_db_system["id"])
    ```


    :param builtins.str compartment_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
    :param builtins.str display_name: A filter to only return the resources that match the entire display name.
    :param builtins.str external_database_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the external database.
    :param builtins.str external_db_system_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the external DB system.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['externalDatabaseId'] = external_database_id
    __args__['externalDbSystemId'] = external_db_system_id
    __args__['filters'] = filters
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:DatabaseManagement/getExternalDatabases:getExternalDatabases', __args__, opts=opts, typ=GetExternalDatabasesResult)
    return __ret__.apply(lambda __response__: GetExternalDatabasesResult(
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        display_name=pulumi.get(__response__, 'display_name'),
        external_database_collections=pulumi.get(__response__, 'external_database_collections'),
        external_database_id=pulumi.get(__response__, 'external_database_id'),
        external_db_system_id=pulumi.get(__response__, 'external_db_system_id'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id')))
