# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetManagedDatabaseCursorCacheStatementsResult',
    'AwaitableGetManagedDatabaseCursorCacheStatementsResult',
    'get_managed_database_cursor_cache_statements',
    'get_managed_database_cursor_cache_statements_output',
]

@pulumi.output_type
class GetManagedDatabaseCursorCacheStatementsResult:
    """
    A collection of values returned by getManagedDatabaseCursorCacheStatements.
    """
    def __init__(__self__, cursor_cache_statement_collections=None, filters=None, id=None, limit=None, managed_database_id=None, opc_named_credential_id=None, sql_text=None):
        if cursor_cache_statement_collections and not isinstance(cursor_cache_statement_collections, list):
            raise TypeError("Expected argument 'cursor_cache_statement_collections' to be a list")
        pulumi.set(__self__, "cursor_cache_statement_collections", cursor_cache_statement_collections)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if limit and not isinstance(limit, int):
            raise TypeError("Expected argument 'limit' to be a int")
        pulumi.set(__self__, "limit", limit)
        if managed_database_id and not isinstance(managed_database_id, str):
            raise TypeError("Expected argument 'managed_database_id' to be a str")
        pulumi.set(__self__, "managed_database_id", managed_database_id)
        if opc_named_credential_id and not isinstance(opc_named_credential_id, str):
            raise TypeError("Expected argument 'opc_named_credential_id' to be a str")
        pulumi.set(__self__, "opc_named_credential_id", opc_named_credential_id)
        if sql_text and not isinstance(sql_text, str):
            raise TypeError("Expected argument 'sql_text' to be a str")
        pulumi.set(__self__, "sql_text", sql_text)

    @property
    @pulumi.getter(name="cursorCacheStatementCollections")
    def cursor_cache_statement_collections(self) -> Sequence['outputs.GetManagedDatabaseCursorCacheStatementsCursorCacheStatementCollectionResult']:
        """
        The list of cursor_cache_statement_collection.
        """
        return pulumi.get(self, "cursor_cache_statement_collections")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetManagedDatabaseCursorCacheStatementsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def limit(self) -> Optional[builtins.int]:
        return pulumi.get(self, "limit")

    @property
    @pulumi.getter(name="managedDatabaseId")
    def managed_database_id(self) -> builtins.str:
        return pulumi.get(self, "managed_database_id")

    @property
    @pulumi.getter(name="opcNamedCredentialId")
    def opc_named_credential_id(self) -> Optional[builtins.str]:
        return pulumi.get(self, "opc_named_credential_id")

    @property
    @pulumi.getter(name="sqlText")
    def sql_text(self) -> Optional[builtins.str]:
        """
        The first thousand characters of the SQL text.
        """
        return pulumi.get(self, "sql_text")


class AwaitableGetManagedDatabaseCursorCacheStatementsResult(GetManagedDatabaseCursorCacheStatementsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetManagedDatabaseCursorCacheStatementsResult(
            cursor_cache_statement_collections=self.cursor_cache_statement_collections,
            filters=self.filters,
            id=self.id,
            limit=self.limit,
            managed_database_id=self.managed_database_id,
            opc_named_credential_id=self.opc_named_credential_id,
            sql_text=self.sql_text)


def get_managed_database_cursor_cache_statements(filters: Optional[Sequence[Union['GetManagedDatabaseCursorCacheStatementsFilterArgs', 'GetManagedDatabaseCursorCacheStatementsFilterArgsDict']]] = None,
                                                 limit: Optional[builtins.int] = None,
                                                 managed_database_id: Optional[builtins.str] = None,
                                                 opc_named_credential_id: Optional[builtins.str] = None,
                                                 sql_text: Optional[builtins.str] = None,
                                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetManagedDatabaseCursorCacheStatementsResult:
    """
    This data source provides the list of Managed Database Cursor Cache Statements in Oracle Cloud Infrastructure Database Management service.

    Lists the SQL statements from shared SQL area, also called the cursor cache.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_managed_database_cursor_cache_statements = oci.DatabaseManagement.get_managed_database_cursor_cache_statements(managed_database_id=test_managed_database["id"],
        opc_named_credential_id=managed_database_cursor_cache_statement_opc_named_credential_id,
        sql_text=managed_database_cursor_cache_statement_sql_text)
    ```


    :param builtins.str managed_database_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Managed Database.
    :param builtins.str opc_named_credential_id: The OCID of the Named Credential.
    :param builtins.str sql_text: A filter to return all the SQL plan baselines that match the SQL text. By default, the search is case insensitive. To run an exact or case-sensitive search, double-quote the search string. You may also use the '%' symbol as a wildcard.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['limit'] = limit
    __args__['managedDatabaseId'] = managed_database_id
    __args__['opcNamedCredentialId'] = opc_named_credential_id
    __args__['sqlText'] = sql_text
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:DatabaseManagement/getManagedDatabaseCursorCacheStatements:getManagedDatabaseCursorCacheStatements', __args__, opts=opts, typ=GetManagedDatabaseCursorCacheStatementsResult).value

    return AwaitableGetManagedDatabaseCursorCacheStatementsResult(
        cursor_cache_statement_collections=pulumi.get(__ret__, 'cursor_cache_statement_collections'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        limit=pulumi.get(__ret__, 'limit'),
        managed_database_id=pulumi.get(__ret__, 'managed_database_id'),
        opc_named_credential_id=pulumi.get(__ret__, 'opc_named_credential_id'),
        sql_text=pulumi.get(__ret__, 'sql_text'))
def get_managed_database_cursor_cache_statements_output(filters: Optional[pulumi.Input[Optional[Sequence[Union['GetManagedDatabaseCursorCacheStatementsFilterArgs', 'GetManagedDatabaseCursorCacheStatementsFilterArgsDict']]]]] = None,
                                                        limit: Optional[pulumi.Input[Optional[builtins.int]]] = None,
                                                        managed_database_id: Optional[pulumi.Input[builtins.str]] = None,
                                                        opc_named_credential_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                        sql_text: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetManagedDatabaseCursorCacheStatementsResult]:
    """
    This data source provides the list of Managed Database Cursor Cache Statements in Oracle Cloud Infrastructure Database Management service.

    Lists the SQL statements from shared SQL area, also called the cursor cache.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_managed_database_cursor_cache_statements = oci.DatabaseManagement.get_managed_database_cursor_cache_statements(managed_database_id=test_managed_database["id"],
        opc_named_credential_id=managed_database_cursor_cache_statement_opc_named_credential_id,
        sql_text=managed_database_cursor_cache_statement_sql_text)
    ```


    :param builtins.str managed_database_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Managed Database.
    :param builtins.str opc_named_credential_id: The OCID of the Named Credential.
    :param builtins.str sql_text: A filter to return all the SQL plan baselines that match the SQL text. By default, the search is case insensitive. To run an exact or case-sensitive search, double-quote the search string. You may also use the '%' symbol as a wildcard.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['limit'] = limit
    __args__['managedDatabaseId'] = managed_database_id
    __args__['opcNamedCredentialId'] = opc_named_credential_id
    __args__['sqlText'] = sql_text
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:DatabaseManagement/getManagedDatabaseCursorCacheStatements:getManagedDatabaseCursorCacheStatements', __args__, opts=opts, typ=GetManagedDatabaseCursorCacheStatementsResult)
    return __ret__.apply(lambda __response__: GetManagedDatabaseCursorCacheStatementsResult(
        cursor_cache_statement_collections=pulumi.get(__response__, 'cursor_cache_statement_collections'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        limit=pulumi.get(__response__, 'limit'),
        managed_database_id=pulumi.get(__response__, 'managed_database_id'),
        opc_named_credential_id=pulumi.get(__response__, 'opc_named_credential_id'),
        sql_text=pulumi.get(__response__, 'sql_text')))
