# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetManagedDatabaseSqlTuningSetsResult',
    'AwaitableGetManagedDatabaseSqlTuningSetsResult',
    'get_managed_database_sql_tuning_sets',
    'get_managed_database_sql_tuning_sets_output',
]

@pulumi.output_type
class GetManagedDatabaseSqlTuningSetsResult:
    """
    A collection of values returned by getManagedDatabaseSqlTuningSets.
    """
    def __init__(__self__, filters=None, id=None, managed_database_id=None, name_contains=None, opc_named_credential_id=None, owner=None, sql_tuning_set_collections=None):
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if managed_database_id and not isinstance(managed_database_id, str):
            raise TypeError("Expected argument 'managed_database_id' to be a str")
        pulumi.set(__self__, "managed_database_id", managed_database_id)
        if name_contains and not isinstance(name_contains, str):
            raise TypeError("Expected argument 'name_contains' to be a str")
        pulumi.set(__self__, "name_contains", name_contains)
        if opc_named_credential_id and not isinstance(opc_named_credential_id, str):
            raise TypeError("Expected argument 'opc_named_credential_id' to be a str")
        pulumi.set(__self__, "opc_named_credential_id", opc_named_credential_id)
        if owner and not isinstance(owner, str):
            raise TypeError("Expected argument 'owner' to be a str")
        pulumi.set(__self__, "owner", owner)
        if sql_tuning_set_collections and not isinstance(sql_tuning_set_collections, list):
            raise TypeError("Expected argument 'sql_tuning_set_collections' to be a list")
        pulumi.set(__self__, "sql_tuning_set_collections", sql_tuning_set_collections)

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetManagedDatabaseSqlTuningSetsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="managedDatabaseId")
    def managed_database_id(self) -> builtins.str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Managed Database.
        """
        return pulumi.get(self, "managed_database_id")

    @property
    @pulumi.getter(name="nameContains")
    def name_contains(self) -> Optional[builtins.str]:
        return pulumi.get(self, "name_contains")

    @property
    @pulumi.getter(name="opcNamedCredentialId")
    def opc_named_credential_id(self) -> Optional[builtins.str]:
        return pulumi.get(self, "opc_named_credential_id")

    @property
    @pulumi.getter
    def owner(self) -> Optional[builtins.str]:
        """
        The owner of the SQL tuning set.
        """
        return pulumi.get(self, "owner")

    @property
    @pulumi.getter(name="sqlTuningSetCollections")
    def sql_tuning_set_collections(self) -> Sequence['outputs.GetManagedDatabaseSqlTuningSetsSqlTuningSetCollectionResult']:
        """
        The list of sql_tuning_set_collection.
        """
        return pulumi.get(self, "sql_tuning_set_collections")


class AwaitableGetManagedDatabaseSqlTuningSetsResult(GetManagedDatabaseSqlTuningSetsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetManagedDatabaseSqlTuningSetsResult(
            filters=self.filters,
            id=self.id,
            managed_database_id=self.managed_database_id,
            name_contains=self.name_contains,
            opc_named_credential_id=self.opc_named_credential_id,
            owner=self.owner,
            sql_tuning_set_collections=self.sql_tuning_set_collections)


def get_managed_database_sql_tuning_sets(filters: Optional[Sequence[Union['GetManagedDatabaseSqlTuningSetsFilterArgs', 'GetManagedDatabaseSqlTuningSetsFilterArgsDict']]] = None,
                                         managed_database_id: Optional[builtins.str] = None,
                                         name_contains: Optional[builtins.str] = None,
                                         opc_named_credential_id: Optional[builtins.str] = None,
                                         owner: Optional[builtins.str] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetManagedDatabaseSqlTuningSetsResult:
    """
    This data source provides the list of Managed Database Sql Tuning Sets in Oracle Cloud Infrastructure Database Management service.

    Lists the SQL tuning sets for the specified Managed Database.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_managed_database_sql_tuning_sets = oci.DatabaseManagement.get_managed_database_sql_tuning_sets(managed_database_id=test_managed_database["id"],
        name_contains=managed_database_sql_tuning_set_name_contains,
        opc_named_credential_id=managed_database_sql_tuning_set_opc_named_credential_id,
        owner=managed_database_sql_tuning_set_owner)
    ```


    :param builtins.str managed_database_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Managed Database.
    :param builtins.str name_contains: Allow searching the name of the SQL tuning set by partial matching. The search is case insensitive.
    :param builtins.str opc_named_credential_id: The OCID of the Named Credential.
    :param builtins.str owner: The owner of the SQL tuning set.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['managedDatabaseId'] = managed_database_id
    __args__['nameContains'] = name_contains
    __args__['opcNamedCredentialId'] = opc_named_credential_id
    __args__['owner'] = owner
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:DatabaseManagement/getManagedDatabaseSqlTuningSets:getManagedDatabaseSqlTuningSets', __args__, opts=opts, typ=GetManagedDatabaseSqlTuningSetsResult).value

    return AwaitableGetManagedDatabaseSqlTuningSetsResult(
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        managed_database_id=pulumi.get(__ret__, 'managed_database_id'),
        name_contains=pulumi.get(__ret__, 'name_contains'),
        opc_named_credential_id=pulumi.get(__ret__, 'opc_named_credential_id'),
        owner=pulumi.get(__ret__, 'owner'),
        sql_tuning_set_collections=pulumi.get(__ret__, 'sql_tuning_set_collections'))
def get_managed_database_sql_tuning_sets_output(filters: Optional[pulumi.Input[Optional[Sequence[Union['GetManagedDatabaseSqlTuningSetsFilterArgs', 'GetManagedDatabaseSqlTuningSetsFilterArgsDict']]]]] = None,
                                                managed_database_id: Optional[pulumi.Input[builtins.str]] = None,
                                                name_contains: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                opc_named_credential_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                owner: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetManagedDatabaseSqlTuningSetsResult]:
    """
    This data source provides the list of Managed Database Sql Tuning Sets in Oracle Cloud Infrastructure Database Management service.

    Lists the SQL tuning sets for the specified Managed Database.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_managed_database_sql_tuning_sets = oci.DatabaseManagement.get_managed_database_sql_tuning_sets(managed_database_id=test_managed_database["id"],
        name_contains=managed_database_sql_tuning_set_name_contains,
        opc_named_credential_id=managed_database_sql_tuning_set_opc_named_credential_id,
        owner=managed_database_sql_tuning_set_owner)
    ```


    :param builtins.str managed_database_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Managed Database.
    :param builtins.str name_contains: Allow searching the name of the SQL tuning set by partial matching. The search is case insensitive.
    :param builtins.str opc_named_credential_id: The OCID of the Named Credential.
    :param builtins.str owner: The owner of the SQL tuning set.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['managedDatabaseId'] = managed_database_id
    __args__['nameContains'] = name_contains
    __args__['opcNamedCredentialId'] = opc_named_credential_id
    __args__['owner'] = owner
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:DatabaseManagement/getManagedDatabaseSqlTuningSets:getManagedDatabaseSqlTuningSets', __args__, opts=opts, typ=GetManagedDatabaseSqlTuningSetsResult)
    return __ret__.apply(lambda __response__: GetManagedDatabaseSqlTuningSetsResult(
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        managed_database_id=pulumi.get(__response__, 'managed_database_id'),
        name_contains=pulumi.get(__response__, 'name_contains'),
        opc_named_credential_id=pulumi.get(__response__, 'opc_named_credential_id'),
        owner=pulumi.get(__response__, 'owner'),
        sql_tuning_set_collections=pulumi.get(__response__, 'sql_tuning_set_collections')))
