# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetWorkspaceApplicationSchedulesResult',
    'AwaitableGetWorkspaceApplicationSchedulesResult',
    'get_workspace_application_schedules',
    'get_workspace_application_schedules_output',
]

@pulumi.output_type
class GetWorkspaceApplicationSchedulesResult:
    """
    A collection of values returned by getWorkspaceApplicationSchedules.
    """
    def __init__(__self__, application_key=None, filters=None, id=None, identifiers=None, keys=None, name=None, schedule_summary_collections=None, types=None, workspace_id=None):
        if application_key and not isinstance(application_key, str):
            raise TypeError("Expected argument 'application_key' to be a str")
        pulumi.set(__self__, "application_key", application_key)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if identifiers and not isinstance(identifiers, list):
            raise TypeError("Expected argument 'identifiers' to be a list")
        pulumi.set(__self__, "identifiers", identifiers)
        if keys and not isinstance(keys, list):
            raise TypeError("Expected argument 'keys' to be a list")
        pulumi.set(__self__, "keys", keys)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if schedule_summary_collections and not isinstance(schedule_summary_collections, list):
            raise TypeError("Expected argument 'schedule_summary_collections' to be a list")
        pulumi.set(__self__, "schedule_summary_collections", schedule_summary_collections)
        if types and not isinstance(types, list):
            raise TypeError("Expected argument 'types' to be a list")
        pulumi.set(__self__, "types", types)
        if workspace_id and not isinstance(workspace_id, str):
            raise TypeError("Expected argument 'workspace_id' to be a str")
        pulumi.set(__self__, "workspace_id", workspace_id)

    @property
    @pulumi.getter(name="applicationKey")
    def application_key(self) -> builtins.str:
        return pulumi.get(self, "application_key")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetWorkspaceApplicationSchedulesFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def identifiers(self) -> Optional[Sequence[builtins.str]]:
        """
        The identifier of the aggregator.
        """
        return pulumi.get(self, "identifiers")

    @property
    @pulumi.getter
    def keys(self) -> Optional[Sequence[builtins.str]]:
        """
        The key of the aggregator object.
        """
        return pulumi.get(self, "keys")

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        """
        Free form text without any restriction on permitted characters. Name can have letters, numbers, and special characters. The value is editable and is restricted to 1000 characters.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="scheduleSummaryCollections")
    def schedule_summary_collections(self) -> Sequence['outputs.GetWorkspaceApplicationSchedulesScheduleSummaryCollectionResult']:
        """
        The list of schedule_summary_collection.
        """
        return pulumi.get(self, "schedule_summary_collections")

    @property
    @pulumi.getter
    def types(self) -> Optional[Sequence[builtins.str]]:
        """
        The type of the aggregator.
        """
        return pulumi.get(self, "types")

    @property
    @pulumi.getter(name="workspaceId")
    def workspace_id(self) -> builtins.str:
        return pulumi.get(self, "workspace_id")


class AwaitableGetWorkspaceApplicationSchedulesResult(GetWorkspaceApplicationSchedulesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWorkspaceApplicationSchedulesResult(
            application_key=self.application_key,
            filters=self.filters,
            id=self.id,
            identifiers=self.identifiers,
            keys=self.keys,
            name=self.name,
            schedule_summary_collections=self.schedule_summary_collections,
            types=self.types,
            workspace_id=self.workspace_id)


def get_workspace_application_schedules(application_key: Optional[builtins.str] = None,
                                        filters: Optional[Sequence[Union['GetWorkspaceApplicationSchedulesFilterArgs', 'GetWorkspaceApplicationSchedulesFilterArgsDict']]] = None,
                                        identifiers: Optional[Sequence[builtins.str]] = None,
                                        keys: Optional[Sequence[builtins.str]] = None,
                                        name: Optional[builtins.str] = None,
                                        types: Optional[Sequence[builtins.str]] = None,
                                        workspace_id: Optional[builtins.str] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWorkspaceApplicationSchedulesResult:
    """
    This data source provides the list of Workspace Application Schedules in Oracle Cloud Infrastructure Data Integration service.

    Use this endpoint to list schedules.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_workspace_application_schedules = oci.DataIntegration.get_workspace_application_schedules(application_key=workspace_application_schedule_application_key,
        workspace_id=test_workspace["id"],
        identifiers=workspace_application_schedule_identifier,
        keys=workspace_application_schedule_key,
        name=workspace_application_schedule_name,
        types=workspace_application_schedule_type)
    ```


    :param builtins.str application_key: The application key.
    :param Sequence[builtins.str] identifiers: Used to filter by the identifier of the object.
    :param Sequence[builtins.str] keys: Used to filter by the key of the object.
    :param builtins.str name: Used to filter by the name of the object.
    :param Sequence[builtins.str] types: Used to filter by the object type of the object. It can be suffixed with an optional filter operator InSubtree. If this operator is not specified, then exact match is considered. <br><br><B>Examples:</B><br> <ul> <li><B>?type=DATA_LOADER_TASK&typeInSubtree=false</B> returns all objects of type data loader task</li> <li><B>?type=DATA_LOADER_TASK</B> returns all objects of type data loader task</li> <li><B>?type=DATA_LOADER_TASK&typeInSubtree=true</B> returns all objects of type data loader task</li> </ul>
    :param builtins.str workspace_id: The workspace ID.
    """
    __args__ = dict()
    __args__['applicationKey'] = application_key
    __args__['filters'] = filters
    __args__['identifiers'] = identifiers
    __args__['keys'] = keys
    __args__['name'] = name
    __args__['types'] = types
    __args__['workspaceId'] = workspace_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:DataIntegration/getWorkspaceApplicationSchedules:getWorkspaceApplicationSchedules', __args__, opts=opts, typ=GetWorkspaceApplicationSchedulesResult).value

    return AwaitableGetWorkspaceApplicationSchedulesResult(
        application_key=pulumi.get(__ret__, 'application_key'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        identifiers=pulumi.get(__ret__, 'identifiers'),
        keys=pulumi.get(__ret__, 'keys'),
        name=pulumi.get(__ret__, 'name'),
        schedule_summary_collections=pulumi.get(__ret__, 'schedule_summary_collections'),
        types=pulumi.get(__ret__, 'types'),
        workspace_id=pulumi.get(__ret__, 'workspace_id'))
def get_workspace_application_schedules_output(application_key: Optional[pulumi.Input[builtins.str]] = None,
                                               filters: Optional[pulumi.Input[Optional[Sequence[Union['GetWorkspaceApplicationSchedulesFilterArgs', 'GetWorkspaceApplicationSchedulesFilterArgsDict']]]]] = None,
                                               identifiers: Optional[pulumi.Input[Optional[Sequence[builtins.str]]]] = None,
                                               keys: Optional[pulumi.Input[Optional[Sequence[builtins.str]]]] = None,
                                               name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                               types: Optional[pulumi.Input[Optional[Sequence[builtins.str]]]] = None,
                                               workspace_id: Optional[pulumi.Input[builtins.str]] = None,
                                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetWorkspaceApplicationSchedulesResult]:
    """
    This data source provides the list of Workspace Application Schedules in Oracle Cloud Infrastructure Data Integration service.

    Use this endpoint to list schedules.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_workspace_application_schedules = oci.DataIntegration.get_workspace_application_schedules(application_key=workspace_application_schedule_application_key,
        workspace_id=test_workspace["id"],
        identifiers=workspace_application_schedule_identifier,
        keys=workspace_application_schedule_key,
        name=workspace_application_schedule_name,
        types=workspace_application_schedule_type)
    ```


    :param builtins.str application_key: The application key.
    :param Sequence[builtins.str] identifiers: Used to filter by the identifier of the object.
    :param Sequence[builtins.str] keys: Used to filter by the key of the object.
    :param builtins.str name: Used to filter by the name of the object.
    :param Sequence[builtins.str] types: Used to filter by the object type of the object. It can be suffixed with an optional filter operator InSubtree. If this operator is not specified, then exact match is considered. <br><br><B>Examples:</B><br> <ul> <li><B>?type=DATA_LOADER_TASK&typeInSubtree=false</B> returns all objects of type data loader task</li> <li><B>?type=DATA_LOADER_TASK</B> returns all objects of type data loader task</li> <li><B>?type=DATA_LOADER_TASK&typeInSubtree=true</B> returns all objects of type data loader task</li> </ul>
    :param builtins.str workspace_id: The workspace ID.
    """
    __args__ = dict()
    __args__['applicationKey'] = application_key
    __args__['filters'] = filters
    __args__['identifiers'] = identifiers
    __args__['keys'] = keys
    __args__['name'] = name
    __args__['types'] = types
    __args__['workspaceId'] = workspace_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:DataIntegration/getWorkspaceApplicationSchedules:getWorkspaceApplicationSchedules', __args__, opts=opts, typ=GetWorkspaceApplicationSchedulesResult)
    return __ret__.apply(lambda __response__: GetWorkspaceApplicationSchedulesResult(
        application_key=pulumi.get(__response__, 'application_key'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        identifiers=pulumi.get(__response__, 'identifiers'),
        keys=pulumi.get(__response__, 'keys'),
        name=pulumi.get(__response__, 'name'),
        schedule_summary_collections=pulumi.get(__response__, 'schedule_summary_collections'),
        types=pulumi.get(__response__, 'types'),
        workspace_id=pulumi.get(__response__, 'workspace_id')))
