# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetAnnotationFormatResult',
    'AwaitableGetAnnotationFormatResult',
    'get_annotation_format',
    'get_annotation_format_output',
]

@pulumi.output_type
class GetAnnotationFormatResult:
    """
    A collection of values returned by getAnnotationFormat.
    """
    def __init__(__self__, compartment_id=None, id=None, items=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetAnnotationFormatItemResult']:
        """
        List of annotation formats.
        """
        return pulumi.get(self, "items")


class AwaitableGetAnnotationFormatResult(GetAnnotationFormatResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAnnotationFormatResult(
            compartment_id=self.compartment_id,
            id=self.id,
            items=self.items)


def get_annotation_format(compartment_id: Optional[builtins.str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAnnotationFormatResult:
    """
    This data source provides details about a specific Annotation Format resource in Oracle Cloud Infrastructure Data Labeling Service service.

    These are a static list in a given region.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_annotation_format = oci.DataLabellingService.get_annotation_format(compartment_id=compartment_id)
    ```


    :param builtins.str compartment_id: The ID of the compartment in which to list resources.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:DataLabellingService/getAnnotationFormat:getAnnotationFormat', __args__, opts=opts, typ=GetAnnotationFormatResult).value

    return AwaitableGetAnnotationFormatResult(
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        id=pulumi.get(__ret__, 'id'),
        items=pulumi.get(__ret__, 'items'))
def get_annotation_format_output(compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetAnnotationFormatResult]:
    """
    This data source provides details about a specific Annotation Format resource in Oracle Cloud Infrastructure Data Labeling Service service.

    These are a static list in a given region.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_annotation_format = oci.DataLabellingService.get_annotation_format(compartment_id=compartment_id)
    ```


    :param builtins.str compartment_id: The ID of the compartment in which to list resources.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:DataLabellingService/getAnnotationFormat:getAnnotationFormat', __args__, opts=opts, typ=GetAnnotationFormatResult)
    return __ret__.apply(lambda __response__: GetAnnotationFormatResult(
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        id=pulumi.get(__response__, 'id'),
        items=pulumi.get(__response__, 'items')))
