# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetDatabaseSecurityConfigResult',
    'AwaitableGetDatabaseSecurityConfigResult',
    'get_database_security_config',
    'get_database_security_config_output',
]

@pulumi.output_type
class GetDatabaseSecurityConfigResult:
    """
    A collection of values returned by getDatabaseSecurityConfig.
    """
    def __init__(__self__, compartment_id=None, database_security_config_id=None, defined_tags=None, description=None, display_name=None, freeform_tags=None, id=None, lifecycle_details=None, refresh_trigger=None, sql_firewall_configs=None, state=None, system_tags=None, target_id=None, time_created=None, time_last_refreshed=None, time_updated=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if database_security_config_id and not isinstance(database_security_config_id, str):
            raise TypeError("Expected argument 'database_security_config_id' to be a str")
        pulumi.set(__self__, "database_security_config_id", database_security_config_id)
        if defined_tags and not isinstance(defined_tags, dict):
            raise TypeError("Expected argument 'defined_tags' to be a dict")
        pulumi.set(__self__, "defined_tags", defined_tags)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if freeform_tags and not isinstance(freeform_tags, dict):
            raise TypeError("Expected argument 'freeform_tags' to be a dict")
        pulumi.set(__self__, "freeform_tags", freeform_tags)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if lifecycle_details and not isinstance(lifecycle_details, str):
            raise TypeError("Expected argument 'lifecycle_details' to be a str")
        pulumi.set(__self__, "lifecycle_details", lifecycle_details)
        if refresh_trigger and not isinstance(refresh_trigger, int):
            raise TypeError("Expected argument 'refresh_trigger' to be a int")
        pulumi.set(__self__, "refresh_trigger", refresh_trigger)
        if sql_firewall_configs and not isinstance(sql_firewall_configs, list):
            raise TypeError("Expected argument 'sql_firewall_configs' to be a list")
        pulumi.set(__self__, "sql_firewall_configs", sql_firewall_configs)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)
        if system_tags and not isinstance(system_tags, dict):
            raise TypeError("Expected argument 'system_tags' to be a dict")
        pulumi.set(__self__, "system_tags", system_tags)
        if target_id and not isinstance(target_id, str):
            raise TypeError("Expected argument 'target_id' to be a str")
        pulumi.set(__self__, "target_id", target_id)
        if time_created and not isinstance(time_created, str):
            raise TypeError("Expected argument 'time_created' to be a str")
        pulumi.set(__self__, "time_created", time_created)
        if time_last_refreshed and not isinstance(time_last_refreshed, str):
            raise TypeError("Expected argument 'time_last_refreshed' to be a str")
        pulumi.set(__self__, "time_last_refreshed", time_last_refreshed)
        if time_updated and not isinstance(time_updated, str):
            raise TypeError("Expected argument 'time_updated' to be a str")
        pulumi.set(__self__, "time_updated", time_updated)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        """
        The OCID of the compartment containing the database security config.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="databaseSecurityConfigId")
    def database_security_config_id(self) -> builtins.str:
        return pulumi.get(self, "database_security_config_id")

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> Mapping[str, builtins.str]:
        """
        Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm) Example: `{"Operations.CostCenter": "42"}`
        """
        return pulumi.get(self, "defined_tags")

    @property
    @pulumi.getter
    def description(self) -> builtins.str:
        """
        The description of the database security config.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> builtins.str:
        """
        The display name of the database security config.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> Mapping[str, builtins.str]:
        """
        Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm)  Example: `{"Department": "Finance"}`
        """
        return pulumi.get(self, "freeform_tags")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The OCID of the database security config.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="lifecycleDetails")
    def lifecycle_details(self) -> builtins.str:
        """
        Details about the current state of the database security config in Data Safe.
        """
        return pulumi.get(self, "lifecycle_details")

    @property
    @pulumi.getter(name="refreshTrigger")
    def refresh_trigger(self) -> builtins.int:
        return pulumi.get(self, "refresh_trigger")

    @property
    @pulumi.getter(name="sqlFirewallConfigs")
    def sql_firewall_configs(self) -> Sequence['outputs.GetDatabaseSecurityConfigSqlFirewallConfigResult']:
        """
        The SQL Firewall related configurations.
        """
        return pulumi.get(self, "sql_firewall_configs")

    @property
    @pulumi.getter
    def state(self) -> builtins.str:
        """
        The current state of the database security config.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter(name="systemTags")
    def system_tags(self) -> Mapping[str, builtins.str]:
        """
        System tags for this resource. Each key is predefined and scoped to a namespace. For more information, see Resource Tags. Example: `{"orcl-cloud.free-tier-retained": "true"}`
        """
        return pulumi.get(self, "system_tags")

    @property
    @pulumi.getter(name="targetId")
    def target_id(self) -> builtins.str:
        """
        The target OCID corresponding to the database security config.
        """
        return pulumi.get(self, "target_id")

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> builtins.str:
        """
        The time that the database security config was created, in the format defined by RFC3339.
        """
        return pulumi.get(self, "time_created")

    @property
    @pulumi.getter(name="timeLastRefreshed")
    def time_last_refreshed(self) -> builtins.str:
        """
        The last date and time the database security config was refreshed, in the format defined by RFC3339.
        """
        return pulumi.get(self, "time_last_refreshed")

    @property
    @pulumi.getter(name="timeUpdated")
    def time_updated(self) -> builtins.str:
        """
        The date and time the database security configuration was last updated, in the format defined by RFC3339.
        """
        return pulumi.get(self, "time_updated")


class AwaitableGetDatabaseSecurityConfigResult(GetDatabaseSecurityConfigResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDatabaseSecurityConfigResult(
            compartment_id=self.compartment_id,
            database_security_config_id=self.database_security_config_id,
            defined_tags=self.defined_tags,
            description=self.description,
            display_name=self.display_name,
            freeform_tags=self.freeform_tags,
            id=self.id,
            lifecycle_details=self.lifecycle_details,
            refresh_trigger=self.refresh_trigger,
            sql_firewall_configs=self.sql_firewall_configs,
            state=self.state,
            system_tags=self.system_tags,
            target_id=self.target_id,
            time_created=self.time_created,
            time_last_refreshed=self.time_last_refreshed,
            time_updated=self.time_updated)


def get_database_security_config(database_security_config_id: Optional[builtins.str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDatabaseSecurityConfigResult:
    """
    This data source provides details about a specific Database Security Config resource in Oracle Cloud Infrastructure Data Safe service.

    Gets a database security configuration by identifier.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_database_security_config = oci.DataSafe.get_database_security_config(database_security_config_id=test_database_security_config_oci_data_safe_database_security_config["id"])
    ```


    :param builtins.str database_security_config_id: The OCID of the database security configuration resource.
    """
    __args__ = dict()
    __args__['databaseSecurityConfigId'] = database_security_config_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:DataSafe/getDatabaseSecurityConfig:getDatabaseSecurityConfig', __args__, opts=opts, typ=GetDatabaseSecurityConfigResult).value

    return AwaitableGetDatabaseSecurityConfigResult(
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        database_security_config_id=pulumi.get(__ret__, 'database_security_config_id'),
        defined_tags=pulumi.get(__ret__, 'defined_tags'),
        description=pulumi.get(__ret__, 'description'),
        display_name=pulumi.get(__ret__, 'display_name'),
        freeform_tags=pulumi.get(__ret__, 'freeform_tags'),
        id=pulumi.get(__ret__, 'id'),
        lifecycle_details=pulumi.get(__ret__, 'lifecycle_details'),
        refresh_trigger=pulumi.get(__ret__, 'refresh_trigger'),
        sql_firewall_configs=pulumi.get(__ret__, 'sql_firewall_configs'),
        state=pulumi.get(__ret__, 'state'),
        system_tags=pulumi.get(__ret__, 'system_tags'),
        target_id=pulumi.get(__ret__, 'target_id'),
        time_created=pulumi.get(__ret__, 'time_created'),
        time_last_refreshed=pulumi.get(__ret__, 'time_last_refreshed'),
        time_updated=pulumi.get(__ret__, 'time_updated'))
def get_database_security_config_output(database_security_config_id: Optional[pulumi.Input[builtins.str]] = None,
                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetDatabaseSecurityConfigResult]:
    """
    This data source provides details about a specific Database Security Config resource in Oracle Cloud Infrastructure Data Safe service.

    Gets a database security configuration by identifier.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_database_security_config = oci.DataSafe.get_database_security_config(database_security_config_id=test_database_security_config_oci_data_safe_database_security_config["id"])
    ```


    :param builtins.str database_security_config_id: The OCID of the database security configuration resource.
    """
    __args__ = dict()
    __args__['databaseSecurityConfigId'] = database_security_config_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:DataSafe/getDatabaseSecurityConfig:getDatabaseSecurityConfig', __args__, opts=opts, typ=GetDatabaseSecurityConfigResult)
    return __ret__.apply(lambda __response__: GetDatabaseSecurityConfigResult(
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        database_security_config_id=pulumi.get(__response__, 'database_security_config_id'),
        defined_tags=pulumi.get(__response__, 'defined_tags'),
        description=pulumi.get(__response__, 'description'),
        display_name=pulumi.get(__response__, 'display_name'),
        freeform_tags=pulumi.get(__response__, 'freeform_tags'),
        id=pulumi.get(__response__, 'id'),
        lifecycle_details=pulumi.get(__response__, 'lifecycle_details'),
        refresh_trigger=pulumi.get(__response__, 'refresh_trigger'),
        sql_firewall_configs=pulumi.get(__response__, 'sql_firewall_configs'),
        state=pulumi.get(__response__, 'state'),
        system_tags=pulumi.get(__response__, 'system_tags'),
        target_id=pulumi.get(__response__, 'target_id'),
        time_created=pulumi.get(__response__, 'time_created'),
        time_last_refreshed=pulumi.get(__response__, 'time_last_refreshed'),
        time_updated=pulumi.get(__response__, 'time_updated')))
