# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetReportContentResult',
    'AwaitableGetReportContentResult',
    'get_report_content',
    'get_report_content_output',
]

@pulumi.output_type
class GetReportContentResult:
    """
    A collection of values returned by getReportContent.
    """
    def __init__(__self__, id=None, report_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if report_id and not isinstance(report_id, str):
            raise TypeError("Expected argument 'report_id' to be a str")
        pulumi.set(__self__, "report_id", report_id)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="reportId")
    def report_id(self) -> builtins.str:
        return pulumi.get(self, "report_id")


class AwaitableGetReportContentResult(GetReportContentResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetReportContentResult(
            id=self.id,
            report_id=self.report_id)


def get_report_content(report_id: Optional[builtins.str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetReportContentResult:
    """
    This data source provides details about a specific Report Content resource in Oracle Cloud Infrastructure Data Safe service.

    Downloads the specified report in the form of .xls or .pdf.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_report_content = oci.DataSafe.get_report_content(report_id=test_report["id"])
    ```


    :param builtins.str report_id: Unique report identifier
    """
    __args__ = dict()
    __args__['reportId'] = report_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:DataSafe/getReportContent:getReportContent', __args__, opts=opts, typ=GetReportContentResult).value

    return AwaitableGetReportContentResult(
        id=pulumi.get(__ret__, 'id'),
        report_id=pulumi.get(__ret__, 'report_id'))
def get_report_content_output(report_id: Optional[pulumi.Input[builtins.str]] = None,
                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetReportContentResult]:
    """
    This data source provides details about a specific Report Content resource in Oracle Cloud Infrastructure Data Safe service.

    Downloads the specified report in the form of .xls or .pdf.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_report_content = oci.DataSafe.get_report_content(report_id=test_report["id"])
    ```


    :param builtins.str report_id: Unique report identifier
    """
    __args__ = dict()
    __args__['reportId'] = report_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:DataSafe/getReportContent:getReportContent', __args__, opts=opts, typ=GetReportContentResult)
    return __ret__.apply(lambda __response__: GetReportContentResult(
        id=pulumi.get(__response__, 'id'),
        report_id=pulumi.get(__response__, 'report_id')))
