# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetSensitiveTypesExportResult',
    'AwaitableGetSensitiveTypesExportResult',
    'get_sensitive_types_export',
    'get_sensitive_types_export_output',
]

@pulumi.output_type
class GetSensitiveTypesExportResult:
    """
    A collection of values returned by getSensitiveTypesExport.
    """
    def __init__(__self__, compartment_id=None, defined_tags=None, description=None, display_name=None, freeform_tags=None, id=None, is_include_all_sensitive_types=None, sensitive_type_ids_for_exports=None, sensitive_types_export_id=None, state=None, system_tags=None, time_created=None, time_updated=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if defined_tags and not isinstance(defined_tags, dict):
            raise TypeError("Expected argument 'defined_tags' to be a dict")
        pulumi.set(__self__, "defined_tags", defined_tags)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if freeform_tags and not isinstance(freeform_tags, dict):
            raise TypeError("Expected argument 'freeform_tags' to be a dict")
        pulumi.set(__self__, "freeform_tags", freeform_tags)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if is_include_all_sensitive_types and not isinstance(is_include_all_sensitive_types, bool):
            raise TypeError("Expected argument 'is_include_all_sensitive_types' to be a bool")
        pulumi.set(__self__, "is_include_all_sensitive_types", is_include_all_sensitive_types)
        if sensitive_type_ids_for_exports and not isinstance(sensitive_type_ids_for_exports, list):
            raise TypeError("Expected argument 'sensitive_type_ids_for_exports' to be a list")
        pulumi.set(__self__, "sensitive_type_ids_for_exports", sensitive_type_ids_for_exports)
        if sensitive_types_export_id and not isinstance(sensitive_types_export_id, str):
            raise TypeError("Expected argument 'sensitive_types_export_id' to be a str")
        pulumi.set(__self__, "sensitive_types_export_id", sensitive_types_export_id)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)
        if system_tags and not isinstance(system_tags, dict):
            raise TypeError("Expected argument 'system_tags' to be a dict")
        pulumi.set(__self__, "system_tags", system_tags)
        if time_created and not isinstance(time_created, str):
            raise TypeError("Expected argument 'time_created' to be a str")
        pulumi.set(__self__, "time_created", time_created)
        if time_updated and not isinstance(time_updated, str):
            raise TypeError("Expected argument 'time_updated' to be a str")
        pulumi.set(__self__, "time_updated", time_updated)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        """
        The OCID of the compartment that contains the sensitive types export.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> Mapping[str, builtins.str]:
        """
        Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm) Example: `{"Operations.CostCenter": "42"}`
        """
        return pulumi.get(self, "defined_tags")

    @property
    @pulumi.getter
    def description(self) -> builtins.str:
        """
        The description of the sensitive types export.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> builtins.str:
        """
        The display name of the sensitive types export.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> Mapping[str, builtins.str]:
        """
        Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm)  Example: `{"Department": "Finance"}`
        """
        return pulumi.get(self, "freeform_tags")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The OCID of the sensitive types export.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="isIncludeAllSensitiveTypes")
    def is_include_all_sensitive_types(self) -> builtins.bool:
        """
        Indicates if all the existing user-defined sensitive types are used for export. If it's set to true, the sensitiveTypeIdsForExport attribute is ignored and all user-defined sensitive types are exported.
        """
        return pulumi.get(self, "is_include_all_sensitive_types")

    @property
    @pulumi.getter(name="sensitiveTypeIdsForExports")
    def sensitive_type_ids_for_exports(self) -> Sequence[builtins.str]:
        """
        The OCIDs of the sensitive types used to create sensitive types export.
        """
        return pulumi.get(self, "sensitive_type_ids_for_exports")

    @property
    @pulumi.getter(name="sensitiveTypesExportId")
    def sensitive_types_export_id(self) -> builtins.str:
        return pulumi.get(self, "sensitive_types_export_id")

    @property
    @pulumi.getter
    def state(self) -> builtins.str:
        """
        The current state of the sensitive types export.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter(name="systemTags")
    def system_tags(self) -> Mapping[str, builtins.str]:
        """
        System tags for this resource. Each key is predefined and scoped to a namespace. For more information, see Resource Tags. Example: `{"orcl-cloud.free-tier-retained": "true"}`
        """
        return pulumi.get(self, "system_tags")

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> builtins.str:
        """
        The date and time the sensitive types export was created, in the format defined by [RFC3339](https://tools.ietf.org/html/rfc3339).
        """
        return pulumi.get(self, "time_created")

    @property
    @pulumi.getter(name="timeUpdated")
    def time_updated(self) -> builtins.str:
        """
        The date and time the sensitive types export was last updated, in the format defined by [RFC3339](https://tools.ietf.org/html/rfc3339).
        """
        return pulumi.get(self, "time_updated")


class AwaitableGetSensitiveTypesExportResult(GetSensitiveTypesExportResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSensitiveTypesExportResult(
            compartment_id=self.compartment_id,
            defined_tags=self.defined_tags,
            description=self.description,
            display_name=self.display_name,
            freeform_tags=self.freeform_tags,
            id=self.id,
            is_include_all_sensitive_types=self.is_include_all_sensitive_types,
            sensitive_type_ids_for_exports=self.sensitive_type_ids_for_exports,
            sensitive_types_export_id=self.sensitive_types_export_id,
            state=self.state,
            system_tags=self.system_tags,
            time_created=self.time_created,
            time_updated=self.time_updated)


def get_sensitive_types_export(sensitive_types_export_id: Optional[builtins.str] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSensitiveTypesExportResult:
    """
    This data source provides details about a specific Sensitive Types Export resource in Oracle Cloud Infrastructure Data Safe service.

    Gets the details of the specified sensitive types export by identifier.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_sensitive_types_export = oci.DataSafe.get_sensitive_types_export(sensitive_types_export_id=test_sensitive_types_export_oci_data_safe_sensitive_types_export["id"])
    ```


    :param builtins.str sensitive_types_export_id: The OCID of the sensitive types export.
    """
    __args__ = dict()
    __args__['sensitiveTypesExportId'] = sensitive_types_export_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:DataSafe/getSensitiveTypesExport:getSensitiveTypesExport', __args__, opts=opts, typ=GetSensitiveTypesExportResult).value

    return AwaitableGetSensitiveTypesExportResult(
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        defined_tags=pulumi.get(__ret__, 'defined_tags'),
        description=pulumi.get(__ret__, 'description'),
        display_name=pulumi.get(__ret__, 'display_name'),
        freeform_tags=pulumi.get(__ret__, 'freeform_tags'),
        id=pulumi.get(__ret__, 'id'),
        is_include_all_sensitive_types=pulumi.get(__ret__, 'is_include_all_sensitive_types'),
        sensitive_type_ids_for_exports=pulumi.get(__ret__, 'sensitive_type_ids_for_exports'),
        sensitive_types_export_id=pulumi.get(__ret__, 'sensitive_types_export_id'),
        state=pulumi.get(__ret__, 'state'),
        system_tags=pulumi.get(__ret__, 'system_tags'),
        time_created=pulumi.get(__ret__, 'time_created'),
        time_updated=pulumi.get(__ret__, 'time_updated'))
def get_sensitive_types_export_output(sensitive_types_export_id: Optional[pulumi.Input[builtins.str]] = None,
                                      opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetSensitiveTypesExportResult]:
    """
    This data source provides details about a specific Sensitive Types Export resource in Oracle Cloud Infrastructure Data Safe service.

    Gets the details of the specified sensitive types export by identifier.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_sensitive_types_export = oci.DataSafe.get_sensitive_types_export(sensitive_types_export_id=test_sensitive_types_export_oci_data_safe_sensitive_types_export["id"])
    ```


    :param builtins.str sensitive_types_export_id: The OCID of the sensitive types export.
    """
    __args__ = dict()
    __args__['sensitiveTypesExportId'] = sensitive_types_export_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:DataSafe/getSensitiveTypesExport:getSensitiveTypesExport', __args__, opts=opts, typ=GetSensitiveTypesExportResult)
    return __ret__.apply(lambda __response__: GetSensitiveTypesExportResult(
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        defined_tags=pulumi.get(__response__, 'defined_tags'),
        description=pulumi.get(__response__, 'description'),
        display_name=pulumi.get(__response__, 'display_name'),
        freeform_tags=pulumi.get(__response__, 'freeform_tags'),
        id=pulumi.get(__response__, 'id'),
        is_include_all_sensitive_types=pulumi.get(__response__, 'is_include_all_sensitive_types'),
        sensitive_type_ids_for_exports=pulumi.get(__response__, 'sensitive_type_ids_for_exports'),
        sensitive_types_export_id=pulumi.get(__response__, 'sensitive_types_export_id'),
        state=pulumi.get(__response__, 'state'),
        system_tags=pulumi.get(__response__, 'system_tags'),
        time_created=pulumi.get(__response__, 'time_created'),
        time_updated=pulumi.get(__response__, 'time_updated')))
