# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = ['UnsetSecurityAssessmentBaselineManagementArgs', 'UnsetSecurityAssessmentBaselineManagement']

@pulumi.input_type
class UnsetSecurityAssessmentBaselineManagementArgs:
    def __init__(__self__, *,
                 compartment_id: pulumi.Input[builtins.str],
                 security_assessment_id: pulumi.Input[builtins.str]):
        """
        The set of arguments for constructing a UnsetSecurityAssessmentBaselineManagement resource.
        :param pulumi.Input[builtins.str] compartment_id: The compartment OCID where the assessment resides.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        :param pulumi.Input[builtins.str] security_assessment_id: The OCID of the security assessment.
        """
        pulumi.set(__self__, "compartment_id", compartment_id)
        pulumi.set(__self__, "security_assessment_id", security_assessment_id)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> pulumi.Input[builtins.str]:
        """
        The compartment OCID where the assessment resides.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "compartment_id")

    @compartment_id.setter
    def compartment_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "compartment_id", value)

    @property
    @pulumi.getter(name="securityAssessmentId")
    def security_assessment_id(self) -> pulumi.Input[builtins.str]:
        """
        The OCID of the security assessment.
        """
        return pulumi.get(self, "security_assessment_id")

    @security_assessment_id.setter
    def security_assessment_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "security_assessment_id", value)


@pulumi.input_type
class _UnsetSecurityAssessmentBaselineManagementState:
    def __init__(__self__, *,
                 compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 security_assessment_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering UnsetSecurityAssessmentBaselineManagement resources.
        :param pulumi.Input[builtins.str] compartment_id: The compartment OCID where the assessment resides.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        :param pulumi.Input[builtins.str] security_assessment_id: The OCID of the security assessment.
        """
        if compartment_id is not None:
            pulumi.set(__self__, "compartment_id", compartment_id)
        if security_assessment_id is not None:
            pulumi.set(__self__, "security_assessment_id", security_assessment_id)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The compartment OCID where the assessment resides.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "compartment_id")

    @compartment_id.setter
    def compartment_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "compartment_id", value)

    @property
    @pulumi.getter(name="securityAssessmentId")
    def security_assessment_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The OCID of the security assessment.
        """
        return pulumi.get(self, "security_assessment_id")

    @security_assessment_id.setter
    def security_assessment_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "security_assessment_id", value)


@pulumi.type_token("oci:DataSafe/unsetSecurityAssessmentBaselineManagement:UnsetSecurityAssessmentBaselineManagement")
class UnsetSecurityAssessmentBaselineManagement(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 security_assessment_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        This resource provides the Unset Security Assessment Baseline management resource in Oracle Cloud Infrastructure Data Safe service.

        Removes the baseline setting for the saved security assessment as the baseline in the compartment where the the specified assessment resides.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_unset_security_assessment_baseline_management = oci.data_safe.UnsetSecurityAssessmentBaselineManagement("test_unset_security_assessment_baseline_management",
            security_assessment_id=test_set_security_assessment_baseline_management["securityAssessmentId"],
            compartment_id=comaprtment_id)
        ```

        ## Import

        UnsetSecurityAssessmentBaselineManagement can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:DataSafe/unsetSecurityAssessmentBaselineManagement:UnsetSecurityAssessmentBaselineManagement test_unset_security_assessment_baseline_management "id"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] compartment_id: The compartment OCID where the assessment resides.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        :param pulumi.Input[builtins.str] security_assessment_id: The OCID of the security assessment.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: UnsetSecurityAssessmentBaselineManagementArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource provides the Unset Security Assessment Baseline management resource in Oracle Cloud Infrastructure Data Safe service.

        Removes the baseline setting for the saved security assessment as the baseline in the compartment where the the specified assessment resides.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_unset_security_assessment_baseline_management = oci.data_safe.UnsetSecurityAssessmentBaselineManagement("test_unset_security_assessment_baseline_management",
            security_assessment_id=test_set_security_assessment_baseline_management["securityAssessmentId"],
            compartment_id=comaprtment_id)
        ```

        ## Import

        UnsetSecurityAssessmentBaselineManagement can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:DataSafe/unsetSecurityAssessmentBaselineManagement:UnsetSecurityAssessmentBaselineManagement test_unset_security_assessment_baseline_management "id"
        ```

        :param str resource_name: The name of the resource.
        :param UnsetSecurityAssessmentBaselineManagementArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(UnsetSecurityAssessmentBaselineManagementArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 security_assessment_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = UnsetSecurityAssessmentBaselineManagementArgs.__new__(UnsetSecurityAssessmentBaselineManagementArgs)

            if compartment_id is None and not opts.urn:
                raise TypeError("Missing required property 'compartment_id'")
            __props__.__dict__["compartment_id"] = compartment_id
            if security_assessment_id is None and not opts.urn:
                raise TypeError("Missing required property 'security_assessment_id'")
            __props__.__dict__["security_assessment_id"] = security_assessment_id
        super(UnsetSecurityAssessmentBaselineManagement, __self__).__init__(
            'oci:DataSafe/unsetSecurityAssessmentBaselineManagement:UnsetSecurityAssessmentBaselineManagement',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            compartment_id: Optional[pulumi.Input[builtins.str]] = None,
            security_assessment_id: Optional[pulumi.Input[builtins.str]] = None) -> 'UnsetSecurityAssessmentBaselineManagement':
        """
        Get an existing UnsetSecurityAssessmentBaselineManagement resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] compartment_id: The compartment OCID where the assessment resides.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        :param pulumi.Input[builtins.str] security_assessment_id: The OCID of the security assessment.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _UnsetSecurityAssessmentBaselineManagementState.__new__(_UnsetSecurityAssessmentBaselineManagementState)

        __props__.__dict__["compartment_id"] = compartment_id
        __props__.__dict__["security_assessment_id"] = security_assessment_id
        return UnsetSecurityAssessmentBaselineManagement(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> pulumi.Output[builtins.str]:
        """
        The compartment OCID where the assessment resides.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="securityAssessmentId")
    def security_assessment_id(self) -> pulumi.Output[builtins.str]:
        """
        The OCID of the security assessment.
        """
        return pulumi.get(self, "security_assessment_id")

