# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetRrsetsResult',
    'AwaitableGetRrsetsResult',
    'get_rrsets',
    'get_rrsets_output',
]

@pulumi.output_type
class GetRrsetsResult:
    """
    A collection of values returned by getRrsets.
    """
    def __init__(__self__, domain=None, domain_contains=None, filters=None, id=None, rrsets=None, rtype=None, scope=None, view_id=None, zone_name_or_id=None):
        if domain and not isinstance(domain, str):
            raise TypeError("Expected argument 'domain' to be a str")
        pulumi.set(__self__, "domain", domain)
        if domain_contains and not isinstance(domain_contains, str):
            raise TypeError("Expected argument 'domain_contains' to be a str")
        pulumi.set(__self__, "domain_contains", domain_contains)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if rrsets and not isinstance(rrsets, list):
            raise TypeError("Expected argument 'rrsets' to be a list")
        pulumi.set(__self__, "rrsets", rrsets)
        if rtype and not isinstance(rtype, str):
            raise TypeError("Expected argument 'rtype' to be a str")
        pulumi.set(__self__, "rtype", rtype)
        if scope and not isinstance(scope, str):
            raise TypeError("Expected argument 'scope' to be a str")
        pulumi.set(__self__, "scope", scope)
        if view_id and not isinstance(view_id, str):
            raise TypeError("Expected argument 'view_id' to be a str")
        pulumi.set(__self__, "view_id", view_id)
        if zone_name_or_id and not isinstance(zone_name_or_id, str):
            raise TypeError("Expected argument 'zone_name_or_id' to be a str")
        pulumi.set(__self__, "zone_name_or_id", zone_name_or_id)

    @property
    @pulumi.getter
    def domain(self) -> Optional[builtins.str]:
        """
        The fully qualified domain name where the record can be located.
        """
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter(name="domainContains")
    def domain_contains(self) -> Optional[builtins.str]:
        return pulumi.get(self, "domain_contains")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetRrsetsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def rrsets(self) -> Sequence['outputs.GetRrsetsRrsetResult']:
        """
        The list of rrsets.
        """
        return pulumi.get(self, "rrsets")

    @property
    @pulumi.getter
    def rtype(self) -> Optional[builtins.str]:
        """
        The type of DNS record, such as A or CNAME. For more information, see [Resource Record (RR) TYPEs](https://www.iana.org/assignments/dns-parameters/dns-parameters.xhtml#dns-parameters-4).
        """
        return pulumi.get(self, "rtype")

    @property
    @pulumi.getter
    def scope(self) -> Optional[builtins.str]:
        return pulumi.get(self, "scope")

    @property
    @pulumi.getter(name="viewId")
    def view_id(self) -> Optional[builtins.str]:
        return pulumi.get(self, "view_id")

    @property
    @pulumi.getter(name="zoneNameOrId")
    def zone_name_or_id(self) -> builtins.str:
        return pulumi.get(self, "zone_name_or_id")


class AwaitableGetRrsetsResult(GetRrsetsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRrsetsResult(
            domain=self.domain,
            domain_contains=self.domain_contains,
            filters=self.filters,
            id=self.id,
            rrsets=self.rrsets,
            rtype=self.rtype,
            scope=self.scope,
            view_id=self.view_id,
            zone_name_or_id=self.zone_name_or_id)


def get_rrsets(domain: Optional[builtins.str] = None,
               domain_contains: Optional[builtins.str] = None,
               filters: Optional[Sequence[Union['GetRrsetsFilterArgs', 'GetRrsetsFilterArgsDict']]] = None,
               rtype: Optional[builtins.str] = None,
               scope: Optional[builtins.str] = None,
               view_id: Optional[builtins.str] = None,
               zone_name_or_id: Optional[builtins.str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRrsetsResult:
    """
    This data source provides the list of RRsets in Oracle Cloud Infrastructure DNS service.

    Gets a list of all rrsets in the specified zone.

    You can optionally filter the results using the listed parameters. When the zone name
    is provided as a path parameter and `PRIVATE` is used for the scope query parameter then
    the viewId parameter is required.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_rrsets = oci.Dns.get_rrsets(zone_name_or_id=test_zone["id"],
        domain=rrset_domain,
        domain_contains=rrset_domain,
        rtype=rrset_rtype,
        scope=rrset_scope,
        view_id=test_view["id"])
    ```


    :param builtins.str domain: The target fully-qualified domain name (FQDN) within the target zone.
    :param builtins.str domain_contains: Matches any rrset whose fully-qualified domain name (FQDN) contains the provided value.
    :param builtins.str rtype: Search by record type. Will match any record whose [type](https://www.iana.org/assignments/dns-parameters/dns-parameters.xhtml#dns-parameters-4) (case-insensitive) equals the provided value.
    :param builtins.str scope: Specifies to operate only on resources that have a matching DNS scope.
    :param builtins.str view_id: The OCID of the view the zone is associated with. Required when accessing a private zone by name.
    :param builtins.str zone_name_or_id: The name or OCID of the target zone.
    """
    __args__ = dict()
    __args__['domain'] = domain
    __args__['domainContains'] = domain_contains
    __args__['filters'] = filters
    __args__['rtype'] = rtype
    __args__['scope'] = scope
    __args__['viewId'] = view_id
    __args__['zoneNameOrId'] = zone_name_or_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Dns/getRrsets:getRrsets', __args__, opts=opts, typ=GetRrsetsResult).value

    return AwaitableGetRrsetsResult(
        domain=pulumi.get(__ret__, 'domain'),
        domain_contains=pulumi.get(__ret__, 'domain_contains'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        rrsets=pulumi.get(__ret__, 'rrsets'),
        rtype=pulumi.get(__ret__, 'rtype'),
        scope=pulumi.get(__ret__, 'scope'),
        view_id=pulumi.get(__ret__, 'view_id'),
        zone_name_or_id=pulumi.get(__ret__, 'zone_name_or_id'))
def get_rrsets_output(domain: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                      domain_contains: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                      filters: Optional[pulumi.Input[Optional[Sequence[Union['GetRrsetsFilterArgs', 'GetRrsetsFilterArgsDict']]]]] = None,
                      rtype: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                      scope: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                      view_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                      zone_name_or_id: Optional[pulumi.Input[builtins.str]] = None,
                      opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetRrsetsResult]:
    """
    This data source provides the list of RRsets in Oracle Cloud Infrastructure DNS service.

    Gets a list of all rrsets in the specified zone.

    You can optionally filter the results using the listed parameters. When the zone name
    is provided as a path parameter and `PRIVATE` is used for the scope query parameter then
    the viewId parameter is required.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_rrsets = oci.Dns.get_rrsets(zone_name_or_id=test_zone["id"],
        domain=rrset_domain,
        domain_contains=rrset_domain,
        rtype=rrset_rtype,
        scope=rrset_scope,
        view_id=test_view["id"])
    ```


    :param builtins.str domain: The target fully-qualified domain name (FQDN) within the target zone.
    :param builtins.str domain_contains: Matches any rrset whose fully-qualified domain name (FQDN) contains the provided value.
    :param builtins.str rtype: Search by record type. Will match any record whose [type](https://www.iana.org/assignments/dns-parameters/dns-parameters.xhtml#dns-parameters-4) (case-insensitive) equals the provided value.
    :param builtins.str scope: Specifies to operate only on resources that have a matching DNS scope.
    :param builtins.str view_id: The OCID of the view the zone is associated with. Required when accessing a private zone by name.
    :param builtins.str zone_name_or_id: The name or OCID of the target zone.
    """
    __args__ = dict()
    __args__['domain'] = domain
    __args__['domainContains'] = domain_contains
    __args__['filters'] = filters
    __args__['rtype'] = rtype
    __args__['scope'] = scope
    __args__['viewId'] = view_id
    __args__['zoneNameOrId'] = zone_name_or_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Dns/getRrsets:getRrsets', __args__, opts=opts, typ=GetRrsetsResult)
    return __ret__.apply(lambda __response__: GetRrsetsResult(
        domain=pulumi.get(__response__, 'domain'),
        domain_contains=pulumi.get(__response__, 'domain_contains'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        rrsets=pulumi.get(__response__, 'rrsets'),
        rtype=pulumi.get(__response__, 'rtype'),
        scope=pulumi.get(__response__, 'scope'),
        view_id=pulumi.get(__response__, 'view_id'),
        zone_name_or_id=pulumi.get(__response__, 'zone_name_or_id')))
