# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetFusionEnvironmentFamilySubscriptionDetailResult',
    'AwaitableGetFusionEnvironmentFamilySubscriptionDetailResult',
    'get_fusion_environment_family_subscription_detail',
    'get_fusion_environment_family_subscription_detail_output',
]

@pulumi.output_type
class GetFusionEnvironmentFamilySubscriptionDetailResult:
    """
    A collection of values returned by getFusionEnvironmentFamilySubscriptionDetail.
    """
    def __init__(__self__, fusion_environment_family_id=None, id=None, subscriptions=None):
        if fusion_environment_family_id and not isinstance(fusion_environment_family_id, str):
            raise TypeError("Expected argument 'fusion_environment_family_id' to be a str")
        pulumi.set(__self__, "fusion_environment_family_id", fusion_environment_family_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if subscriptions and not isinstance(subscriptions, list):
            raise TypeError("Expected argument 'subscriptions' to be a list")
        pulumi.set(__self__, "subscriptions", subscriptions)

    @property
    @pulumi.getter(name="fusionEnvironmentFamilyId")
    def fusion_environment_family_id(self) -> builtins.str:
        return pulumi.get(self, "fusion_environment_family_id")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def subscriptions(self) -> Sequence['outputs.GetFusionEnvironmentFamilySubscriptionDetailSubscriptionResult']:
        """
        List of subscriptions.
        """
        return pulumi.get(self, "subscriptions")


class AwaitableGetFusionEnvironmentFamilySubscriptionDetailResult(GetFusionEnvironmentFamilySubscriptionDetailResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFusionEnvironmentFamilySubscriptionDetailResult(
            fusion_environment_family_id=self.fusion_environment_family_id,
            id=self.id,
            subscriptions=self.subscriptions)


def get_fusion_environment_family_subscription_detail(fusion_environment_family_id: Optional[builtins.str] = None,
                                                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFusionEnvironmentFamilySubscriptionDetailResult:
    """
    This data source provides details about a specific Fusion Environment Family Subscription Detail resource in Oracle Cloud Infrastructure Fusion Apps service.

    Gets the subscription details of an fusion environment family.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_fusion_environment_family_subscription_detail = oci.Functions.get_fusion_environment_family_subscription_detail(fusion_environment_family_id=test_fusion_environment_family["id"])
    ```


    :param builtins.str fusion_environment_family_id: The unique identifier (OCID) of the FusionEnvironmentFamily.
    """
    __args__ = dict()
    __args__['fusionEnvironmentFamilyId'] = fusion_environment_family_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Functions/getFusionEnvironmentFamilySubscriptionDetail:getFusionEnvironmentFamilySubscriptionDetail', __args__, opts=opts, typ=GetFusionEnvironmentFamilySubscriptionDetailResult).value

    return AwaitableGetFusionEnvironmentFamilySubscriptionDetailResult(
        fusion_environment_family_id=pulumi.get(__ret__, 'fusion_environment_family_id'),
        id=pulumi.get(__ret__, 'id'),
        subscriptions=pulumi.get(__ret__, 'subscriptions'))
def get_fusion_environment_family_subscription_detail_output(fusion_environment_family_id: Optional[pulumi.Input[builtins.str]] = None,
                                                             opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetFusionEnvironmentFamilySubscriptionDetailResult]:
    """
    This data source provides details about a specific Fusion Environment Family Subscription Detail resource in Oracle Cloud Infrastructure Fusion Apps service.

    Gets the subscription details of an fusion environment family.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_fusion_environment_family_subscription_detail = oci.Functions.get_fusion_environment_family_subscription_detail(fusion_environment_family_id=test_fusion_environment_family["id"])
    ```


    :param builtins.str fusion_environment_family_id: The unique identifier (OCID) of the FusionEnvironmentFamily.
    """
    __args__ = dict()
    __args__['fusionEnvironmentFamilyId'] = fusion_environment_family_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Functions/getFusionEnvironmentFamilySubscriptionDetail:getFusionEnvironmentFamilySubscriptionDetail', __args__, opts=opts, typ=GetFusionEnvironmentFamilySubscriptionDetailResult)
    return __ret__.apply(lambda __response__: GetFusionEnvironmentFamilySubscriptionDetailResult(
        fusion_environment_family_id=pulumi.get(__response__, 'fusion_environment_family_id'),
        id=pulumi.get(__response__, 'id'),
        subscriptions=pulumi.get(__response__, 'subscriptions')))
