# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetFusionEnvironmentRefreshActivitiesResult',
    'AwaitableGetFusionEnvironmentRefreshActivitiesResult',
    'get_fusion_environment_refresh_activities',
    'get_fusion_environment_refresh_activities_output',
]

@pulumi.output_type
class GetFusionEnvironmentRefreshActivitiesResult:
    """
    A collection of values returned by getFusionEnvironmentRefreshActivities.
    """
    def __init__(__self__, display_name=None, filters=None, fusion_environment_id=None, id=None, refresh_activity_collections=None, state=None, time_expected_finish_less_than_or_equal_to=None, time_scheduled_start_greater_than_or_equal_to=None):
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if fusion_environment_id and not isinstance(fusion_environment_id, str):
            raise TypeError("Expected argument 'fusion_environment_id' to be a str")
        pulumi.set(__self__, "fusion_environment_id", fusion_environment_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if refresh_activity_collections and not isinstance(refresh_activity_collections, list):
            raise TypeError("Expected argument 'refresh_activity_collections' to be a list")
        pulumi.set(__self__, "refresh_activity_collections", refresh_activity_collections)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)
        if time_expected_finish_less_than_or_equal_to and not isinstance(time_expected_finish_less_than_or_equal_to, str):
            raise TypeError("Expected argument 'time_expected_finish_less_than_or_equal_to' to be a str")
        pulumi.set(__self__, "time_expected_finish_less_than_or_equal_to", time_expected_finish_less_than_or_equal_to)
        if time_scheduled_start_greater_than_or_equal_to and not isinstance(time_scheduled_start_greater_than_or_equal_to, str):
            raise TypeError("Expected argument 'time_scheduled_start_greater_than_or_equal_to' to be a str")
        pulumi.set(__self__, "time_scheduled_start_greater_than_or_equal_to", time_scheduled_start_greater_than_or_equal_to)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[builtins.str]:
        """
        A friendly name for the refresh activity. Can be changed later.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetFusionEnvironmentRefreshActivitiesFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter(name="fusionEnvironmentId")
    def fusion_environment_id(self) -> builtins.str:
        return pulumi.get(self, "fusion_environment_id")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="refreshActivityCollections")
    def refresh_activity_collections(self) -> Sequence['outputs.GetFusionEnvironmentRefreshActivitiesRefreshActivityCollectionResult']:
        """
        The list of refresh_activity_collection.
        """
        return pulumi.get(self, "refresh_activity_collections")

    @property
    @pulumi.getter
    def state(self) -> Optional[builtins.str]:
        """
        The current state of the refreshActivity.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter(name="timeExpectedFinishLessThanOrEqualTo")
    def time_expected_finish_less_than_or_equal_to(self) -> Optional[builtins.str]:
        return pulumi.get(self, "time_expected_finish_less_than_or_equal_to")

    @property
    @pulumi.getter(name="timeScheduledStartGreaterThanOrEqualTo")
    def time_scheduled_start_greater_than_or_equal_to(self) -> Optional[builtins.str]:
        return pulumi.get(self, "time_scheduled_start_greater_than_or_equal_to")


class AwaitableGetFusionEnvironmentRefreshActivitiesResult(GetFusionEnvironmentRefreshActivitiesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFusionEnvironmentRefreshActivitiesResult(
            display_name=self.display_name,
            filters=self.filters,
            fusion_environment_id=self.fusion_environment_id,
            id=self.id,
            refresh_activity_collections=self.refresh_activity_collections,
            state=self.state,
            time_expected_finish_less_than_or_equal_to=self.time_expected_finish_less_than_or_equal_to,
            time_scheduled_start_greater_than_or_equal_to=self.time_scheduled_start_greater_than_or_equal_to)


def get_fusion_environment_refresh_activities(display_name: Optional[builtins.str] = None,
                                              filters: Optional[Sequence[Union['GetFusionEnvironmentRefreshActivitiesFilterArgs', 'GetFusionEnvironmentRefreshActivitiesFilterArgsDict']]] = None,
                                              fusion_environment_id: Optional[builtins.str] = None,
                                              state: Optional[builtins.str] = None,
                                              time_expected_finish_less_than_or_equal_to: Optional[builtins.str] = None,
                                              time_scheduled_start_greater_than_or_equal_to: Optional[builtins.str] = None,
                                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFusionEnvironmentRefreshActivitiesResult:
    """
    This data source provides the list of Fusion Environment Refresh Activities in Oracle Cloud Infrastructure Fusion Apps service.

    Returns a list of RefreshActivities.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_fusion_environment_refresh_activities = oci.Functions.get_fusion_environment_refresh_activities(fusion_environment_id=test_fusion_environment["id"],
        display_name=fusion_environment_refresh_activity_display_name,
        state=fusion_environment_refresh_activity_state,
        time_expected_finish_less_than_or_equal_to=fusion_environment_refresh_activity_time_expected_finish_less_than_or_equal_to,
        time_scheduled_start_greater_than_or_equal_to=fusion_environment_refresh_activity_time_scheduled_start_greater_than_or_equal_to)
    ```


    :param builtins.str display_name: A filter to return only resources that match the entire display name given.
    :param builtins.str fusion_environment_id: unique FusionEnvironment identifier
    :param builtins.str state: A filter that returns all resources that match the specified status
    :param builtins.str time_expected_finish_less_than_or_equal_to: A filter that returns all resources that end before this date
    :param builtins.str time_scheduled_start_greater_than_or_equal_to: A filter that returns all resources that are scheduled after this date
    """
    __args__ = dict()
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['fusionEnvironmentId'] = fusion_environment_id
    __args__['state'] = state
    __args__['timeExpectedFinishLessThanOrEqualTo'] = time_expected_finish_less_than_or_equal_to
    __args__['timeScheduledStartGreaterThanOrEqualTo'] = time_scheduled_start_greater_than_or_equal_to
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Functions/getFusionEnvironmentRefreshActivities:getFusionEnvironmentRefreshActivities', __args__, opts=opts, typ=GetFusionEnvironmentRefreshActivitiesResult).value

    return AwaitableGetFusionEnvironmentRefreshActivitiesResult(
        display_name=pulumi.get(__ret__, 'display_name'),
        filters=pulumi.get(__ret__, 'filters'),
        fusion_environment_id=pulumi.get(__ret__, 'fusion_environment_id'),
        id=pulumi.get(__ret__, 'id'),
        refresh_activity_collections=pulumi.get(__ret__, 'refresh_activity_collections'),
        state=pulumi.get(__ret__, 'state'),
        time_expected_finish_less_than_or_equal_to=pulumi.get(__ret__, 'time_expected_finish_less_than_or_equal_to'),
        time_scheduled_start_greater_than_or_equal_to=pulumi.get(__ret__, 'time_scheduled_start_greater_than_or_equal_to'))
def get_fusion_environment_refresh_activities_output(display_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                     filters: Optional[pulumi.Input[Optional[Sequence[Union['GetFusionEnvironmentRefreshActivitiesFilterArgs', 'GetFusionEnvironmentRefreshActivitiesFilterArgsDict']]]]] = None,
                                                     fusion_environment_id: Optional[pulumi.Input[builtins.str]] = None,
                                                     state: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                     time_expected_finish_less_than_or_equal_to: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                     time_scheduled_start_greater_than_or_equal_to: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetFusionEnvironmentRefreshActivitiesResult]:
    """
    This data source provides the list of Fusion Environment Refresh Activities in Oracle Cloud Infrastructure Fusion Apps service.

    Returns a list of RefreshActivities.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_fusion_environment_refresh_activities = oci.Functions.get_fusion_environment_refresh_activities(fusion_environment_id=test_fusion_environment["id"],
        display_name=fusion_environment_refresh_activity_display_name,
        state=fusion_environment_refresh_activity_state,
        time_expected_finish_less_than_or_equal_to=fusion_environment_refresh_activity_time_expected_finish_less_than_or_equal_to,
        time_scheduled_start_greater_than_or_equal_to=fusion_environment_refresh_activity_time_scheduled_start_greater_than_or_equal_to)
    ```


    :param builtins.str display_name: A filter to return only resources that match the entire display name given.
    :param builtins.str fusion_environment_id: unique FusionEnvironment identifier
    :param builtins.str state: A filter that returns all resources that match the specified status
    :param builtins.str time_expected_finish_less_than_or_equal_to: A filter that returns all resources that end before this date
    :param builtins.str time_scheduled_start_greater_than_or_equal_to: A filter that returns all resources that are scheduled after this date
    """
    __args__ = dict()
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['fusionEnvironmentId'] = fusion_environment_id
    __args__['state'] = state
    __args__['timeExpectedFinishLessThanOrEqualTo'] = time_expected_finish_less_than_or_equal_to
    __args__['timeScheduledStartGreaterThanOrEqualTo'] = time_scheduled_start_greater_than_or_equal_to
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Functions/getFusionEnvironmentRefreshActivities:getFusionEnvironmentRefreshActivities', __args__, opts=opts, typ=GetFusionEnvironmentRefreshActivitiesResult)
    return __ret__.apply(lambda __response__: GetFusionEnvironmentRefreshActivitiesResult(
        display_name=pulumi.get(__response__, 'display_name'),
        filters=pulumi.get(__response__, 'filters'),
        fusion_environment_id=pulumi.get(__response__, 'fusion_environment_id'),
        id=pulumi.get(__response__, 'id'),
        refresh_activity_collections=pulumi.get(__response__, 'refresh_activity_collections'),
        state=pulumi.get(__response__, 'state'),
        time_expected_finish_less_than_or_equal_to=pulumi.get(__response__, 'time_expected_finish_less_than_or_equal_to'),
        time_scheduled_start_greater_than_or_equal_to=pulumi.get(__response__, 'time_scheduled_start_greater_than_or_equal_to')))
