# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetAgentDataIngestionJobLogContentResult',
    'AwaitableGetAgentDataIngestionJobLogContentResult',
    'get_agent_data_ingestion_job_log_content',
    'get_agent_data_ingestion_job_log_content_output',
]

@pulumi.output_type
class GetAgentDataIngestionJobLogContentResult:
    """
    A collection of values returned by getAgentDataIngestionJobLogContent.
    """
    def __init__(__self__, data_ingestion_job_id=None, id=None):
        if data_ingestion_job_id and not isinstance(data_ingestion_job_id, str):
            raise TypeError("Expected argument 'data_ingestion_job_id' to be a str")
        pulumi.set(__self__, "data_ingestion_job_id", data_ingestion_job_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter(name="dataIngestionJobId")
    def data_ingestion_job_id(self) -> builtins.str:
        return pulumi.get(self, "data_ingestion_job_id")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")


class AwaitableGetAgentDataIngestionJobLogContentResult(GetAgentDataIngestionJobLogContentResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAgentDataIngestionJobLogContentResult(
            data_ingestion_job_id=self.data_ingestion_job_id,
            id=self.id)


def get_agent_data_ingestion_job_log_content(data_ingestion_job_id: Optional[builtins.str] = None,
                                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAgentDataIngestionJobLogContentResult:
    """
    This data source provides details about a specific Data Ingestion Job Log Content resource in Oracle Cloud Infrastructure Generative Ai Agent service.

    **GetDataIngestionJobLogContent**

    Returns the raw log file for the specified data ingestion job in text format.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_data_ingestion_job_log_content = oci.GenerativeAi.get_agent_data_ingestion_job_log_content(data_ingestion_job_id=test_data_ingestion_job["id"])
    ```


    :param builtins.str data_ingestion_job_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the data ingestion job.
    """
    __args__ = dict()
    __args__['dataIngestionJobId'] = data_ingestion_job_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:GenerativeAi/getAgentDataIngestionJobLogContent:getAgentDataIngestionJobLogContent', __args__, opts=opts, typ=GetAgentDataIngestionJobLogContentResult).value

    return AwaitableGetAgentDataIngestionJobLogContentResult(
        data_ingestion_job_id=pulumi.get(__ret__, 'data_ingestion_job_id'),
        id=pulumi.get(__ret__, 'id'))
def get_agent_data_ingestion_job_log_content_output(data_ingestion_job_id: Optional[pulumi.Input[builtins.str]] = None,
                                                    opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetAgentDataIngestionJobLogContentResult]:
    """
    This data source provides details about a specific Data Ingestion Job Log Content resource in Oracle Cloud Infrastructure Generative Ai Agent service.

    **GetDataIngestionJobLogContent**

    Returns the raw log file for the specified data ingestion job in text format.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_data_ingestion_job_log_content = oci.GenerativeAi.get_agent_data_ingestion_job_log_content(data_ingestion_job_id=test_data_ingestion_job["id"])
    ```


    :param builtins.str data_ingestion_job_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the data ingestion job.
    """
    __args__ = dict()
    __args__['dataIngestionJobId'] = data_ingestion_job_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:GenerativeAi/getAgentDataIngestionJobLogContent:getAgentDataIngestionJobLogContent', __args__, opts=opts, typ=GetAgentDataIngestionJobLogContentResult)
    return __ret__.apply(lambda __response__: GetAgentDataIngestionJobLogContentResult(
        data_ingestion_job_id=pulumi.get(__response__, 'data_ingestion_job_id'),
        id=pulumi.get(__response__, 'id')))
