# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetFleetJavaMigrationAnalysisResultsResult',
    'AwaitableGetFleetJavaMigrationAnalysisResultsResult',
    'get_fleet_java_migration_analysis_results',
    'get_fleet_java_migration_analysis_results_output',
]

@pulumi.output_type
class GetFleetJavaMigrationAnalysisResultsResult:
    """
    A collection of values returned by getFleetJavaMigrationAnalysisResults.
    """
    def __init__(__self__, application_name=None, filters=None, fleet_id=None, host_name=None, id=None, java_migration_analysis_result_collections=None, managed_instance_id=None, time_end=None, time_start=None):
        if application_name and not isinstance(application_name, str):
            raise TypeError("Expected argument 'application_name' to be a str")
        pulumi.set(__self__, "application_name", application_name)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if fleet_id and not isinstance(fleet_id, str):
            raise TypeError("Expected argument 'fleet_id' to be a str")
        pulumi.set(__self__, "fleet_id", fleet_id)
        if host_name and not isinstance(host_name, str):
            raise TypeError("Expected argument 'host_name' to be a str")
        pulumi.set(__self__, "host_name", host_name)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if java_migration_analysis_result_collections and not isinstance(java_migration_analysis_result_collections, list):
            raise TypeError("Expected argument 'java_migration_analysis_result_collections' to be a list")
        pulumi.set(__self__, "java_migration_analysis_result_collections", java_migration_analysis_result_collections)
        if managed_instance_id and not isinstance(managed_instance_id, str):
            raise TypeError("Expected argument 'managed_instance_id' to be a str")
        pulumi.set(__self__, "managed_instance_id", managed_instance_id)
        if time_end and not isinstance(time_end, str):
            raise TypeError("Expected argument 'time_end' to be a str")
        pulumi.set(__self__, "time_end", time_end)
        if time_start and not isinstance(time_start, str):
            raise TypeError("Expected argument 'time_start' to be a str")
        pulumi.set(__self__, "time_start", time_start)

    @property
    @pulumi.getter(name="applicationName")
    def application_name(self) -> Optional[builtins.str]:
        """
        The name of the application for which the Java migration analysis was performed.
        """
        return pulumi.get(self, "application_name")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetFleetJavaMigrationAnalysisResultsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter(name="fleetId")
    def fleet_id(self) -> builtins.str:
        """
        The fleet OCID.
        """
        return pulumi.get(self, "fleet_id")

    @property
    @pulumi.getter(name="hostName")
    def host_name(self) -> Optional[builtins.str]:
        """
        The hostname of the managed instance that hosts the application for which the Java migration analysis was performed.
        """
        return pulumi.get(self, "host_name")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="javaMigrationAnalysisResultCollections")
    def java_migration_analysis_result_collections(self) -> Sequence['outputs.GetFleetJavaMigrationAnalysisResultsJavaMigrationAnalysisResultCollectionResult']:
        """
        The list of java_migration_analysis_result_collection.
        """
        return pulumi.get(self, "java_migration_analysis_result_collections")

    @property
    @pulumi.getter(name="managedInstanceId")
    def managed_instance_id(self) -> Optional[builtins.str]:
        """
        The managed instance OCID.
        """
        return pulumi.get(self, "managed_instance_id")

    @property
    @pulumi.getter(name="timeEnd")
    def time_end(self) -> Optional[builtins.str]:
        return pulumi.get(self, "time_end")

    @property
    @pulumi.getter(name="timeStart")
    def time_start(self) -> Optional[builtins.str]:
        return pulumi.get(self, "time_start")


class AwaitableGetFleetJavaMigrationAnalysisResultsResult(GetFleetJavaMigrationAnalysisResultsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFleetJavaMigrationAnalysisResultsResult(
            application_name=self.application_name,
            filters=self.filters,
            fleet_id=self.fleet_id,
            host_name=self.host_name,
            id=self.id,
            java_migration_analysis_result_collections=self.java_migration_analysis_result_collections,
            managed_instance_id=self.managed_instance_id,
            time_end=self.time_end,
            time_start=self.time_start)


def get_fleet_java_migration_analysis_results(application_name: Optional[builtins.str] = None,
                                              filters: Optional[Sequence[Union['GetFleetJavaMigrationAnalysisResultsFilterArgs', 'GetFleetJavaMigrationAnalysisResultsFilterArgsDict']]] = None,
                                              fleet_id: Optional[builtins.str] = None,
                                              host_name: Optional[builtins.str] = None,
                                              managed_instance_id: Optional[builtins.str] = None,
                                              time_end: Optional[builtins.str] = None,
                                              time_start: Optional[builtins.str] = None,
                                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFleetJavaMigrationAnalysisResultsResult:
    """
    This data source provides the list of Fleet Java Migration Analysis Results in Oracle Cloud Infrastructure Jms service.

    Lists the results of a Java migration analysis.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_fleet_java_migration_analysis_results = oci.Jms.get_fleet_java_migration_analysis_results(fleet_id=test_fleet["id"],
        application_name=fleet_java_migration_analysis_result_application_name,
        host_name=fleet_java_migration_analysis_result_host_name,
        managed_instance_id=fleet_java_migration_analysis_result_managed_instance_id,
        time_end=fleet_java_migration_analysis_result_time_end,
        time_start=fleet_java_migration_analysis_result_time_start)
    ```


    :param builtins.str application_name: The name of the application.
    :param builtins.str fleet_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Fleet.
    :param builtins.str host_name: The host [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the managed instance.
    :param builtins.str managed_instance_id: The Fleet-unique identifier of the related managed instance.
    :param builtins.str time_end: The end of the time period during which resources are searched (formatted according to [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339)).
    :param builtins.str time_start: The start of the time period during which resources are searched (formatted according to [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339)).
    """
    __args__ = dict()
    __args__['applicationName'] = application_name
    __args__['filters'] = filters
    __args__['fleetId'] = fleet_id
    __args__['hostName'] = host_name
    __args__['managedInstanceId'] = managed_instance_id
    __args__['timeEnd'] = time_end
    __args__['timeStart'] = time_start
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Jms/getFleetJavaMigrationAnalysisResults:getFleetJavaMigrationAnalysisResults', __args__, opts=opts, typ=GetFleetJavaMigrationAnalysisResultsResult).value

    return AwaitableGetFleetJavaMigrationAnalysisResultsResult(
        application_name=pulumi.get(__ret__, 'application_name'),
        filters=pulumi.get(__ret__, 'filters'),
        fleet_id=pulumi.get(__ret__, 'fleet_id'),
        host_name=pulumi.get(__ret__, 'host_name'),
        id=pulumi.get(__ret__, 'id'),
        java_migration_analysis_result_collections=pulumi.get(__ret__, 'java_migration_analysis_result_collections'),
        managed_instance_id=pulumi.get(__ret__, 'managed_instance_id'),
        time_end=pulumi.get(__ret__, 'time_end'),
        time_start=pulumi.get(__ret__, 'time_start'))
def get_fleet_java_migration_analysis_results_output(application_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                     filters: Optional[pulumi.Input[Optional[Sequence[Union['GetFleetJavaMigrationAnalysisResultsFilterArgs', 'GetFleetJavaMigrationAnalysisResultsFilterArgsDict']]]]] = None,
                                                     fleet_id: Optional[pulumi.Input[builtins.str]] = None,
                                                     host_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                     managed_instance_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                     time_end: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                     time_start: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetFleetJavaMigrationAnalysisResultsResult]:
    """
    This data source provides the list of Fleet Java Migration Analysis Results in Oracle Cloud Infrastructure Jms service.

    Lists the results of a Java migration analysis.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_fleet_java_migration_analysis_results = oci.Jms.get_fleet_java_migration_analysis_results(fleet_id=test_fleet["id"],
        application_name=fleet_java_migration_analysis_result_application_name,
        host_name=fleet_java_migration_analysis_result_host_name,
        managed_instance_id=fleet_java_migration_analysis_result_managed_instance_id,
        time_end=fleet_java_migration_analysis_result_time_end,
        time_start=fleet_java_migration_analysis_result_time_start)
    ```


    :param builtins.str application_name: The name of the application.
    :param builtins.str fleet_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Fleet.
    :param builtins.str host_name: The host [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the managed instance.
    :param builtins.str managed_instance_id: The Fleet-unique identifier of the related managed instance.
    :param builtins.str time_end: The end of the time period during which resources are searched (formatted according to [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339)).
    :param builtins.str time_start: The start of the time period during which resources are searched (formatted according to [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339)).
    """
    __args__ = dict()
    __args__['applicationName'] = application_name
    __args__['filters'] = filters
    __args__['fleetId'] = fleet_id
    __args__['hostName'] = host_name
    __args__['managedInstanceId'] = managed_instance_id
    __args__['timeEnd'] = time_end
    __args__['timeStart'] = time_start
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Jms/getFleetJavaMigrationAnalysisResults:getFleetJavaMigrationAnalysisResults', __args__, opts=opts, typ=GetFleetJavaMigrationAnalysisResultsResult)
    return __ret__.apply(lambda __response__: GetFleetJavaMigrationAnalysisResultsResult(
        application_name=pulumi.get(__response__, 'application_name'),
        filters=pulumi.get(__response__, 'filters'),
        fleet_id=pulumi.get(__response__, 'fleet_id'),
        host_name=pulumi.get(__response__, 'host_name'),
        id=pulumi.get(__response__, 'id'),
        java_migration_analysis_result_collections=pulumi.get(__response__, 'java_migration_analysis_result_collections'),
        managed_instance_id=pulumi.get(__response__, 'managed_instance_id'),
        time_end=pulumi.get(__response__, 'time_end'),
        time_start=pulumi.get(__response__, 'time_start')))
