# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetJavaDownloadsJavaDownloadReportContentResult',
    'AwaitableGetJavaDownloadsJavaDownloadReportContentResult',
    'get_java_downloads_java_download_report_content',
    'get_java_downloads_java_download_report_content_output',
]

@pulumi.output_type
class GetJavaDownloadsJavaDownloadReportContentResult:
    """
    A collection of values returned by getJavaDownloadsJavaDownloadReportContent.
    """
    def __init__(__self__, id=None, java_download_report_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if java_download_report_id and not isinstance(java_download_report_id, str):
            raise TypeError("Expected argument 'java_download_report_id' to be a str")
        pulumi.set(__self__, "java_download_report_id", java_download_report_id)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="javaDownloadReportId")
    def java_download_report_id(self) -> builtins.str:
        return pulumi.get(self, "java_download_report_id")


class AwaitableGetJavaDownloadsJavaDownloadReportContentResult(GetJavaDownloadsJavaDownloadReportContentResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetJavaDownloadsJavaDownloadReportContentResult(
            id=self.id,
            java_download_report_id=self.java_download_report_id)


def get_java_downloads_java_download_report_content(java_download_report_id: Optional[builtins.str] = None,
                                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetJavaDownloadsJavaDownloadReportContentResult:
    """
    This data source provides details about a specific Java Download Report Content resource in Oracle Cloud Infrastructure Jms Java Downloads service.

    Retrieve a Java download report with the specified identifier.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_java_download_report_content = oci.Jms.get_java_downloads_java_download_report_content(java_download_report_id=test_java_download_report["id"])
    ```


    :param builtins.str java_download_report_id: Unique Java download report identifier.
    """
    __args__ = dict()
    __args__['javaDownloadReportId'] = java_download_report_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Jms/getJavaDownloadsJavaDownloadReportContent:getJavaDownloadsJavaDownloadReportContent', __args__, opts=opts, typ=GetJavaDownloadsJavaDownloadReportContentResult).value

    return AwaitableGetJavaDownloadsJavaDownloadReportContentResult(
        id=pulumi.get(__ret__, 'id'),
        java_download_report_id=pulumi.get(__ret__, 'java_download_report_id'))
def get_java_downloads_java_download_report_content_output(java_download_report_id: Optional[pulumi.Input[builtins.str]] = None,
                                                           opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetJavaDownloadsJavaDownloadReportContentResult]:
    """
    This data source provides details about a specific Java Download Report Content resource in Oracle Cloud Infrastructure Jms Java Downloads service.

    Retrieve a Java download report with the specified identifier.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_java_download_report_content = oci.Jms.get_java_downloads_java_download_report_content(java_download_report_id=test_java_download_report["id"])
    ```


    :param builtins.str java_download_report_id: Unique Java download report identifier.
    """
    __args__ = dict()
    __args__['javaDownloadReportId'] = java_download_report_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Jms/getJavaDownloadsJavaDownloadReportContent:getJavaDownloadsJavaDownloadReportContent', __args__, opts=opts, typ=GetJavaDownloadsJavaDownloadReportContentResult)
    return __ret__.apply(lambda __response__: GetJavaDownloadsJavaDownloadReportContentResult(
        id=pulumi.get(__response__, 'id'),
        java_download_report_id=pulumi.get(__response__, 'java_download_report_id')))
