# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetVaultReplicasResult',
    'AwaitableGetVaultReplicasResult',
    'get_vault_replicas',
    'get_vault_replicas_output',
]

@pulumi.output_type
class GetVaultReplicasResult:
    """
    A collection of values returned by getVaultReplicas.
    """
    def __init__(__self__, filters=None, id=None, vault_id=None, vault_replicas=None):
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if vault_id and not isinstance(vault_id, str):
            raise TypeError("Expected argument 'vault_id' to be a str")
        pulumi.set(__self__, "vault_id", vault_id)
        if vault_replicas and not isinstance(vault_replicas, list):
            raise TypeError("Expected argument 'vault_replicas' to be a list")
        pulumi.set(__self__, "vault_replicas", vault_replicas)

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetVaultReplicasFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="vaultId")
    def vault_id(self) -> builtins.str:
        return pulumi.get(self, "vault_id")

    @property
    @pulumi.getter(name="vaultReplicas")
    def vault_replicas(self) -> Sequence['outputs.GetVaultReplicasVaultReplicaResult']:
        """
        The list of vault_replicas.
        """
        return pulumi.get(self, "vault_replicas")


class AwaitableGetVaultReplicasResult(GetVaultReplicasResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVaultReplicasResult(
            filters=self.filters,
            id=self.id,
            vault_id=self.vault_id,
            vault_replicas=self.vault_replicas)


def get_vault_replicas(filters: Optional[Sequence[Union['GetVaultReplicasFilterArgs', 'GetVaultReplicasFilterArgsDict']]] = None,
                       vault_id: Optional[builtins.str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVaultReplicasResult:
    """
    This data source provides the list of Vault Replicas in Oracle Cloud Infrastructure Kms service.

    Lists the replicas for a vault

    As a provisioning operation, this call is subject to a Key Management limit that applies to
    the total number of requests across all provisioning write operations. Key Management might
    throttle this call to reject an otherwise valid request when the total rate of provisioning
    write operations exceeds 10 requests per second for a given tenancy.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_vault_replicas = oci.Kms.get_vault_replicas(vault_id=test_vault["id"])
    ```


    :param builtins.str vault_id: The OCID of the vault.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['vaultId'] = vault_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Kms/getVaultReplicas:getVaultReplicas', __args__, opts=opts, typ=GetVaultReplicasResult).value

    return AwaitableGetVaultReplicasResult(
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        vault_id=pulumi.get(__ret__, 'vault_id'),
        vault_replicas=pulumi.get(__ret__, 'vault_replicas'))
def get_vault_replicas_output(filters: Optional[pulumi.Input[Optional[Sequence[Union['GetVaultReplicasFilterArgs', 'GetVaultReplicasFilterArgsDict']]]]] = None,
                              vault_id: Optional[pulumi.Input[builtins.str]] = None,
                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetVaultReplicasResult]:
    """
    This data source provides the list of Vault Replicas in Oracle Cloud Infrastructure Kms service.

    Lists the replicas for a vault

    As a provisioning operation, this call is subject to a Key Management limit that applies to
    the total number of requests across all provisioning write operations. Key Management might
    throttle this call to reject an otherwise valid request when the total rate of provisioning
    write operations exceeds 10 requests per second for a given tenancy.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_vault_replicas = oci.Kms.get_vault_replicas(vault_id=test_vault["id"])
    ```


    :param builtins.str vault_id: The OCID of the vault.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['vaultId'] = vault_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Kms/getVaultReplicas:getVaultReplicas', __args__, opts=opts, typ=GetVaultReplicasResult)
    return __ret__.apply(lambda __response__: GetVaultReplicasResult(
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        vault_id=pulumi.get(__response__, 'vault_id'),
        vault_replicas=pulumi.get(__response__, 'vault_replicas')))
