# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetResourceAvailabilityResult',
    'AwaitableGetResourceAvailabilityResult',
    'get_resource_availability',
    'get_resource_availability_output',
]

@pulumi.output_type
class GetResourceAvailabilityResult:
    """
    A collection of values returned by getResourceAvailability.
    """
    def __init__(__self__, availability_domain=None, available=None, compartment_id=None, effective_quota_value=None, fractional_availability=None, fractional_usage=None, id=None, limit_name=None, service_name=None, subscription_id=None, used=None):
        if availability_domain and not isinstance(availability_domain, str):
            raise TypeError("Expected argument 'availability_domain' to be a str")
        pulumi.set(__self__, "availability_domain", availability_domain)
        if available and not isinstance(available, str):
            raise TypeError("Expected argument 'available' to be a str")
        pulumi.set(__self__, "available", available)
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if effective_quota_value and not isinstance(effective_quota_value, float):
            raise TypeError("Expected argument 'effective_quota_value' to be a float")
        pulumi.set(__self__, "effective_quota_value", effective_quota_value)
        if fractional_availability and not isinstance(fractional_availability, float):
            raise TypeError("Expected argument 'fractional_availability' to be a float")
        pulumi.set(__self__, "fractional_availability", fractional_availability)
        if fractional_usage and not isinstance(fractional_usage, float):
            raise TypeError("Expected argument 'fractional_usage' to be a float")
        pulumi.set(__self__, "fractional_usage", fractional_usage)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if limit_name and not isinstance(limit_name, str):
            raise TypeError("Expected argument 'limit_name' to be a str")
        pulumi.set(__self__, "limit_name", limit_name)
        if service_name and not isinstance(service_name, str):
            raise TypeError("Expected argument 'service_name' to be a str")
        pulumi.set(__self__, "service_name", service_name)
        if subscription_id and not isinstance(subscription_id, str):
            raise TypeError("Expected argument 'subscription_id' to be a str")
        pulumi.set(__self__, "subscription_id", subscription_id)
        if used and not isinstance(used, str):
            raise TypeError("Expected argument 'used' to be a str")
        pulumi.set(__self__, "used", used)

    @property
    @pulumi.getter(name="availabilityDomain")
    def availability_domain(self) -> Optional[builtins.str]:
        return pulumi.get(self, "availability_domain")

    @property
    @pulumi.getter
    def available(self) -> builtins.str:
        """
        The count of available resources. To support resources with fractional counts, the field rounds down to the nearest integer.
        """
        return pulumi.get(self, "available")

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="effectiveQuotaValue")
    def effective_quota_value(self) -> builtins.float:
        """
        The effective quota value for the given compartment. This field is only present if there is a current quota policy affecting the current resource in the target region or availability domain.
        """
        return pulumi.get(self, "effective_quota_value")

    @property
    @pulumi.getter(name="fractionalAvailability")
    def fractional_availability(self) -> builtins.float:
        """
        The most accurate count of available resources.
        """
        return pulumi.get(self, "fractional_availability")

    @property
    @pulumi.getter(name="fractionalUsage")
    def fractional_usage(self) -> builtins.float:
        """
        The current most accurate usage in the given compartment.
        """
        return pulumi.get(self, "fractional_usage")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="limitName")
    def limit_name(self) -> builtins.str:
        return pulumi.get(self, "limit_name")

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> builtins.str:
        return pulumi.get(self, "service_name")

    @property
    @pulumi.getter(name="subscriptionId")
    def subscription_id(self) -> Optional[builtins.str]:
        return pulumi.get(self, "subscription_id")

    @property
    @pulumi.getter
    def used(self) -> builtins.str:
        """
        The current usage in the given compartment. To support resources with fractional counts, the field rounds up to the nearest integer.
        """
        return pulumi.get(self, "used")


class AwaitableGetResourceAvailabilityResult(GetResourceAvailabilityResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetResourceAvailabilityResult(
            availability_domain=self.availability_domain,
            available=self.available,
            compartment_id=self.compartment_id,
            effective_quota_value=self.effective_quota_value,
            fractional_availability=self.fractional_availability,
            fractional_usage=self.fractional_usage,
            id=self.id,
            limit_name=self.limit_name,
            service_name=self.service_name,
            subscription_id=self.subscription_id,
            used=self.used)


def get_resource_availability(availability_domain: Optional[builtins.str] = None,
                              compartment_id: Optional[builtins.str] = None,
                              limit_name: Optional[builtins.str] = None,
                              service_name: Optional[builtins.str] = None,
                              subscription_id: Optional[builtins.str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetResourceAvailabilityResult:
    """
    This data source provides details about a specific Resource Availability resource in Oracle Cloud Infrastructure Limits service.

    For a given compartmentId, resource limit name, and scope, returns the following:
      * The number of available resources associated with the given limit.
      * The usage in the selected compartment for the given limit.
        If Subscription Id is provided, then usage for resource created in that subscription will be returned
        Note that not all resource limits support this API. If the value is not available, the API returns a 404 response.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_resource_availability = oci.Limits.get_resource_availability(compartment_id=tenancy_ocid,
        limit_name=resource_availability_limit_name,
        service_name=test_service["name"],
        availability_domain=resource_availability_availability_domain,
        subscription_id=subscription_ocid)
    ```


    :param builtins.str availability_domain: This field is mandatory if the scopeType of the target resource limit is AD. Otherwise, this field should be omitted. If the above requirements are not met, the API returns a 400 - InvalidParameter response.
    :param builtins.str compartment_id: The OCID of the compartment for which data is being fetched.
    :param builtins.str limit_name: The limit name for which to fetch the data.
    :param builtins.str service_name: The service name of the target quota.
    :param builtins.str subscription_id: The OCID of the subscription assigned to tenant
    """
    __args__ = dict()
    __args__['availabilityDomain'] = availability_domain
    __args__['compartmentId'] = compartment_id
    __args__['limitName'] = limit_name
    __args__['serviceName'] = service_name
    __args__['subscriptionId'] = subscription_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Limits/getResourceAvailability:getResourceAvailability', __args__, opts=opts, typ=GetResourceAvailabilityResult).value

    return AwaitableGetResourceAvailabilityResult(
        availability_domain=pulumi.get(__ret__, 'availability_domain'),
        available=pulumi.get(__ret__, 'available'),
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        effective_quota_value=pulumi.get(__ret__, 'effective_quota_value'),
        fractional_availability=pulumi.get(__ret__, 'fractional_availability'),
        fractional_usage=pulumi.get(__ret__, 'fractional_usage'),
        id=pulumi.get(__ret__, 'id'),
        limit_name=pulumi.get(__ret__, 'limit_name'),
        service_name=pulumi.get(__ret__, 'service_name'),
        subscription_id=pulumi.get(__ret__, 'subscription_id'),
        used=pulumi.get(__ret__, 'used'))
def get_resource_availability_output(availability_domain: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                     compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                                     limit_name: Optional[pulumi.Input[builtins.str]] = None,
                                     service_name: Optional[pulumi.Input[builtins.str]] = None,
                                     subscription_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetResourceAvailabilityResult]:
    """
    This data source provides details about a specific Resource Availability resource in Oracle Cloud Infrastructure Limits service.

    For a given compartmentId, resource limit name, and scope, returns the following:
      * The number of available resources associated with the given limit.
      * The usage in the selected compartment for the given limit.
        If Subscription Id is provided, then usage for resource created in that subscription will be returned
        Note that not all resource limits support this API. If the value is not available, the API returns a 404 response.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_resource_availability = oci.Limits.get_resource_availability(compartment_id=tenancy_ocid,
        limit_name=resource_availability_limit_name,
        service_name=test_service["name"],
        availability_domain=resource_availability_availability_domain,
        subscription_id=subscription_ocid)
    ```


    :param builtins.str availability_domain: This field is mandatory if the scopeType of the target resource limit is AD. Otherwise, this field should be omitted. If the above requirements are not met, the API returns a 400 - InvalidParameter response.
    :param builtins.str compartment_id: The OCID of the compartment for which data is being fetched.
    :param builtins.str limit_name: The limit name for which to fetch the data.
    :param builtins.str service_name: The service name of the target quota.
    :param builtins.str subscription_id: The OCID of the subscription assigned to tenant
    """
    __args__ = dict()
    __args__['availabilityDomain'] = availability_domain
    __args__['compartmentId'] = compartment_id
    __args__['limitName'] = limit_name
    __args__['serviceName'] = service_name
    __args__['subscriptionId'] = subscription_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Limits/getResourceAvailability:getResourceAvailability', __args__, opts=opts, typ=GetResourceAvailabilityResult)
    return __ret__.apply(lambda __response__: GetResourceAvailabilityResult(
        availability_domain=pulumi.get(__response__, 'availability_domain'),
        available=pulumi.get(__response__, 'available'),
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        effective_quota_value=pulumi.get(__response__, 'effective_quota_value'),
        fractional_availability=pulumi.get(__response__, 'fractional_availability'),
        fractional_usage=pulumi.get(__response__, 'fractional_usage'),
        id=pulumi.get(__response__, 'id'),
        limit_name=pulumi.get(__response__, 'limit_name'),
        service_name=pulumi.get(__response__, 'service_name'),
        subscription_id=pulumi.get(__response__, 'subscription_id'),
        used=pulumi.get(__response__, 'used')))
