# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'QuotaLock',
    'GetLimitDefinitionsFilterResult',
    'GetLimitDefinitionsLimitDefinitionResult',
    'GetLimitValuesFilterResult',
    'GetLimitValuesLimitValueResult',
    'GetQuotaLockResult',
    'GetQuotasFilterResult',
    'GetQuotasQuotaResult',
    'GetQuotasQuotaLockResult',
    'GetServicesFilterResult',
    'GetServicesServiceResult',
]

@pulumi.output_type
class QuotaLock(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "relatedResourceId":
            suggest = "related_resource_id"
        elif key == "timeCreated":
            suggest = "time_created"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in QuotaLock. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        QuotaLock.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        QuotaLock.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 type: builtins.str,
                 message: Optional[builtins.str] = None,
                 related_resource_id: Optional[builtins.str] = None,
                 time_created: Optional[builtins.str] = None):
        """
        :param builtins.str type: Lock type.
        :param builtins.str message: A message added by the lock creator. The message typically gives an indication of why the resource is locked.
        :param builtins.str related_resource_id: The resource ID that is locking this resource. Indicates that deleting this resource removes the lock.
        :param builtins.str time_created: Date and time the quota was created, in the format defined by RFC 3339. Example: `2016-08-25T21:10:29.600Z`
        """
        pulumi.set(__self__, "type", type)
        if message is not None:
            pulumi.set(__self__, "message", message)
        if related_resource_id is not None:
            pulumi.set(__self__, "related_resource_id", related_resource_id)
        if time_created is not None:
            pulumi.set(__self__, "time_created", time_created)

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Lock type.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def message(self) -> Optional[builtins.str]:
        """
        A message added by the lock creator. The message typically gives an indication of why the resource is locked.
        """
        return pulumi.get(self, "message")

    @property
    @pulumi.getter(name="relatedResourceId")
    def related_resource_id(self) -> Optional[builtins.str]:
        """
        The resource ID that is locking this resource. Indicates that deleting this resource removes the lock.
        """
        return pulumi.get(self, "related_resource_id")

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> Optional[builtins.str]:
        """
        Date and time the quota was created, in the format defined by RFC 3339. Example: `2016-08-25T21:10:29.600Z`
        """
        return pulumi.get(self, "time_created")


@pulumi.output_type
class GetLimitDefinitionsFilterResult(dict):
    def __init__(__self__, *,
                 name: builtins.str,
                 values: Sequence[builtins.str],
                 regex: Optional[builtins.bool] = None):
        """
        :param builtins.str name: Optional field, filter for a specific resource limit.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "values", values)
        if regex is not None:
            pulumi.set(__self__, "regex", regex)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Optional field, filter for a specific resource limit.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[builtins.str]:
        return pulumi.get(self, "values")

    @property
    @pulumi.getter
    def regex(self) -> Optional[builtins.bool]:
        return pulumi.get(self, "regex")


@pulumi.output_type
class GetLimitDefinitionsLimitDefinitionResult(dict):
    def __init__(__self__, *,
                 are_quotas_supported: builtins.bool,
                 description: builtins.str,
                 is_deprecated: builtins.bool,
                 is_dynamic: builtins.bool,
                 is_eligible_for_limit_increase: builtins.bool,
                 is_resource_availability_supported: builtins.bool,
                 name: builtins.str,
                 scope_type: builtins.str,
                 service_name: builtins.str,
                 supported_quota_families: Sequence[builtins.str],
                 supported_subscriptions: Sequence[builtins.str]):
        """
        :param builtins.bool are_quotas_supported: If true, quota policies can be created on top of this resource limit.
        :param builtins.str description: The limit description.
        :param builtins.bool is_deprecated: Indicates if the limit has been deprecated.
        :param builtins.bool is_dynamic: The limit for this resource has a dynamic value that is based on consumption across all Oracle Cloud Infrastructure services.
        :param builtins.bool is_eligible_for_limit_increase: Indicates if the customer can request a limit increase for this resource.
        :param builtins.bool is_resource_availability_supported: Reflects whether or not the GetResourceAvailability API is supported for this limit. If not, the API returns an empty JSON response.
        :param builtins.str name: Optional field, filter for a specific resource limit.
        :param builtins.str scope_type: Reflects the scope of the resource limit, whether Global (across all regions), regional, or availability domain-specific.
        :param builtins.str service_name: The target service name.
        :param Sequence[builtins.str] supported_quota_families: Supported quota family names for creation of quota policy.
        :param Sequence[builtins.str] supported_subscriptions: An array of subscription types supported by the limit. e,g The type of subscription, such as 'SAAS', 'ERP', 'CRM'.
        """
        pulumi.set(__self__, "are_quotas_supported", are_quotas_supported)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "is_deprecated", is_deprecated)
        pulumi.set(__self__, "is_dynamic", is_dynamic)
        pulumi.set(__self__, "is_eligible_for_limit_increase", is_eligible_for_limit_increase)
        pulumi.set(__self__, "is_resource_availability_supported", is_resource_availability_supported)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "scope_type", scope_type)
        pulumi.set(__self__, "service_name", service_name)
        pulumi.set(__self__, "supported_quota_families", supported_quota_families)
        pulumi.set(__self__, "supported_subscriptions", supported_subscriptions)

    @property
    @pulumi.getter(name="areQuotasSupported")
    def are_quotas_supported(self) -> builtins.bool:
        """
        If true, quota policies can be created on top of this resource limit.
        """
        return pulumi.get(self, "are_quotas_supported")

    @property
    @pulumi.getter
    def description(self) -> builtins.str:
        """
        The limit description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="isDeprecated")
    def is_deprecated(self) -> builtins.bool:
        """
        Indicates if the limit has been deprecated.
        """
        return pulumi.get(self, "is_deprecated")

    @property
    @pulumi.getter(name="isDynamic")
    def is_dynamic(self) -> builtins.bool:
        """
        The limit for this resource has a dynamic value that is based on consumption across all Oracle Cloud Infrastructure services.
        """
        return pulumi.get(self, "is_dynamic")

    @property
    @pulumi.getter(name="isEligibleForLimitIncrease")
    def is_eligible_for_limit_increase(self) -> builtins.bool:
        """
        Indicates if the customer can request a limit increase for this resource.
        """
        return pulumi.get(self, "is_eligible_for_limit_increase")

    @property
    @pulumi.getter(name="isResourceAvailabilitySupported")
    def is_resource_availability_supported(self) -> builtins.bool:
        """
        Reflects whether or not the GetResourceAvailability API is supported for this limit. If not, the API returns an empty JSON response.
        """
        return pulumi.get(self, "is_resource_availability_supported")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Optional field, filter for a specific resource limit.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="scopeType")
    def scope_type(self) -> builtins.str:
        """
        Reflects the scope of the resource limit, whether Global (across all regions), regional, or availability domain-specific.
        """
        return pulumi.get(self, "scope_type")

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> builtins.str:
        """
        The target service name.
        """
        return pulumi.get(self, "service_name")

    @property
    @pulumi.getter(name="supportedQuotaFamilies")
    def supported_quota_families(self) -> Sequence[builtins.str]:
        """
        Supported quota family names for creation of quota policy.
        """
        return pulumi.get(self, "supported_quota_families")

    @property
    @pulumi.getter(name="supportedSubscriptions")
    def supported_subscriptions(self) -> Sequence[builtins.str]:
        """
        An array of subscription types supported by the limit. e,g The type of subscription, such as 'SAAS', 'ERP', 'CRM'.
        """
        return pulumi.get(self, "supported_subscriptions")


@pulumi.output_type
class GetLimitValuesFilterResult(dict):
    def __init__(__self__, *,
                 name: builtins.str,
                 values: Sequence[builtins.str],
                 regex: Optional[builtins.bool] = None):
        """
        :param builtins.str name: Optional field, can be used to see a specific resource limit value.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "values", values)
        if regex is not None:
            pulumi.set(__self__, "regex", regex)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Optional field, can be used to see a specific resource limit value.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[builtins.str]:
        return pulumi.get(self, "values")

    @property
    @pulumi.getter
    def regex(self) -> Optional[builtins.bool]:
        return pulumi.get(self, "regex")


@pulumi.output_type
class GetLimitValuesLimitValueResult(dict):
    def __init__(__self__, *,
                 availability_domain: builtins.str,
                 name: builtins.str,
                 scope_type: builtins.str,
                 value: builtins.str):
        """
        :param builtins.str availability_domain: Filter entries by availability domain. This implies that only AD-specific values are returned.
        :param builtins.str name: Optional field, can be used to see a specific resource limit value.
        :param builtins.str scope_type: Filter entries by scope type.
        :param builtins.str value: The resource limit value.
        """
        pulumi.set(__self__, "availability_domain", availability_domain)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "scope_type", scope_type)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="availabilityDomain")
    def availability_domain(self) -> builtins.str:
        """
        Filter entries by availability domain. This implies that only AD-specific values are returned.
        """
        return pulumi.get(self, "availability_domain")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Optional field, can be used to see a specific resource limit value.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="scopeType")
    def scope_type(self) -> builtins.str:
        """
        Filter entries by scope type.
        """
        return pulumi.get(self, "scope_type")

    @property
    @pulumi.getter
    def value(self) -> builtins.str:
        """
        The resource limit value.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class GetQuotaLockResult(dict):
    def __init__(__self__, *,
                 message: builtins.str,
                 related_resource_id: builtins.str,
                 time_created: builtins.str,
                 type: builtins.str):
        """
        :param builtins.str message: A message added by the lock creator. The message typically gives an indication of why the resource is locked.
        :param builtins.str related_resource_id: The resource ID that is locking this resource. Indicates that deleting this resource removes the lock.
        :param builtins.str time_created: Date and time the quota was created, in the format defined by RFC 3339. Example: `2016-08-25T21:10:29.600Z`
        :param builtins.str type: Lock type.
        """
        pulumi.set(__self__, "message", message)
        pulumi.set(__self__, "related_resource_id", related_resource_id)
        pulumi.set(__self__, "time_created", time_created)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def message(self) -> builtins.str:
        """
        A message added by the lock creator. The message typically gives an indication of why the resource is locked.
        """
        return pulumi.get(self, "message")

    @property
    @pulumi.getter(name="relatedResourceId")
    def related_resource_id(self) -> builtins.str:
        """
        The resource ID that is locking this resource. Indicates that deleting this resource removes the lock.
        """
        return pulumi.get(self, "related_resource_id")

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> builtins.str:
        """
        Date and time the quota was created, in the format defined by RFC 3339. Example: `2016-08-25T21:10:29.600Z`
        """
        return pulumi.get(self, "time_created")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Lock type.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetQuotasFilterResult(dict):
    def __init__(__self__, *,
                 name: builtins.str,
                 values: Sequence[builtins.str],
                 regex: Optional[builtins.bool] = None):
        """
        :param builtins.str name: name
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "values", values)
        if regex is not None:
            pulumi.set(__self__, "regex", regex)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[builtins.str]:
        return pulumi.get(self, "values")

    @property
    @pulumi.getter
    def regex(self) -> Optional[builtins.bool]:
        return pulumi.get(self, "regex")


@pulumi.output_type
class GetQuotasQuotaResult(dict):
    def __init__(__self__, *,
                 compartment_id: builtins.str,
                 defined_tags: Mapping[str, builtins.str],
                 description: builtins.str,
                 freeform_tags: Mapping[str, builtins.str],
                 id: builtins.str,
                 is_lock_override: builtins.bool,
                 locks: Sequence['outputs.GetQuotasQuotaLockResult'],
                 name: builtins.str,
                 state: builtins.str,
                 statements: Sequence[builtins.str],
                 time_created: builtins.str):
        """
        :param builtins.str compartment_id: The OCID of the parent compartment (remember that the tenancy is simply the root compartment).
        :param Mapping[str, builtins.str] defined_tags: Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"Operations.CostCenter": "42"}`
        :param builtins.str description: The description you assign to the quota.
        :param Mapping[str, builtins.str] freeform_tags: Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"Department": "Finance"}`
        :param builtins.str id: The OCID of the quota.
        :param Sequence['GetQuotasQuotaLockArgs'] locks: Locks associated with this resource.
        :param builtins.str name: name
        :param builtins.str state: Filters returned quotas based on the given state.
        :param Sequence[builtins.str] statements: An array of one or more quota statements written in the declarative quota statement language.
        :param builtins.str time_created: Date and time the quota was created, in the format defined by RFC 3339. Example: `2016-08-25T21:10:29.600Z`
        """
        pulumi.set(__self__, "compartment_id", compartment_id)
        pulumi.set(__self__, "defined_tags", defined_tags)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "freeform_tags", freeform_tags)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "is_lock_override", is_lock_override)
        pulumi.set(__self__, "locks", locks)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "state", state)
        pulumi.set(__self__, "statements", statements)
        pulumi.set(__self__, "time_created", time_created)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        """
        The OCID of the parent compartment (remember that the tenancy is simply the root compartment).
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> Mapping[str, builtins.str]:
        """
        Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"Operations.CostCenter": "42"}`
        """
        return pulumi.get(self, "defined_tags")

    @property
    @pulumi.getter
    def description(self) -> builtins.str:
        """
        The description you assign to the quota.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> Mapping[str, builtins.str]:
        """
        Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"Department": "Finance"}`
        """
        return pulumi.get(self, "freeform_tags")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The OCID of the quota.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="isLockOverride")
    def is_lock_override(self) -> builtins.bool:
        return pulumi.get(self, "is_lock_override")

    @property
    @pulumi.getter
    def locks(self) -> Sequence['outputs.GetQuotasQuotaLockResult']:
        """
        Locks associated with this resource.
        """
        return pulumi.get(self, "locks")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def state(self) -> builtins.str:
        """
        Filters returned quotas based on the given state.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter
    def statements(self) -> Sequence[builtins.str]:
        """
        An array of one or more quota statements written in the declarative quota statement language.
        """
        return pulumi.get(self, "statements")

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> builtins.str:
        """
        Date and time the quota was created, in the format defined by RFC 3339. Example: `2016-08-25T21:10:29.600Z`
        """
        return pulumi.get(self, "time_created")


@pulumi.output_type
class GetQuotasQuotaLockResult(dict):
    def __init__(__self__, *,
                 message: builtins.str,
                 related_resource_id: builtins.str,
                 time_created: builtins.str,
                 type: builtins.str):
        """
        :param builtins.str message: A message added by the lock creator. The message typically gives an indication of why the resource is locked.
        :param builtins.str related_resource_id: The resource ID that is locking this resource. Indicates that deleting this resource removes the lock.
        :param builtins.str time_created: Date and time the quota was created, in the format defined by RFC 3339. Example: `2016-08-25T21:10:29.600Z`
        :param builtins.str type: Lock type.
        """
        pulumi.set(__self__, "message", message)
        pulumi.set(__self__, "related_resource_id", related_resource_id)
        pulumi.set(__self__, "time_created", time_created)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def message(self) -> builtins.str:
        """
        A message added by the lock creator. The message typically gives an indication of why the resource is locked.
        """
        return pulumi.get(self, "message")

    @property
    @pulumi.getter(name="relatedResourceId")
    def related_resource_id(self) -> builtins.str:
        """
        The resource ID that is locking this resource. Indicates that deleting this resource removes the lock.
        """
        return pulumi.get(self, "related_resource_id")

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> builtins.str:
        """
        Date and time the quota was created, in the format defined by RFC 3339. Example: `2016-08-25T21:10:29.600Z`
        """
        return pulumi.get(self, "time_created")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Lock type.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetServicesFilterResult(dict):
    def __init__(__self__, *,
                 name: builtins.str,
                 values: Sequence[builtins.str],
                 regex: Optional[builtins.bool] = None):
        """
        :param builtins.str name: The service name. Use this when calling other APIs.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "values", values)
        if regex is not None:
            pulumi.set(__self__, "regex", regex)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The service name. Use this when calling other APIs.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[builtins.str]:
        return pulumi.get(self, "values")

    @property
    @pulumi.getter
    def regex(self) -> Optional[builtins.bool]:
        return pulumi.get(self, "regex")


@pulumi.output_type
class GetServicesServiceResult(dict):
    def __init__(__self__, *,
                 description: builtins.str,
                 name: builtins.str,
                 supported_subscriptions: Sequence[builtins.str]):
        """
        :param builtins.str description: The friendly service name.
        :param builtins.str name: The service name. Use this when calling other APIs.
        :param Sequence[builtins.str] supported_subscriptions: An array of subscription types supported by the service. e,g The type of subscription, such as 'SAAS', 'ERP', 'CRM'.
        """
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "supported_subscriptions", supported_subscriptions)

    @property
    @pulumi.getter
    def description(self) -> builtins.str:
        """
        The friendly service name.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The service name. Use this when calling other APIs.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="supportedSubscriptions")
    def supported_subscriptions(self) -> Sequence[builtins.str]:
        """
        An array of subscription types supported by the service. e,g The type of subscription, such as 'SAAS', 'ERP', 'CRM'.
        """
        return pulumi.get(self, "supported_subscriptions")


