# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetLogAnalyticsPreferenceResult',
    'AwaitableGetLogAnalyticsPreferenceResult',
    'get_log_analytics_preference',
    'get_log_analytics_preference_output',
]

@pulumi.output_type
class GetLogAnalyticsPreferenceResult:
    """
    A collection of values returned by getLogAnalyticsPreference.
    """
    def __init__(__self__, id=None, items=None, namespace=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if namespace and not isinstance(namespace, str):
            raise TypeError("Expected argument 'namespace' to be a str")
        pulumi.set(__self__, "namespace", namespace)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetLogAnalyticsPreferenceItemResult']:
        """
        An array of tenant preferences.
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter
    def namespace(self) -> builtins.str:
        return pulumi.get(self, "namespace")


class AwaitableGetLogAnalyticsPreferenceResult(GetLogAnalyticsPreferenceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetLogAnalyticsPreferenceResult(
            id=self.id,
            items=self.items,
            namespace=self.namespace)


def get_log_analytics_preference(namespace: Optional[builtins.str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetLogAnalyticsPreferenceResult:
    """
    This data source provides details about a specific Log Analytics Preference resource in Oracle Cloud Infrastructure Log Analytics service.

    Lists the tenant preferences such as DEFAULT_HOMEPAGE and collection properties.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_log_analytics_preference = oci.LogAnalytics.get_log_analytics_preference(namespace=log_analytics_preference_namespace)
    ```


    :param builtins.str namespace: The Logging Analytics namespace used for the request.
    """
    __args__ = dict()
    __args__['namespace'] = namespace
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:LogAnalytics/getLogAnalyticsPreference:getLogAnalyticsPreference', __args__, opts=opts, typ=GetLogAnalyticsPreferenceResult).value

    return AwaitableGetLogAnalyticsPreferenceResult(
        id=pulumi.get(__ret__, 'id'),
        items=pulumi.get(__ret__, 'items'),
        namespace=pulumi.get(__ret__, 'namespace'))
def get_log_analytics_preference_output(namespace: Optional[pulumi.Input[builtins.str]] = None,
                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetLogAnalyticsPreferenceResult]:
    """
    This data source provides details about a specific Log Analytics Preference resource in Oracle Cloud Infrastructure Log Analytics service.

    Lists the tenant preferences such as DEFAULT_HOMEPAGE and collection properties.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_log_analytics_preference = oci.LogAnalytics.get_log_analytics_preference(namespace=log_analytics_preference_namespace)
    ```


    :param builtins.str namespace: The Logging Analytics namespace used for the request.
    """
    __args__ = dict()
    __args__['namespace'] = namespace
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:LogAnalytics/getLogAnalyticsPreference:getLogAnalyticsPreference', __args__, opts=opts, typ=GetLogAnalyticsPreferenceResult)
    return __ret__.apply(lambda __response__: GetLogAnalyticsPreferenceResult(
        id=pulumi.get(__response__, 'id'),
        items=pulumi.get(__response__, 'items'),
        namespace=pulumi.get(__response__, 'namespace')))
