# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetNetworkFirewallPolicyAddressListsResult',
    'AwaitableGetNetworkFirewallPolicyAddressListsResult',
    'get_network_firewall_policy_address_lists',
    'get_network_firewall_policy_address_lists_output',
]

@pulumi.output_type
class GetNetworkFirewallPolicyAddressListsResult:
    """
    A collection of values returned by getNetworkFirewallPolicyAddressLists.
    """
    def __init__(__self__, address_list_summary_collections=None, display_name=None, filters=None, id=None, network_firewall_policy_id=None):
        if address_list_summary_collections and not isinstance(address_list_summary_collections, list):
            raise TypeError("Expected argument 'address_list_summary_collections' to be a list")
        pulumi.set(__self__, "address_list_summary_collections", address_list_summary_collections)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if network_firewall_policy_id and not isinstance(network_firewall_policy_id, str):
            raise TypeError("Expected argument 'network_firewall_policy_id' to be a str")
        pulumi.set(__self__, "network_firewall_policy_id", network_firewall_policy_id)

    @property
    @pulumi.getter(name="addressListSummaryCollections")
    def address_list_summary_collections(self) -> Sequence['outputs.GetNetworkFirewallPolicyAddressListsAddressListSummaryCollectionResult']:
        """
        The list of address_list_summary_collection.
        """
        return pulumi.get(self, "address_list_summary_collections")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[builtins.str]:
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetNetworkFirewallPolicyAddressListsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="networkFirewallPolicyId")
    def network_firewall_policy_id(self) -> builtins.str:
        return pulumi.get(self, "network_firewall_policy_id")


class AwaitableGetNetworkFirewallPolicyAddressListsResult(GetNetworkFirewallPolicyAddressListsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNetworkFirewallPolicyAddressListsResult(
            address_list_summary_collections=self.address_list_summary_collections,
            display_name=self.display_name,
            filters=self.filters,
            id=self.id,
            network_firewall_policy_id=self.network_firewall_policy_id)


def get_network_firewall_policy_address_lists(display_name: Optional[builtins.str] = None,
                                              filters: Optional[Sequence[Union['GetNetworkFirewallPolicyAddressListsFilterArgs', 'GetNetworkFirewallPolicyAddressListsFilterArgsDict']]] = None,
                                              network_firewall_policy_id: Optional[builtins.str] = None,
                                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNetworkFirewallPolicyAddressListsResult:
    """
    This data source provides the list of Network Firewall Policy Address Lists in Oracle Cloud Infrastructure Network Firewall service.

    Returns a list of Network Firewall Policies.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_network_firewall_policy_address_lists = oci.NetworkFirewall.get_network_firewall_policy_address_lists(network_firewall_policy_id=test_network_firewall_policy["id"],
        display_name=network_firewall_policy_address_list_display_name)
    ```


    :param builtins.str display_name: A filter to return only resources that match the entire display name given.
    :param builtins.str network_firewall_policy_id: Unique Network Firewall Policy identifier
    """
    __args__ = dict()
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['networkFirewallPolicyId'] = network_firewall_policy_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:NetworkFirewall/getNetworkFirewallPolicyAddressLists:getNetworkFirewallPolicyAddressLists', __args__, opts=opts, typ=GetNetworkFirewallPolicyAddressListsResult).value

    return AwaitableGetNetworkFirewallPolicyAddressListsResult(
        address_list_summary_collections=pulumi.get(__ret__, 'address_list_summary_collections'),
        display_name=pulumi.get(__ret__, 'display_name'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        network_firewall_policy_id=pulumi.get(__ret__, 'network_firewall_policy_id'))
def get_network_firewall_policy_address_lists_output(display_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                     filters: Optional[pulumi.Input[Optional[Sequence[Union['GetNetworkFirewallPolicyAddressListsFilterArgs', 'GetNetworkFirewallPolicyAddressListsFilterArgsDict']]]]] = None,
                                                     network_firewall_policy_id: Optional[pulumi.Input[builtins.str]] = None,
                                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetNetworkFirewallPolicyAddressListsResult]:
    """
    This data source provides the list of Network Firewall Policy Address Lists in Oracle Cloud Infrastructure Network Firewall service.

    Returns a list of Network Firewall Policies.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_network_firewall_policy_address_lists = oci.NetworkFirewall.get_network_firewall_policy_address_lists(network_firewall_policy_id=test_network_firewall_policy["id"],
        display_name=network_firewall_policy_address_list_display_name)
    ```


    :param builtins.str display_name: A filter to return only resources that match the entire display name given.
    :param builtins.str network_firewall_policy_id: Unique Network Firewall Policy identifier
    """
    __args__ = dict()
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['networkFirewallPolicyId'] = network_firewall_policy_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:NetworkFirewall/getNetworkFirewallPolicyAddressLists:getNetworkFirewallPolicyAddressLists', __args__, opts=opts, typ=GetNetworkFirewallPolicyAddressListsResult)
    return __ret__.apply(lambda __response__: GetNetworkFirewallPolicyAddressListsResult(
        address_list_summary_collections=pulumi.get(__response__, 'address_list_summary_collections'),
        display_name=pulumi.get(__response__, 'display_name'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        network_firewall_policy_id=pulumi.get(__response__, 'network_firewall_policy_id')))
