# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetNetworkFirewallPolicyUrlListsResult',
    'AwaitableGetNetworkFirewallPolicyUrlListsResult',
    'get_network_firewall_policy_url_lists',
    'get_network_firewall_policy_url_lists_output',
]

@pulumi.output_type
class GetNetworkFirewallPolicyUrlListsResult:
    """
    A collection of values returned by getNetworkFirewallPolicyUrlLists.
    """
    def __init__(__self__, display_name=None, filters=None, id=None, network_firewall_policy_id=None, url_list_summary_collections=None):
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if network_firewall_policy_id and not isinstance(network_firewall_policy_id, str):
            raise TypeError("Expected argument 'network_firewall_policy_id' to be a str")
        pulumi.set(__self__, "network_firewall_policy_id", network_firewall_policy_id)
        if url_list_summary_collections and not isinstance(url_list_summary_collections, list):
            raise TypeError("Expected argument 'url_list_summary_collections' to be a list")
        pulumi.set(__self__, "url_list_summary_collections", url_list_summary_collections)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[builtins.str]:
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetNetworkFirewallPolicyUrlListsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="networkFirewallPolicyId")
    def network_firewall_policy_id(self) -> builtins.str:
        return pulumi.get(self, "network_firewall_policy_id")

    @property
    @pulumi.getter(name="urlListSummaryCollections")
    def url_list_summary_collections(self) -> Sequence['outputs.GetNetworkFirewallPolicyUrlListsUrlListSummaryCollectionResult']:
        """
        The list of url_list_summary_collection.
        """
        return pulumi.get(self, "url_list_summary_collections")


class AwaitableGetNetworkFirewallPolicyUrlListsResult(GetNetworkFirewallPolicyUrlListsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNetworkFirewallPolicyUrlListsResult(
            display_name=self.display_name,
            filters=self.filters,
            id=self.id,
            network_firewall_policy_id=self.network_firewall_policy_id,
            url_list_summary_collections=self.url_list_summary_collections)


def get_network_firewall_policy_url_lists(display_name: Optional[builtins.str] = None,
                                          filters: Optional[Sequence[Union['GetNetworkFirewallPolicyUrlListsFilterArgs', 'GetNetworkFirewallPolicyUrlListsFilterArgsDict']]] = None,
                                          network_firewall_policy_id: Optional[builtins.str] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNetworkFirewallPolicyUrlListsResult:
    """
    This data source provides the list of Network Firewall Policy Url Lists in Oracle Cloud Infrastructure Network Firewall service.

    Returns a list of URL lists for the Network Firewall Policy.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_network_firewall_policy_url_lists = oci.NetworkFirewall.get_network_firewall_policy_url_lists(network_firewall_policy_id=test_network_firewall_policy["id"],
        display_name=network_firewall_policy_url_list_display_name)
    ```


    :param builtins.str display_name: A filter to return only resources that match the entire display name given.
    :param builtins.str network_firewall_policy_id: Unique Network Firewall Policy identifier
    """
    __args__ = dict()
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['networkFirewallPolicyId'] = network_firewall_policy_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:NetworkFirewall/getNetworkFirewallPolicyUrlLists:getNetworkFirewallPolicyUrlLists', __args__, opts=opts, typ=GetNetworkFirewallPolicyUrlListsResult).value

    return AwaitableGetNetworkFirewallPolicyUrlListsResult(
        display_name=pulumi.get(__ret__, 'display_name'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        network_firewall_policy_id=pulumi.get(__ret__, 'network_firewall_policy_id'),
        url_list_summary_collections=pulumi.get(__ret__, 'url_list_summary_collections'))
def get_network_firewall_policy_url_lists_output(display_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                 filters: Optional[pulumi.Input[Optional[Sequence[Union['GetNetworkFirewallPolicyUrlListsFilterArgs', 'GetNetworkFirewallPolicyUrlListsFilterArgsDict']]]]] = None,
                                                 network_firewall_policy_id: Optional[pulumi.Input[builtins.str]] = None,
                                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetNetworkFirewallPolicyUrlListsResult]:
    """
    This data source provides the list of Network Firewall Policy Url Lists in Oracle Cloud Infrastructure Network Firewall service.

    Returns a list of URL lists for the Network Firewall Policy.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_network_firewall_policy_url_lists = oci.NetworkFirewall.get_network_firewall_policy_url_lists(network_firewall_policy_id=test_network_firewall_policy["id"],
        display_name=network_firewall_policy_url_list_display_name)
    ```


    :param builtins.str display_name: A filter to return only resources that match the entire display name given.
    :param builtins.str network_firewall_policy_id: Unique Network Firewall Policy identifier
    """
    __args__ = dict()
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['networkFirewallPolicyId'] = network_firewall_policy_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:NetworkFirewall/getNetworkFirewallPolicyUrlLists:getNetworkFirewallPolicyUrlLists', __args__, opts=opts, typ=GetNetworkFirewallPolicyUrlListsResult)
    return __ret__.apply(lambda __response__: GetNetworkFirewallPolicyUrlListsResult(
        display_name=pulumi.get(__response__, 'display_name'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        network_firewall_policy_id=pulumi.get(__response__, 'network_firewall_policy_id'),
        url_list_summary_collections=pulumi.get(__response__, 'url_list_summary_collections')))
