# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['BackendSetArgs', 'BackendSet']

@pulumi.input_type
class BackendSetArgs:
    def __init__(__self__, *,
                 health_checker: pulumi.Input['BackendSetHealthCheckerArgs'],
                 network_load_balancer_id: pulumi.Input[builtins.str],
                 policy: pulumi.Input[builtins.str],
                 are_operationally_active_backends_preferred: Optional[pulumi.Input[builtins.bool]] = None,
                 ip_version: Optional[pulumi.Input[builtins.str]] = None,
                 is_fail_open: Optional[pulumi.Input[builtins.bool]] = None,
                 is_instant_failover_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 is_instant_failover_tcp_reset_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 is_preserve_source: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a BackendSet resource.
        :param pulumi.Input['BackendSetHealthCheckerArgs'] health_checker: (Updatable) The health check policy configuration. For more information, see [Editing Network Load Balancer Health Check Policies](https://docs.cloud.oracle.com/iaas/Content/NetworkLoadBalancer/HealthCheckPolicies/update-health-check-policy.htm).
        :param pulumi.Input[builtins.str] network_load_balancer_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the network load balancer to update.
        :param pulumi.Input[builtins.str] policy: (Updatable) The network load balancer policy for the backend set.  Example: `FIVE_TUPLE`` 
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        :param pulumi.Input[builtins.bool] are_operationally_active_backends_preferred: (Updatable) If enabled, NLB supports active-standby backends. The standby backend takes over the traffic when the active node fails, and continues to serve the traffic even when the old active node is back healthy.
        :param pulumi.Input[builtins.str] ip_version: (Updatable) IP version associated with the backend set.
        :param pulumi.Input[builtins.bool] is_fail_open: (Updatable) If enabled, the network load balancer will continue to distribute traffic in the configured distribution in the event all backends are unhealthy. The value is false by default.
        :param pulumi.Input[builtins.bool] is_instant_failover_enabled: (Updatable) If enabled existing connections will be forwarded to an alternative healthy backend as soon as current backend becomes unhealthy.
        :param pulumi.Input[builtins.bool] is_instant_failover_tcp_reset_enabled: (Updatable) If enabled along with instant failover, the network load balancer will send TCP RST to the clients for the existing connections instead of failing over to a healthy backend. This only applies when using the instant failover. By default, TCP RST is enabled.
        :param pulumi.Input[builtins.bool] is_preserve_source: (Updatable) If this parameter is enabled, then the network load balancer preserves the source IP of the packet when it is forwarded to backends. Backends see the original source IP. If the isPreserveSourceDestination parameter is enabled for the network load balancer resource, then this parameter cannot be disabled. The value is true by default.
        :param pulumi.Input[builtins.str] name: A user-friendly name for the backend set that must be unique and cannot be changed.
               
               Valid backend set names include only alphanumeric characters, dashes, and underscores. Backend set names cannot contain spaces. Avoid entering confidential information.
               
               Example: `example_backend_set`
        """
        pulumi.set(__self__, "health_checker", health_checker)
        pulumi.set(__self__, "network_load_balancer_id", network_load_balancer_id)
        pulumi.set(__self__, "policy", policy)
        if are_operationally_active_backends_preferred is not None:
            pulumi.set(__self__, "are_operationally_active_backends_preferred", are_operationally_active_backends_preferred)
        if ip_version is not None:
            pulumi.set(__self__, "ip_version", ip_version)
        if is_fail_open is not None:
            pulumi.set(__self__, "is_fail_open", is_fail_open)
        if is_instant_failover_enabled is not None:
            pulumi.set(__self__, "is_instant_failover_enabled", is_instant_failover_enabled)
        if is_instant_failover_tcp_reset_enabled is not None:
            pulumi.set(__self__, "is_instant_failover_tcp_reset_enabled", is_instant_failover_tcp_reset_enabled)
        if is_preserve_source is not None:
            pulumi.set(__self__, "is_preserve_source", is_preserve_source)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="healthChecker")
    def health_checker(self) -> pulumi.Input['BackendSetHealthCheckerArgs']:
        """
        (Updatable) The health check policy configuration. For more information, see [Editing Network Load Balancer Health Check Policies](https://docs.cloud.oracle.com/iaas/Content/NetworkLoadBalancer/HealthCheckPolicies/update-health-check-policy.htm).
        """
        return pulumi.get(self, "health_checker")

    @health_checker.setter
    def health_checker(self, value: pulumi.Input['BackendSetHealthCheckerArgs']):
        pulumi.set(self, "health_checker", value)

    @property
    @pulumi.getter(name="networkLoadBalancerId")
    def network_load_balancer_id(self) -> pulumi.Input[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the network load balancer to update.
        """
        return pulumi.get(self, "network_load_balancer_id")

    @network_load_balancer_id.setter
    def network_load_balancer_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "network_load_balancer_id", value)

    @property
    @pulumi.getter
    def policy(self) -> pulumi.Input[builtins.str]:
        """
        (Updatable) The network load balancer policy for the backend set.  Example: `FIVE_TUPLE`` 


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "policy")

    @policy.setter
    def policy(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "policy", value)

    @property
    @pulumi.getter(name="areOperationallyActiveBackendsPreferred")
    def are_operationally_active_backends_preferred(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (Updatable) If enabled, NLB supports active-standby backends. The standby backend takes over the traffic when the active node fails, and continues to serve the traffic even when the old active node is back healthy.
        """
        return pulumi.get(self, "are_operationally_active_backends_preferred")

    @are_operationally_active_backends_preferred.setter
    def are_operationally_active_backends_preferred(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "are_operationally_active_backends_preferred", value)

    @property
    @pulumi.getter(name="ipVersion")
    def ip_version(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Updatable) IP version associated with the backend set.
        """
        return pulumi.get(self, "ip_version")

    @ip_version.setter
    def ip_version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ip_version", value)

    @property
    @pulumi.getter(name="isFailOpen")
    def is_fail_open(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (Updatable) If enabled, the network load balancer will continue to distribute traffic in the configured distribution in the event all backends are unhealthy. The value is false by default.
        """
        return pulumi.get(self, "is_fail_open")

    @is_fail_open.setter
    def is_fail_open(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_fail_open", value)

    @property
    @pulumi.getter(name="isInstantFailoverEnabled")
    def is_instant_failover_enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (Updatable) If enabled existing connections will be forwarded to an alternative healthy backend as soon as current backend becomes unhealthy.
        """
        return pulumi.get(self, "is_instant_failover_enabled")

    @is_instant_failover_enabled.setter
    def is_instant_failover_enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_instant_failover_enabled", value)

    @property
    @pulumi.getter(name="isInstantFailoverTcpResetEnabled")
    def is_instant_failover_tcp_reset_enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (Updatable) If enabled along with instant failover, the network load balancer will send TCP RST to the clients for the existing connections instead of failing over to a healthy backend. This only applies when using the instant failover. By default, TCP RST is enabled.
        """
        return pulumi.get(self, "is_instant_failover_tcp_reset_enabled")

    @is_instant_failover_tcp_reset_enabled.setter
    def is_instant_failover_tcp_reset_enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_instant_failover_tcp_reset_enabled", value)

    @property
    @pulumi.getter(name="isPreserveSource")
    def is_preserve_source(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (Updatable) If this parameter is enabled, then the network load balancer preserves the source IP of the packet when it is forwarded to backends. Backends see the original source IP. If the isPreserveSourceDestination parameter is enabled for the network load balancer resource, then this parameter cannot be disabled. The value is true by default.
        """
        return pulumi.get(self, "is_preserve_source")

    @is_preserve_source.setter
    def is_preserve_source(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_preserve_source", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        A user-friendly name for the backend set that must be unique and cannot be changed.

        Valid backend set names include only alphanumeric characters, dashes, and underscores. Backend set names cannot contain spaces. Avoid entering confidential information.

        Example: `example_backend_set`
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _BackendSetState:
    def __init__(__self__, *,
                 are_operationally_active_backends_preferred: Optional[pulumi.Input[builtins.bool]] = None,
                 backends: Optional[pulumi.Input[Sequence[pulumi.Input['BackendSetBackendArgs']]]] = None,
                 health_checker: Optional[pulumi.Input['BackendSetHealthCheckerArgs']] = None,
                 ip_version: Optional[pulumi.Input[builtins.str]] = None,
                 is_fail_open: Optional[pulumi.Input[builtins.bool]] = None,
                 is_instant_failover_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 is_instant_failover_tcp_reset_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 is_preserve_source: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_load_balancer_id: Optional[pulumi.Input[builtins.str]] = None,
                 policy: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering BackendSet resources.
        :param pulumi.Input[builtins.bool] are_operationally_active_backends_preferred: (Updatable) If enabled, NLB supports active-standby backends. The standby backend takes over the traffic when the active node fails, and continues to serve the traffic even when the old active node is back healthy.
        :param pulumi.Input[Sequence[pulumi.Input['BackendSetBackendArgs']]] backends: (Updatable) An array of backends to be associated with the backend set.
        :param pulumi.Input['BackendSetHealthCheckerArgs'] health_checker: (Updatable) The health check policy configuration. For more information, see [Editing Network Load Balancer Health Check Policies](https://docs.cloud.oracle.com/iaas/Content/NetworkLoadBalancer/HealthCheckPolicies/update-health-check-policy.htm).
        :param pulumi.Input[builtins.str] ip_version: (Updatable) IP version associated with the backend set.
        :param pulumi.Input[builtins.bool] is_fail_open: (Updatable) If enabled, the network load balancer will continue to distribute traffic in the configured distribution in the event all backends are unhealthy. The value is false by default.
        :param pulumi.Input[builtins.bool] is_instant_failover_enabled: (Updatable) If enabled existing connections will be forwarded to an alternative healthy backend as soon as current backend becomes unhealthy.
        :param pulumi.Input[builtins.bool] is_instant_failover_tcp_reset_enabled: (Updatable) If enabled along with instant failover, the network load balancer will send TCP RST to the clients for the existing connections instead of failing over to a healthy backend. This only applies when using the instant failover. By default, TCP RST is enabled.
        :param pulumi.Input[builtins.bool] is_preserve_source: (Updatable) If this parameter is enabled, then the network load balancer preserves the source IP of the packet when it is forwarded to backends. Backends see the original source IP. If the isPreserveSourceDestination parameter is enabled for the network load balancer resource, then this parameter cannot be disabled. The value is true by default.
        :param pulumi.Input[builtins.str] name: A user-friendly name for the backend set that must be unique and cannot be changed.
               
               Valid backend set names include only alphanumeric characters, dashes, and underscores. Backend set names cannot contain spaces. Avoid entering confidential information.
               
               Example: `example_backend_set`
        :param pulumi.Input[builtins.str] network_load_balancer_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the network load balancer to update.
        :param pulumi.Input[builtins.str] policy: (Updatable) The network load balancer policy for the backend set.  Example: `FIVE_TUPLE`` 
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        if are_operationally_active_backends_preferred is not None:
            pulumi.set(__self__, "are_operationally_active_backends_preferred", are_operationally_active_backends_preferred)
        if backends is not None:
            pulumi.set(__self__, "backends", backends)
        if health_checker is not None:
            pulumi.set(__self__, "health_checker", health_checker)
        if ip_version is not None:
            pulumi.set(__self__, "ip_version", ip_version)
        if is_fail_open is not None:
            pulumi.set(__self__, "is_fail_open", is_fail_open)
        if is_instant_failover_enabled is not None:
            pulumi.set(__self__, "is_instant_failover_enabled", is_instant_failover_enabled)
        if is_instant_failover_tcp_reset_enabled is not None:
            pulumi.set(__self__, "is_instant_failover_tcp_reset_enabled", is_instant_failover_tcp_reset_enabled)
        if is_preserve_source is not None:
            pulumi.set(__self__, "is_preserve_source", is_preserve_source)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_load_balancer_id is not None:
            pulumi.set(__self__, "network_load_balancer_id", network_load_balancer_id)
        if policy is not None:
            pulumi.set(__self__, "policy", policy)

    @property
    @pulumi.getter(name="areOperationallyActiveBackendsPreferred")
    def are_operationally_active_backends_preferred(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (Updatable) If enabled, NLB supports active-standby backends. The standby backend takes over the traffic when the active node fails, and continues to serve the traffic even when the old active node is back healthy.
        """
        return pulumi.get(self, "are_operationally_active_backends_preferred")

    @are_operationally_active_backends_preferred.setter
    def are_operationally_active_backends_preferred(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "are_operationally_active_backends_preferred", value)

    @property
    @pulumi.getter
    def backends(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['BackendSetBackendArgs']]]]:
        """
        (Updatable) An array of backends to be associated with the backend set.
        """
        return pulumi.get(self, "backends")

    @backends.setter
    def backends(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['BackendSetBackendArgs']]]]):
        pulumi.set(self, "backends", value)

    @property
    @pulumi.getter(name="healthChecker")
    def health_checker(self) -> Optional[pulumi.Input['BackendSetHealthCheckerArgs']]:
        """
        (Updatable) The health check policy configuration. For more information, see [Editing Network Load Balancer Health Check Policies](https://docs.cloud.oracle.com/iaas/Content/NetworkLoadBalancer/HealthCheckPolicies/update-health-check-policy.htm).
        """
        return pulumi.get(self, "health_checker")

    @health_checker.setter
    def health_checker(self, value: Optional[pulumi.Input['BackendSetHealthCheckerArgs']]):
        pulumi.set(self, "health_checker", value)

    @property
    @pulumi.getter(name="ipVersion")
    def ip_version(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Updatable) IP version associated with the backend set.
        """
        return pulumi.get(self, "ip_version")

    @ip_version.setter
    def ip_version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ip_version", value)

    @property
    @pulumi.getter(name="isFailOpen")
    def is_fail_open(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (Updatable) If enabled, the network load balancer will continue to distribute traffic in the configured distribution in the event all backends are unhealthy. The value is false by default.
        """
        return pulumi.get(self, "is_fail_open")

    @is_fail_open.setter
    def is_fail_open(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_fail_open", value)

    @property
    @pulumi.getter(name="isInstantFailoverEnabled")
    def is_instant_failover_enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (Updatable) If enabled existing connections will be forwarded to an alternative healthy backend as soon as current backend becomes unhealthy.
        """
        return pulumi.get(self, "is_instant_failover_enabled")

    @is_instant_failover_enabled.setter
    def is_instant_failover_enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_instant_failover_enabled", value)

    @property
    @pulumi.getter(name="isInstantFailoverTcpResetEnabled")
    def is_instant_failover_tcp_reset_enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (Updatable) If enabled along with instant failover, the network load balancer will send TCP RST to the clients for the existing connections instead of failing over to a healthy backend. This only applies when using the instant failover. By default, TCP RST is enabled.
        """
        return pulumi.get(self, "is_instant_failover_tcp_reset_enabled")

    @is_instant_failover_tcp_reset_enabled.setter
    def is_instant_failover_tcp_reset_enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_instant_failover_tcp_reset_enabled", value)

    @property
    @pulumi.getter(name="isPreserveSource")
    def is_preserve_source(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (Updatable) If this parameter is enabled, then the network load balancer preserves the source IP of the packet when it is forwarded to backends. Backends see the original source IP. If the isPreserveSourceDestination parameter is enabled for the network load balancer resource, then this parameter cannot be disabled. The value is true by default.
        """
        return pulumi.get(self, "is_preserve_source")

    @is_preserve_source.setter
    def is_preserve_source(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_preserve_source", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        A user-friendly name for the backend set that must be unique and cannot be changed.

        Valid backend set names include only alphanumeric characters, dashes, and underscores. Backend set names cannot contain spaces. Avoid entering confidential information.

        Example: `example_backend_set`
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkLoadBalancerId")
    def network_load_balancer_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the network load balancer to update.
        """
        return pulumi.get(self, "network_load_balancer_id")

    @network_load_balancer_id.setter
    def network_load_balancer_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "network_load_balancer_id", value)

    @property
    @pulumi.getter
    def policy(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Updatable) The network load balancer policy for the backend set.  Example: `FIVE_TUPLE`` 


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "policy")

    @policy.setter
    def policy(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "policy", value)


@pulumi.type_token("oci:NetworkLoadBalancer/backendSet:BackendSet")
class BackendSet(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 are_operationally_active_backends_preferred: Optional[pulumi.Input[builtins.bool]] = None,
                 health_checker: Optional[pulumi.Input[Union['BackendSetHealthCheckerArgs', 'BackendSetHealthCheckerArgsDict']]] = None,
                 ip_version: Optional[pulumi.Input[builtins.str]] = None,
                 is_fail_open: Optional[pulumi.Input[builtins.bool]] = None,
                 is_instant_failover_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 is_instant_failover_tcp_reset_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 is_preserve_source: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_load_balancer_id: Optional[pulumi.Input[builtins.str]] = None,
                 policy: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        This resource provides the Backend Set resource in Oracle Cloud Infrastructure Network Load Balancer service.

        Adds a backend set to a network load balancer.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_backend_set = oci.network_load_balancer.BackendSet("test_backend_set",
            health_checker={
                "protocol": backend_set_health_checker_protocol,
                "dns": {
                    "domain_name": test_domain["name"],
                    "query_class": backend_set_health_checker_dns_query_class,
                    "query_type": backend_set_health_checker_dns_query_type,
                    "rcodes": backend_set_health_checker_dns_rcodes,
                    "transport_protocol": backend_set_health_checker_dns_transport_protocol,
                },
                "interval_in_millis": backend_set_health_checker_interval_in_millis,
                "port": backend_set_health_checker_port,
                "request_data": backend_set_health_checker_request_data,
                "response_body_regex": backend_set_health_checker_response_body_regex,
                "response_data": backend_set_health_checker_response_data,
                "retries": backend_set_health_checker_retries,
                "return_code": backend_set_health_checker_return_code,
                "timeout_in_millis": backend_set_health_checker_timeout_in_millis,
                "url_path": backend_set_health_checker_url_path,
            },
            name=backend_set_name,
            network_load_balancer_id=test_network_load_balancer["id"],
            policy=backend_set_policy,
            are_operationally_active_backends_preferred=backend_set_are_operationally_active_backends_preferred,
            ip_version=backend_set_ip_version,
            is_fail_open=backend_set_is_fail_open,
            is_instant_failover_enabled=backend_set_is_instant_failover_enabled,
            is_instant_failover_tcp_reset_enabled=backend_set_is_instant_failover_tcp_reset_enabled,
            is_preserve_source=backend_set_is_preserve_source)
        ```

        ## Import

        BackendSets can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:NetworkLoadBalancer/backendSet:BackendSet test_backend_set "networkLoadBalancers/{networkLoadBalancerId}/backendSets/{backendSetName}"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.bool] are_operationally_active_backends_preferred: (Updatable) If enabled, NLB supports active-standby backends. The standby backend takes over the traffic when the active node fails, and continues to serve the traffic even when the old active node is back healthy.
        :param pulumi.Input[Union['BackendSetHealthCheckerArgs', 'BackendSetHealthCheckerArgsDict']] health_checker: (Updatable) The health check policy configuration. For more information, see [Editing Network Load Balancer Health Check Policies](https://docs.cloud.oracle.com/iaas/Content/NetworkLoadBalancer/HealthCheckPolicies/update-health-check-policy.htm).
        :param pulumi.Input[builtins.str] ip_version: (Updatable) IP version associated with the backend set.
        :param pulumi.Input[builtins.bool] is_fail_open: (Updatable) If enabled, the network load balancer will continue to distribute traffic in the configured distribution in the event all backends are unhealthy. The value is false by default.
        :param pulumi.Input[builtins.bool] is_instant_failover_enabled: (Updatable) If enabled existing connections will be forwarded to an alternative healthy backend as soon as current backend becomes unhealthy.
        :param pulumi.Input[builtins.bool] is_instant_failover_tcp_reset_enabled: (Updatable) If enabled along with instant failover, the network load balancer will send TCP RST to the clients for the existing connections instead of failing over to a healthy backend. This only applies when using the instant failover. By default, TCP RST is enabled.
        :param pulumi.Input[builtins.bool] is_preserve_source: (Updatable) If this parameter is enabled, then the network load balancer preserves the source IP of the packet when it is forwarded to backends. Backends see the original source IP. If the isPreserveSourceDestination parameter is enabled for the network load balancer resource, then this parameter cannot be disabled. The value is true by default.
        :param pulumi.Input[builtins.str] name: A user-friendly name for the backend set that must be unique and cannot be changed.
               
               Valid backend set names include only alphanumeric characters, dashes, and underscores. Backend set names cannot contain spaces. Avoid entering confidential information.
               
               Example: `example_backend_set`
        :param pulumi.Input[builtins.str] network_load_balancer_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the network load balancer to update.
        :param pulumi.Input[builtins.str] policy: (Updatable) The network load balancer policy for the backend set.  Example: `FIVE_TUPLE`` 
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BackendSetArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource provides the Backend Set resource in Oracle Cloud Infrastructure Network Load Balancer service.

        Adds a backend set to a network load balancer.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_backend_set = oci.network_load_balancer.BackendSet("test_backend_set",
            health_checker={
                "protocol": backend_set_health_checker_protocol,
                "dns": {
                    "domain_name": test_domain["name"],
                    "query_class": backend_set_health_checker_dns_query_class,
                    "query_type": backend_set_health_checker_dns_query_type,
                    "rcodes": backend_set_health_checker_dns_rcodes,
                    "transport_protocol": backend_set_health_checker_dns_transport_protocol,
                },
                "interval_in_millis": backend_set_health_checker_interval_in_millis,
                "port": backend_set_health_checker_port,
                "request_data": backend_set_health_checker_request_data,
                "response_body_regex": backend_set_health_checker_response_body_regex,
                "response_data": backend_set_health_checker_response_data,
                "retries": backend_set_health_checker_retries,
                "return_code": backend_set_health_checker_return_code,
                "timeout_in_millis": backend_set_health_checker_timeout_in_millis,
                "url_path": backend_set_health_checker_url_path,
            },
            name=backend_set_name,
            network_load_balancer_id=test_network_load_balancer["id"],
            policy=backend_set_policy,
            are_operationally_active_backends_preferred=backend_set_are_operationally_active_backends_preferred,
            ip_version=backend_set_ip_version,
            is_fail_open=backend_set_is_fail_open,
            is_instant_failover_enabled=backend_set_is_instant_failover_enabled,
            is_instant_failover_tcp_reset_enabled=backend_set_is_instant_failover_tcp_reset_enabled,
            is_preserve_source=backend_set_is_preserve_source)
        ```

        ## Import

        BackendSets can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:NetworkLoadBalancer/backendSet:BackendSet test_backend_set "networkLoadBalancers/{networkLoadBalancerId}/backendSets/{backendSetName}"
        ```

        :param str resource_name: The name of the resource.
        :param BackendSetArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BackendSetArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 are_operationally_active_backends_preferred: Optional[pulumi.Input[builtins.bool]] = None,
                 health_checker: Optional[pulumi.Input[Union['BackendSetHealthCheckerArgs', 'BackendSetHealthCheckerArgsDict']]] = None,
                 ip_version: Optional[pulumi.Input[builtins.str]] = None,
                 is_fail_open: Optional[pulumi.Input[builtins.bool]] = None,
                 is_instant_failover_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 is_instant_failover_tcp_reset_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 is_preserve_source: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_load_balancer_id: Optional[pulumi.Input[builtins.str]] = None,
                 policy: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BackendSetArgs.__new__(BackendSetArgs)

            __props__.__dict__["are_operationally_active_backends_preferred"] = are_operationally_active_backends_preferred
            if health_checker is None and not opts.urn:
                raise TypeError("Missing required property 'health_checker'")
            __props__.__dict__["health_checker"] = health_checker
            __props__.__dict__["ip_version"] = ip_version
            __props__.__dict__["is_fail_open"] = is_fail_open
            __props__.__dict__["is_instant_failover_enabled"] = is_instant_failover_enabled
            __props__.__dict__["is_instant_failover_tcp_reset_enabled"] = is_instant_failover_tcp_reset_enabled
            __props__.__dict__["is_preserve_source"] = is_preserve_source
            __props__.__dict__["name"] = name
            if network_load_balancer_id is None and not opts.urn:
                raise TypeError("Missing required property 'network_load_balancer_id'")
            __props__.__dict__["network_load_balancer_id"] = network_load_balancer_id
            if policy is None and not opts.urn:
                raise TypeError("Missing required property 'policy'")
            __props__.__dict__["policy"] = policy
            __props__.__dict__["backends"] = None
        super(BackendSet, __self__).__init__(
            'oci:NetworkLoadBalancer/backendSet:BackendSet',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            are_operationally_active_backends_preferred: Optional[pulumi.Input[builtins.bool]] = None,
            backends: Optional[pulumi.Input[Sequence[pulumi.Input[Union['BackendSetBackendArgs', 'BackendSetBackendArgsDict']]]]] = None,
            health_checker: Optional[pulumi.Input[Union['BackendSetHealthCheckerArgs', 'BackendSetHealthCheckerArgsDict']]] = None,
            ip_version: Optional[pulumi.Input[builtins.str]] = None,
            is_fail_open: Optional[pulumi.Input[builtins.bool]] = None,
            is_instant_failover_enabled: Optional[pulumi.Input[builtins.bool]] = None,
            is_instant_failover_tcp_reset_enabled: Optional[pulumi.Input[builtins.bool]] = None,
            is_preserve_source: Optional[pulumi.Input[builtins.bool]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            network_load_balancer_id: Optional[pulumi.Input[builtins.str]] = None,
            policy: Optional[pulumi.Input[builtins.str]] = None) -> 'BackendSet':
        """
        Get an existing BackendSet resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.bool] are_operationally_active_backends_preferred: (Updatable) If enabled, NLB supports active-standby backends. The standby backend takes over the traffic when the active node fails, and continues to serve the traffic even when the old active node is back healthy.
        :param pulumi.Input[Sequence[pulumi.Input[Union['BackendSetBackendArgs', 'BackendSetBackendArgsDict']]]] backends: (Updatable) An array of backends to be associated with the backend set.
        :param pulumi.Input[Union['BackendSetHealthCheckerArgs', 'BackendSetHealthCheckerArgsDict']] health_checker: (Updatable) The health check policy configuration. For more information, see [Editing Network Load Balancer Health Check Policies](https://docs.cloud.oracle.com/iaas/Content/NetworkLoadBalancer/HealthCheckPolicies/update-health-check-policy.htm).
        :param pulumi.Input[builtins.str] ip_version: (Updatable) IP version associated with the backend set.
        :param pulumi.Input[builtins.bool] is_fail_open: (Updatable) If enabled, the network load balancer will continue to distribute traffic in the configured distribution in the event all backends are unhealthy. The value is false by default.
        :param pulumi.Input[builtins.bool] is_instant_failover_enabled: (Updatable) If enabled existing connections will be forwarded to an alternative healthy backend as soon as current backend becomes unhealthy.
        :param pulumi.Input[builtins.bool] is_instant_failover_tcp_reset_enabled: (Updatable) If enabled along with instant failover, the network load balancer will send TCP RST to the clients for the existing connections instead of failing over to a healthy backend. This only applies when using the instant failover. By default, TCP RST is enabled.
        :param pulumi.Input[builtins.bool] is_preserve_source: (Updatable) If this parameter is enabled, then the network load balancer preserves the source IP of the packet when it is forwarded to backends. Backends see the original source IP. If the isPreserveSourceDestination parameter is enabled for the network load balancer resource, then this parameter cannot be disabled. The value is true by default.
        :param pulumi.Input[builtins.str] name: A user-friendly name for the backend set that must be unique and cannot be changed.
               
               Valid backend set names include only alphanumeric characters, dashes, and underscores. Backend set names cannot contain spaces. Avoid entering confidential information.
               
               Example: `example_backend_set`
        :param pulumi.Input[builtins.str] network_load_balancer_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the network load balancer to update.
        :param pulumi.Input[builtins.str] policy: (Updatable) The network load balancer policy for the backend set.  Example: `FIVE_TUPLE`` 
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BackendSetState.__new__(_BackendSetState)

        __props__.__dict__["are_operationally_active_backends_preferred"] = are_operationally_active_backends_preferred
        __props__.__dict__["backends"] = backends
        __props__.__dict__["health_checker"] = health_checker
        __props__.__dict__["ip_version"] = ip_version
        __props__.__dict__["is_fail_open"] = is_fail_open
        __props__.__dict__["is_instant_failover_enabled"] = is_instant_failover_enabled
        __props__.__dict__["is_instant_failover_tcp_reset_enabled"] = is_instant_failover_tcp_reset_enabled
        __props__.__dict__["is_preserve_source"] = is_preserve_source
        __props__.__dict__["name"] = name
        __props__.__dict__["network_load_balancer_id"] = network_load_balancer_id
        __props__.__dict__["policy"] = policy
        return BackendSet(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="areOperationallyActiveBackendsPreferred")
    def are_operationally_active_backends_preferred(self) -> pulumi.Output[builtins.bool]:
        """
        (Updatable) If enabled, NLB supports active-standby backends. The standby backend takes over the traffic when the active node fails, and continues to serve the traffic even when the old active node is back healthy.
        """
        return pulumi.get(self, "are_operationally_active_backends_preferred")

    @property
    @pulumi.getter
    def backends(self) -> pulumi.Output[Sequence['outputs.BackendSetBackend']]:
        """
        (Updatable) An array of backends to be associated with the backend set.
        """
        return pulumi.get(self, "backends")

    @property
    @pulumi.getter(name="healthChecker")
    def health_checker(self) -> pulumi.Output['outputs.BackendSetHealthChecker']:
        """
        (Updatable) The health check policy configuration. For more information, see [Editing Network Load Balancer Health Check Policies](https://docs.cloud.oracle.com/iaas/Content/NetworkLoadBalancer/HealthCheckPolicies/update-health-check-policy.htm).
        """
        return pulumi.get(self, "health_checker")

    @property
    @pulumi.getter(name="ipVersion")
    def ip_version(self) -> pulumi.Output[builtins.str]:
        """
        (Updatable) IP version associated with the backend set.
        """
        return pulumi.get(self, "ip_version")

    @property
    @pulumi.getter(name="isFailOpen")
    def is_fail_open(self) -> pulumi.Output[builtins.bool]:
        """
        (Updatable) If enabled, the network load balancer will continue to distribute traffic in the configured distribution in the event all backends are unhealthy. The value is false by default.
        """
        return pulumi.get(self, "is_fail_open")

    @property
    @pulumi.getter(name="isInstantFailoverEnabled")
    def is_instant_failover_enabled(self) -> pulumi.Output[builtins.bool]:
        """
        (Updatable) If enabled existing connections will be forwarded to an alternative healthy backend as soon as current backend becomes unhealthy.
        """
        return pulumi.get(self, "is_instant_failover_enabled")

    @property
    @pulumi.getter(name="isInstantFailoverTcpResetEnabled")
    def is_instant_failover_tcp_reset_enabled(self) -> pulumi.Output[builtins.bool]:
        """
        (Updatable) If enabled along with instant failover, the network load balancer will send TCP RST to the clients for the existing connections instead of failing over to a healthy backend. This only applies when using the instant failover. By default, TCP RST is enabled.
        """
        return pulumi.get(self, "is_instant_failover_tcp_reset_enabled")

    @property
    @pulumi.getter(name="isPreserveSource")
    def is_preserve_source(self) -> pulumi.Output[builtins.bool]:
        """
        (Updatable) If this parameter is enabled, then the network load balancer preserves the source IP of the packet when it is forwarded to backends. Backends see the original source IP. If the isPreserveSourceDestination parameter is enabled for the network load balancer resource, then this parameter cannot be disabled. The value is true by default.
        """
        return pulumi.get(self, "is_preserve_source")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        A user-friendly name for the backend set that must be unique and cannot be changed.

        Valid backend set names include only alphanumeric characters, dashes, and underscores. Backend set names cannot contain spaces. Avoid entering confidential information.

        Example: `example_backend_set`
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkLoadBalancerId")
    def network_load_balancer_id(self) -> pulumi.Output[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the network load balancer to update.
        """
        return pulumi.get(self, "network_load_balancer_id")

    @property
    @pulumi.getter
    def policy(self) -> pulumi.Output[builtins.str]:
        """
        (Updatable) The network load balancer policy for the backend set.  Example: `FIVE_TUPLE`` 


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "policy")

