# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetNetworkLoadBalancersProtocolsResult',
    'AwaitableGetNetworkLoadBalancersProtocolsResult',
    'get_network_load_balancers_protocols',
    'get_network_load_balancers_protocols_output',
]

@pulumi.output_type
class GetNetworkLoadBalancersProtocolsResult:
    """
    A collection of values returned by getNetworkLoadBalancersProtocols.
    """
    def __init__(__self__, filters=None, id=None, network_load_balancers_protocol_collections=None):
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if network_load_balancers_protocol_collections and not isinstance(network_load_balancers_protocol_collections, list):
            raise TypeError("Expected argument 'network_load_balancers_protocol_collections' to be a list")
        pulumi.set(__self__, "network_load_balancers_protocol_collections", network_load_balancers_protocol_collections)

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetNetworkLoadBalancersProtocolsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="networkLoadBalancersProtocolCollections")
    def network_load_balancers_protocol_collections(self) -> Sequence['outputs.GetNetworkLoadBalancersProtocolsNetworkLoadBalancersProtocolCollectionResult']:
        """
        The list of network_load_balancers_protocol_collection.
        """
        return pulumi.get(self, "network_load_balancers_protocol_collections")


class AwaitableGetNetworkLoadBalancersProtocolsResult(GetNetworkLoadBalancersProtocolsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNetworkLoadBalancersProtocolsResult(
            filters=self.filters,
            id=self.id,
            network_load_balancers_protocol_collections=self.network_load_balancers_protocol_collections)


def get_network_load_balancers_protocols(filters: Optional[Sequence[Union['GetNetworkLoadBalancersProtocolsFilterArgs', 'GetNetworkLoadBalancersProtocolsFilterArgsDict']]] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNetworkLoadBalancersProtocolsResult:
    """
    This data source provides the list of Network Load Balancers Protocols in Oracle Cloud Infrastructure Network Load Balancer service.

    This API has been deprecated so it won't return the updated list of supported protocls.
    Lists all supported traffic protocols.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_network_load_balancers_protocols = oci.NetworkLoadBalancer.get_network_load_balancers_protocols()
    ```
    """
    __args__ = dict()
    __args__['filters'] = filters
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:NetworkLoadBalancer/getNetworkLoadBalancersProtocols:getNetworkLoadBalancersProtocols', __args__, opts=opts, typ=GetNetworkLoadBalancersProtocolsResult).value

    return AwaitableGetNetworkLoadBalancersProtocolsResult(
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        network_load_balancers_protocol_collections=pulumi.get(__ret__, 'network_load_balancers_protocol_collections'))
def get_network_load_balancers_protocols_output(filters: Optional[pulumi.Input[Optional[Sequence[Union['GetNetworkLoadBalancersProtocolsFilterArgs', 'GetNetworkLoadBalancersProtocolsFilterArgsDict']]]]] = None,
                                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetNetworkLoadBalancersProtocolsResult]:
    """
    This data source provides the list of Network Load Balancers Protocols in Oracle Cloud Infrastructure Network Load Balancer service.

    This API has been deprecated so it won't return the updated list of supported protocls.
    Lists all supported traffic protocols.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_network_load_balancers_protocols = oci.NetworkLoadBalancer.get_network_load_balancers_protocols()
    ```
    """
    __args__ = dict()
    __args__['filters'] = filters
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:NetworkLoadBalancer/getNetworkLoadBalancersProtocols:getNetworkLoadBalancersProtocols', __args__, opts=opts, typ=GetNetworkLoadBalancersProtocolsResult)
    return __ret__.apply(lambda __response__: GetNetworkLoadBalancersProtocolsResult(
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        network_load_balancers_protocol_collections=pulumi.get(__response__, 'network_load_balancers_protocol_collections')))
