# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = ['NamespaceMetadataArgs', 'NamespaceMetadata']

@pulumi.input_type
class NamespaceMetadataArgs:
    def __init__(__self__, *,
                 namespace: pulumi.Input[builtins.str],
                 default_s3compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 default_swift_compartment_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a NamespaceMetadata resource.
        """
        pulumi.set(__self__, "namespace", namespace)
        if default_s3compartment_id is not None:
            pulumi.set(__self__, "default_s3compartment_id", default_s3compartment_id)
        if default_swift_compartment_id is not None:
            pulumi.set(__self__, "default_swift_compartment_id", default_swift_compartment_id)

    @property
    @pulumi.getter
    def namespace(self) -> pulumi.Input[builtins.str]:
        return pulumi.get(self, "namespace")

    @namespace.setter
    def namespace(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "namespace", value)

    @property
    @pulumi.getter(name="defaultS3compartmentId")
    def default_s3compartment_id(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "default_s3compartment_id")

    @default_s3compartment_id.setter
    def default_s3compartment_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "default_s3compartment_id", value)

    @property
    @pulumi.getter(name="defaultSwiftCompartmentId")
    def default_swift_compartment_id(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "default_swift_compartment_id")

    @default_swift_compartment_id.setter
    def default_swift_compartment_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "default_swift_compartment_id", value)


@pulumi.input_type
class _NamespaceMetadataState:
    def __init__(__self__, *,
                 default_s3compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 default_swift_compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 namespace: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering NamespaceMetadata resources.
        """
        if default_s3compartment_id is not None:
            pulumi.set(__self__, "default_s3compartment_id", default_s3compartment_id)
        if default_swift_compartment_id is not None:
            pulumi.set(__self__, "default_swift_compartment_id", default_swift_compartment_id)
        if namespace is not None:
            pulumi.set(__self__, "namespace", namespace)

    @property
    @pulumi.getter(name="defaultS3compartmentId")
    def default_s3compartment_id(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "default_s3compartment_id")

    @default_s3compartment_id.setter
    def default_s3compartment_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "default_s3compartment_id", value)

    @property
    @pulumi.getter(name="defaultSwiftCompartmentId")
    def default_swift_compartment_id(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "default_swift_compartment_id")

    @default_swift_compartment_id.setter
    def default_swift_compartment_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "default_swift_compartment_id", value)

    @property
    @pulumi.getter
    def namespace(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "namespace")

    @namespace.setter
    def namespace(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "namespace", value)


@pulumi.type_token("oci:ObjectStorage/namespaceMetadata:NamespaceMetadata")
class NamespaceMetadata(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 default_s3compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 default_swift_compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 namespace: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Create a NamespaceMetadata resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NamespaceMetadataArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a NamespaceMetadata resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param NamespaceMetadataArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NamespaceMetadataArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 default_s3compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 default_swift_compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                 namespace: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NamespaceMetadataArgs.__new__(NamespaceMetadataArgs)

            __props__.__dict__["default_s3compartment_id"] = default_s3compartment_id
            __props__.__dict__["default_swift_compartment_id"] = default_swift_compartment_id
            if namespace is None and not opts.urn:
                raise TypeError("Missing required property 'namespace'")
            __props__.__dict__["namespace"] = namespace
        super(NamespaceMetadata, __self__).__init__(
            'oci:ObjectStorage/namespaceMetadata:NamespaceMetadata',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            default_s3compartment_id: Optional[pulumi.Input[builtins.str]] = None,
            default_swift_compartment_id: Optional[pulumi.Input[builtins.str]] = None,
            namespace: Optional[pulumi.Input[builtins.str]] = None) -> 'NamespaceMetadata':
        """
        Get an existing NamespaceMetadata resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NamespaceMetadataState.__new__(_NamespaceMetadataState)

        __props__.__dict__["default_s3compartment_id"] = default_s3compartment_id
        __props__.__dict__["default_swift_compartment_id"] = default_swift_compartment_id
        __props__.__dict__["namespace"] = namespace
        return NamespaceMetadata(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="defaultS3compartmentId")
    def default_s3compartment_id(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "default_s3compartment_id")

    @property
    @pulumi.getter(name="defaultSwiftCompartmentId")
    def default_swift_compartment_id(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "default_swift_compartment_id")

    @property
    @pulumi.getter
    def namespace(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "namespace")

