# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetRetrievePasswordResult',
    'AwaitableGetRetrievePasswordResult',
    'get_retrieve_password',
    'get_retrieve_password_output',
]

@pulumi.output_type
class GetRetrievePasswordResult:
    """
    A collection of values returned by getRetrievePassword.
    """
    def __init__(__self__, id=None, sddc_id=None, sddc_password=None, type=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if sddc_id and not isinstance(sddc_id, str):
            raise TypeError("Expected argument 'sddc_id' to be a str")
        pulumi.set(__self__, "sddc_id", sddc_id)
        if sddc_password and not isinstance(sddc_password, dict):
            raise TypeError("Expected argument 'sddc_password' to be a dict")
        pulumi.set(__self__, "sddc_password", sddc_password)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="sddcId")
    def sddc_id(self) -> builtins.str:
        return pulumi.get(self, "sddc_id")

    @property
    @pulumi.getter(name="sddcPassword")
    def sddc_password(self) -> Mapping[str, builtins.str]:
        """
        SDDC vCenter/NSX/HCX password.
        * `passwordType` - SDDC password type.
        """
        return pulumi.get(self, "sddc_password")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        return pulumi.get(self, "type")


class AwaitableGetRetrievePasswordResult(GetRetrievePasswordResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRetrievePasswordResult(
            id=self.id,
            sddc_id=self.sddc_id,
            sddc_password=self.sddc_password,
            type=self.type)


def get_retrieve_password(sddc_id: Optional[builtins.str] = None,
                          type: Optional[builtins.str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRetrievePasswordResult:
    """
    This data source retrieves the SDDC password in Oracle Cloud Infrastructure Oracle Cloud VMware Solution service.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_password = oci.Ocvp.get_retrieve_password(sddc_id=compartment_id,
        type=password_type)
    ```


    :param builtins.str sddc_id: The [OCID](https://www.terraform.io/Content/General/Concepts/identifiers.htm) of the SDDC.
    :param builtins.str type: The SDDC password type.
    """
    __args__ = dict()
    __args__['sddcId'] = sddc_id
    __args__['type'] = type
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Ocvp/getRetrievePassword:getRetrievePassword', __args__, opts=opts, typ=GetRetrievePasswordResult).value

    return AwaitableGetRetrievePasswordResult(
        id=pulumi.get(__ret__, 'id'),
        sddc_id=pulumi.get(__ret__, 'sddc_id'),
        sddc_password=pulumi.get(__ret__, 'sddc_password'),
        type=pulumi.get(__ret__, 'type'))
def get_retrieve_password_output(sddc_id: Optional[pulumi.Input[builtins.str]] = None,
                                 type: Optional[pulumi.Input[builtins.str]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetRetrievePasswordResult]:
    """
    This data source retrieves the SDDC password in Oracle Cloud Infrastructure Oracle Cloud VMware Solution service.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_password = oci.Ocvp.get_retrieve_password(sddc_id=compartment_id,
        type=password_type)
    ```


    :param builtins.str sddc_id: The [OCID](https://www.terraform.io/Content/General/Concepts/identifiers.htm) of the SDDC.
    :param builtins.str type: The SDDC password type.
    """
    __args__ = dict()
    __args__['sddcId'] = sddc_id
    __args__['type'] = type
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Ocvp/getRetrievePassword:getRetrievePassword', __args__, opts=opts, typ=GetRetrievePasswordResult)
    return __ret__.apply(lambda __response__: GetRetrievePasswordResult(
        id=pulumi.get(__response__, 'id'),
        sddc_id=pulumi.get(__response__, 'sddc_id'),
        sddc_password=pulumi.get(__response__, 'sddc_password'),
        type=pulumi.get(__response__, 'type')))
