# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetAggregatedComputedUsagesResult',
    'AwaitableGetAggregatedComputedUsagesResult',
    'get_aggregated_computed_usages',
    'get_aggregated_computed_usages_output',
]

@pulumi.output_type
class GetAggregatedComputedUsagesResult:
    """
    A collection of values returned by getAggregatedComputedUsages.
    """
    def __init__(__self__, aggregated_computed_usages=None, compartment_id=None, filters=None, grouping=None, id=None, parent_product=None, subscription_id=None, time_from=None, time_to=None):
        if aggregated_computed_usages and not isinstance(aggregated_computed_usages, list):
            raise TypeError("Expected argument 'aggregated_computed_usages' to be a list")
        pulumi.set(__self__, "aggregated_computed_usages", aggregated_computed_usages)
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if grouping and not isinstance(grouping, str):
            raise TypeError("Expected argument 'grouping' to be a str")
        pulumi.set(__self__, "grouping", grouping)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if parent_product and not isinstance(parent_product, str):
            raise TypeError("Expected argument 'parent_product' to be a str")
        pulumi.set(__self__, "parent_product", parent_product)
        if subscription_id and not isinstance(subscription_id, str):
            raise TypeError("Expected argument 'subscription_id' to be a str")
        pulumi.set(__self__, "subscription_id", subscription_id)
        if time_from and not isinstance(time_from, str):
            raise TypeError("Expected argument 'time_from' to be a str")
        pulumi.set(__self__, "time_from", time_from)
        if time_to and not isinstance(time_to, str):
            raise TypeError("Expected argument 'time_to' to be a str")
        pulumi.set(__self__, "time_to", time_to)

    @property
    @pulumi.getter(name="aggregatedComputedUsages")
    def aggregated_computed_usages(self) -> Sequence['outputs.GetAggregatedComputedUsagesAggregatedComputedUsageResult']:
        """
        Aggregation of computed usages for the subscribed service.
        """
        return pulumi.get(self, "aggregated_computed_usages")

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetAggregatedComputedUsagesFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def grouping(self) -> Optional[builtins.str]:
        return pulumi.get(self, "grouping")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="parentProduct")
    def parent_product(self) -> Optional[builtins.str]:
        """
        Product description
        """
        return pulumi.get(self, "parent_product")

    @property
    @pulumi.getter(name="subscriptionId")
    def subscription_id(self) -> builtins.str:
        """
        Subscription Id is an identifier associated to the service used for filter the Computed Usage in SPM
        """
        return pulumi.get(self, "subscription_id")

    @property
    @pulumi.getter(name="timeFrom")
    def time_from(self) -> builtins.str:
        return pulumi.get(self, "time_from")

    @property
    @pulumi.getter(name="timeTo")
    def time_to(self) -> builtins.str:
        return pulumi.get(self, "time_to")


class AwaitableGetAggregatedComputedUsagesResult(GetAggregatedComputedUsagesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAggregatedComputedUsagesResult(
            aggregated_computed_usages=self.aggregated_computed_usages,
            compartment_id=self.compartment_id,
            filters=self.filters,
            grouping=self.grouping,
            id=self.id,
            parent_product=self.parent_product,
            subscription_id=self.subscription_id,
            time_from=self.time_from,
            time_to=self.time_to)


def get_aggregated_computed_usages(compartment_id: Optional[builtins.str] = None,
                                   filters: Optional[Sequence[Union['GetAggregatedComputedUsagesFilterArgs', 'GetAggregatedComputedUsagesFilterArgsDict']]] = None,
                                   grouping: Optional[builtins.str] = None,
                                   parent_product: Optional[builtins.str] = None,
                                   subscription_id: Optional[builtins.str] = None,
                                   time_from: Optional[builtins.str] = None,
                                   time_to: Optional[builtins.str] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAggregatedComputedUsagesResult:
    """
    This data source provides the list of Aggregated Computed Usages in Oracle Cloud Infrastructure Onesubscription service.

    This is a collection API which returns a list of aggregated computed usage details (there can be multiple Parent Products under a given SubID each of which is represented under Subscription Service Line # in SPM).


    :param builtins.str compartment_id: The OCID of the root compartment.
    :param builtins.str grouping: Grouping criteria to use for aggregate the computed Usage, either hourly (`HOURLY`), daily (`DAILY`), monthly(`MONTHLY`) or none (`NONE`) to not follow a grouping criteria by date.
    :param builtins.str parent_product: Product part number for subscribed service line, called parent product.
    :param builtins.str subscription_id: Subscription Id is an identifier associated to the service used for filter the Computed Usage in SPM.
    :param builtins.str time_from: Initial date to filter Computed Usage data in SPM. In the case of non aggregated data the time period between of fromDate and toDate , expressed in RFC 3339 timestamp format.
    :param builtins.str time_to: Final date to filter Computed Usage data in SPM, expressed in RFC 3339 timestamp format.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['filters'] = filters
    __args__['grouping'] = grouping
    __args__['parentProduct'] = parent_product
    __args__['subscriptionId'] = subscription_id
    __args__['timeFrom'] = time_from
    __args__['timeTo'] = time_to
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:OneSubsription/getAggregatedComputedUsages:getAggregatedComputedUsages', __args__, opts=opts, typ=GetAggregatedComputedUsagesResult).value

    return AwaitableGetAggregatedComputedUsagesResult(
        aggregated_computed_usages=pulumi.get(__ret__, 'aggregated_computed_usages'),
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        filters=pulumi.get(__ret__, 'filters'),
        grouping=pulumi.get(__ret__, 'grouping'),
        id=pulumi.get(__ret__, 'id'),
        parent_product=pulumi.get(__ret__, 'parent_product'),
        subscription_id=pulumi.get(__ret__, 'subscription_id'),
        time_from=pulumi.get(__ret__, 'time_from'),
        time_to=pulumi.get(__ret__, 'time_to'))
def get_aggregated_computed_usages_output(compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                                          filters: Optional[pulumi.Input[Optional[Sequence[Union['GetAggregatedComputedUsagesFilterArgs', 'GetAggregatedComputedUsagesFilterArgsDict']]]]] = None,
                                          grouping: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                          parent_product: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                          subscription_id: Optional[pulumi.Input[builtins.str]] = None,
                                          time_from: Optional[pulumi.Input[builtins.str]] = None,
                                          time_to: Optional[pulumi.Input[builtins.str]] = None,
                                          opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetAggregatedComputedUsagesResult]:
    """
    This data source provides the list of Aggregated Computed Usages in Oracle Cloud Infrastructure Onesubscription service.

    This is a collection API which returns a list of aggregated computed usage details (there can be multiple Parent Products under a given SubID each of which is represented under Subscription Service Line # in SPM).


    :param builtins.str compartment_id: The OCID of the root compartment.
    :param builtins.str grouping: Grouping criteria to use for aggregate the computed Usage, either hourly (`HOURLY`), daily (`DAILY`), monthly(`MONTHLY`) or none (`NONE`) to not follow a grouping criteria by date.
    :param builtins.str parent_product: Product part number for subscribed service line, called parent product.
    :param builtins.str subscription_id: Subscription Id is an identifier associated to the service used for filter the Computed Usage in SPM.
    :param builtins.str time_from: Initial date to filter Computed Usage data in SPM. In the case of non aggregated data the time period between of fromDate and toDate , expressed in RFC 3339 timestamp format.
    :param builtins.str time_to: Final date to filter Computed Usage data in SPM, expressed in RFC 3339 timestamp format.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['filters'] = filters
    __args__['grouping'] = grouping
    __args__['parentProduct'] = parent_product
    __args__['subscriptionId'] = subscription_id
    __args__['timeFrom'] = time_from
    __args__['timeTo'] = time_to
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:OneSubsription/getAggregatedComputedUsages:getAggregatedComputedUsages', __args__, opts=opts, typ=GetAggregatedComputedUsagesResult)
    return __ret__.apply(lambda __response__: GetAggregatedComputedUsagesResult(
        aggregated_computed_usages=pulumi.get(__response__, 'aggregated_computed_usages'),
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        filters=pulumi.get(__response__, 'filters'),
        grouping=pulumi.get(__response__, 'grouping'),
        id=pulumi.get(__response__, 'id'),
        parent_product=pulumi.get(__response__, 'parent_product'),
        subscription_id=pulumi.get(__response__, 'subscription_id'),
        time_from=pulumi.get(__response__, 'time_from'),
        time_to=pulumi.get(__response__, 'time_to')))
