# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetOrganizationSubscriptionsResult',
    'AwaitableGetOrganizationSubscriptionsResult',
    'get_organization_subscriptions',
    'get_organization_subscriptions_output',
]

@pulumi.output_type
class GetOrganizationSubscriptionsResult:
    """
    A collection of values returned by getOrganizationSubscriptions.
    """
    def __init__(__self__, compartment_id=None, filters=None, id=None, organization_subscriptions=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if organization_subscriptions and not isinstance(organization_subscriptions, list):
            raise TypeError("Expected argument 'organization_subscriptions' to be a list")
        pulumi.set(__self__, "organization_subscriptions", organization_subscriptions)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetOrganizationSubscriptionsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="organizationSubscriptions")
    def organization_subscriptions(self) -> Sequence['outputs.GetOrganizationSubscriptionsOrganizationSubscriptionResult']:
        """
        The list of organization_subscriptions.
        """
        return pulumi.get(self, "organization_subscriptions")


class AwaitableGetOrganizationSubscriptionsResult(GetOrganizationSubscriptionsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOrganizationSubscriptionsResult(
            compartment_id=self.compartment_id,
            filters=self.filters,
            id=self.id,
            organization_subscriptions=self.organization_subscriptions)


def get_organization_subscriptions(compartment_id: Optional[builtins.str] = None,
                                   filters: Optional[Sequence[Union['GetOrganizationSubscriptionsFilterArgs', 'GetOrganizationSubscriptionsFilterArgsDict']]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOrganizationSubscriptionsResult:
    """
    This data source provides the list of Organization Subscriptions in Oracle Cloud Infrastructure Onesubscription service.

    API that returns data for the list of subscription ids returned from Organizations API

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_organization_subscriptions = oci.OneSubsription.get_organization_subscriptions(compartment_id=compartment_id)
    ```


    :param builtins.str compartment_id: The OCID of the root compartment.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['filters'] = filters
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:OneSubsription/getOrganizationSubscriptions:getOrganizationSubscriptions', __args__, opts=opts, typ=GetOrganizationSubscriptionsResult).value

    return AwaitableGetOrganizationSubscriptionsResult(
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        organization_subscriptions=pulumi.get(__ret__, 'organization_subscriptions'))
def get_organization_subscriptions_output(compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                                          filters: Optional[pulumi.Input[Optional[Sequence[Union['GetOrganizationSubscriptionsFilterArgs', 'GetOrganizationSubscriptionsFilterArgsDict']]]]] = None,
                                          opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetOrganizationSubscriptionsResult]:
    """
    This data source provides the list of Organization Subscriptions in Oracle Cloud Infrastructure Onesubscription service.

    API that returns data for the list of subscription ids returned from Organizations API

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_organization_subscriptions = oci.OneSubsription.get_organization_subscriptions(compartment_id=compartment_id)
    ```


    :param builtins.str compartment_id: The OCID of the root compartment.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['filters'] = filters
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:OneSubsription/getOrganizationSubscriptions:getOrganizationSubscriptions', __args__, opts=opts, typ=GetOrganizationSubscriptionsResult)
    return __ret__.apply(lambda __response__: GetOrganizationSubscriptionsResult(
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        organization_subscriptions=pulumi.get(__response__, 'organization_subscriptions')))
