# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetAwrHubsResult',
    'AwaitableGetAwrHubsResult',
    'get_awr_hubs',
    'get_awr_hubs_output',
]

@pulumi.output_type
class GetAwrHubsResult:
    """
    A collection of values returned by getAwrHubs.
    """
    def __init__(__self__, awr_hub_summary_collections=None, compartment_id=None, display_name=None, filters=None, id=None, operations_insights_warehouse_id=None, states=None):
        if awr_hub_summary_collections and not isinstance(awr_hub_summary_collections, list):
            raise TypeError("Expected argument 'awr_hub_summary_collections' to be a list")
        pulumi.set(__self__, "awr_hub_summary_collections", awr_hub_summary_collections)
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if operations_insights_warehouse_id and not isinstance(operations_insights_warehouse_id, str):
            raise TypeError("Expected argument 'operations_insights_warehouse_id' to be a str")
        pulumi.set(__self__, "operations_insights_warehouse_id", operations_insights_warehouse_id)
        if states and not isinstance(states, list):
            raise TypeError("Expected argument 'states' to be a list")
        pulumi.set(__self__, "states", states)

    @property
    @pulumi.getter(name="awrHubSummaryCollections")
    def awr_hub_summary_collections(self) -> Sequence['outputs.GetAwrHubsAwrHubSummaryCollectionResult']:
        """
        The list of awr_hub_summary_collection.
        """
        return pulumi.get(self, "awr_hub_summary_collections")

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> Optional[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[builtins.str]:
        """
        User-friedly name of AWR Hub that does not have to be unique.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetAwrHubsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        AWR Hub OCID
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="operationsInsightsWarehouseId")
    def operations_insights_warehouse_id(self) -> builtins.str:
        """
        OPSI Warehouse OCID
        """
        return pulumi.get(self, "operations_insights_warehouse_id")

    @property
    @pulumi.getter
    def states(self) -> Optional[Sequence[builtins.str]]:
        """
        Possible lifecycle states
        """
        return pulumi.get(self, "states")


class AwaitableGetAwrHubsResult(GetAwrHubsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAwrHubsResult(
            awr_hub_summary_collections=self.awr_hub_summary_collections,
            compartment_id=self.compartment_id,
            display_name=self.display_name,
            filters=self.filters,
            id=self.id,
            operations_insights_warehouse_id=self.operations_insights_warehouse_id,
            states=self.states)


def get_awr_hubs(compartment_id: Optional[builtins.str] = None,
                 display_name: Optional[builtins.str] = None,
                 filters: Optional[Sequence[Union['GetAwrHubsFilterArgs', 'GetAwrHubsFilterArgsDict']]] = None,
                 id: Optional[builtins.str] = None,
                 operations_insights_warehouse_id: Optional[builtins.str] = None,
                 states: Optional[Sequence[builtins.str]] = None,
                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAwrHubsResult:
    """
    This data source provides the list of Awr Hubs in Oracle Cloud Infrastructure Opsi service.

    Gets a list of AWR hubs. Either compartmentId or id must be specified. All these resources are expected to be in root compartment.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_awr_hubs = oci.Opsi.get_awr_hubs(operations_insights_warehouse_id=test_operations_insights_warehouse["id"],
        compartment_id=compartment_id,
        display_name=awr_hub_display_name,
        id=awr_hub_id,
        states=awr_hub_state)
    ```


    :param builtins.str compartment_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
    :param builtins.str display_name: A filter to return only resources that match the entire display name.
    :param builtins.str id: Unique Awr Hub identifier
    :param builtins.str operations_insights_warehouse_id: Unique Operations Insights Warehouse identifier
    :param Sequence[builtins.str] states: Lifecycle states
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['id'] = id
    __args__['operationsInsightsWarehouseId'] = operations_insights_warehouse_id
    __args__['states'] = states
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Opsi/getAwrHubs:getAwrHubs', __args__, opts=opts, typ=GetAwrHubsResult).value

    return AwaitableGetAwrHubsResult(
        awr_hub_summary_collections=pulumi.get(__ret__, 'awr_hub_summary_collections'),
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        display_name=pulumi.get(__ret__, 'display_name'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        operations_insights_warehouse_id=pulumi.get(__ret__, 'operations_insights_warehouse_id'),
        states=pulumi.get(__ret__, 'states'))
def get_awr_hubs_output(compartment_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                        display_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                        filters: Optional[pulumi.Input[Optional[Sequence[Union['GetAwrHubsFilterArgs', 'GetAwrHubsFilterArgsDict']]]]] = None,
                        id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                        operations_insights_warehouse_id: Optional[pulumi.Input[builtins.str]] = None,
                        states: Optional[pulumi.Input[Optional[Sequence[builtins.str]]]] = None,
                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetAwrHubsResult]:
    """
    This data source provides the list of Awr Hubs in Oracle Cloud Infrastructure Opsi service.

    Gets a list of AWR hubs. Either compartmentId or id must be specified. All these resources are expected to be in root compartment.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_awr_hubs = oci.Opsi.get_awr_hubs(operations_insights_warehouse_id=test_operations_insights_warehouse["id"],
        compartment_id=compartment_id,
        display_name=awr_hub_display_name,
        id=awr_hub_id,
        states=awr_hub_state)
    ```


    :param builtins.str compartment_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
    :param builtins.str display_name: A filter to return only resources that match the entire display name.
    :param builtins.str id: Unique Awr Hub identifier
    :param builtins.str operations_insights_warehouse_id: Unique Operations Insights Warehouse identifier
    :param Sequence[builtins.str] states: Lifecycle states
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['id'] = id
    __args__['operationsInsightsWarehouseId'] = operations_insights_warehouse_id
    __args__['states'] = states
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Opsi/getAwrHubs:getAwrHubs', __args__, opts=opts, typ=GetAwrHubsResult)
    return __ret__.apply(lambda __response__: GetAwrHubsResult(
        awr_hub_summary_collections=pulumi.get(__response__, 'awr_hub_summary_collections'),
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        display_name=pulumi.get(__response__, 'display_name'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        operations_insights_warehouse_id=pulumi.get(__response__, 'operations_insights_warehouse_id'),
        states=pulumi.get(__response__, 'states')))
