# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetRecommendationStrategyResult',
    'AwaitableGetRecommendationStrategyResult',
    'get_recommendation_strategy',
    'get_recommendation_strategy_output',
]

@pulumi.output_type
class GetRecommendationStrategyResult:
    """
    A collection of values returned by getRecommendationStrategy.
    """
    def __init__(__self__, compartment_id=None, compartment_id_in_subtree=None, id=None, items=None, name=None, recommendation_name=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if compartment_id_in_subtree and not isinstance(compartment_id_in_subtree, bool):
            raise TypeError("Expected argument 'compartment_id_in_subtree' to be a bool")
        pulumi.set(__self__, "compartment_id_in_subtree", compartment_id_in_subtree)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if recommendation_name and not isinstance(recommendation_name, str):
            raise TypeError("Expected argument 'recommendation_name' to be a str")
        pulumi.set(__self__, "recommendation_name", recommendation_name)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="compartmentIdInSubtree")
    def compartment_id_in_subtree(self) -> builtins.bool:
        return pulumi.get(self, "compartment_id_in_subtree")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetRecommendationStrategyItemResult']:
        """
        A collection of recommendation strategy summaries.
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        """
        The name of the strategy parameter.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="recommendationName")
    def recommendation_name(self) -> Optional[builtins.str]:
        return pulumi.get(self, "recommendation_name")


class AwaitableGetRecommendationStrategyResult(GetRecommendationStrategyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRecommendationStrategyResult(
            compartment_id=self.compartment_id,
            compartment_id_in_subtree=self.compartment_id_in_subtree,
            id=self.id,
            items=self.items,
            name=self.name,
            recommendation_name=self.recommendation_name)


def get_recommendation_strategy(compartment_id: Optional[builtins.str] = None,
                                compartment_id_in_subtree: Optional[builtins.bool] = None,
                                name: Optional[builtins.str] = None,
                                recommendation_name: Optional[builtins.str] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRecommendationStrategyResult:
    """
    This data source provides details about a specific Recommendation Strategy resource in Oracle Cloud Infrastructure Optimizer service.

    Lists the existing strategies.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_recommendation_strategy = oci.Optimizer.get_recommendation_strategy(compartment_id=compartment_id,
        compartment_id_in_subtree=recommendation_strategy_compartment_id_in_subtree,
        name=recommendation_strategy_name,
        recommendation_name=test_recommendation["name"])
    ```


    :param builtins.str compartment_id: The OCID of the compartment.
    :param builtins.bool compartment_id_in_subtree: When set to true, the hierarchy of compartments is traversed and all compartments and subcompartments in the tenancy are returned depending on the the setting of `accessLevel`.
           
           Can only be set to true when performing ListCompartments on the tenancy (root compartment).
    :param builtins.str name: Optional. A filter that returns results that match the name specified.
    :param builtins.str recommendation_name: Optional. A filter that returns results that match the recommendation name specified.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['compartmentIdInSubtree'] = compartment_id_in_subtree
    __args__['name'] = name
    __args__['recommendationName'] = recommendation_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Optimizer/getRecommendationStrategy:getRecommendationStrategy', __args__, opts=opts, typ=GetRecommendationStrategyResult).value

    return AwaitableGetRecommendationStrategyResult(
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        compartment_id_in_subtree=pulumi.get(__ret__, 'compartment_id_in_subtree'),
        id=pulumi.get(__ret__, 'id'),
        items=pulumi.get(__ret__, 'items'),
        name=pulumi.get(__ret__, 'name'),
        recommendation_name=pulumi.get(__ret__, 'recommendation_name'))
def get_recommendation_strategy_output(compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                                       compartment_id_in_subtree: Optional[pulumi.Input[builtins.bool]] = None,
                                       name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                       recommendation_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                       opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetRecommendationStrategyResult]:
    """
    This data source provides details about a specific Recommendation Strategy resource in Oracle Cloud Infrastructure Optimizer service.

    Lists the existing strategies.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_recommendation_strategy = oci.Optimizer.get_recommendation_strategy(compartment_id=compartment_id,
        compartment_id_in_subtree=recommendation_strategy_compartment_id_in_subtree,
        name=recommendation_strategy_name,
        recommendation_name=test_recommendation["name"])
    ```


    :param builtins.str compartment_id: The OCID of the compartment.
    :param builtins.bool compartment_id_in_subtree: When set to true, the hierarchy of compartments is traversed and all compartments and subcompartments in the tenancy are returned depending on the the setting of `accessLevel`.
           
           Can only be set to true when performing ListCompartments on the tenancy (root compartment).
    :param builtins.str name: Optional. A filter that returns results that match the name specified.
    :param builtins.str recommendation_name: Optional. A filter that returns results that match the recommendation name specified.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['compartmentIdInSubtree'] = compartment_id_in_subtree
    __args__['name'] = name
    __args__['recommendationName'] = recommendation_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Optimizer/getRecommendationStrategy:getRecommendationStrategy', __args__, opts=opts, typ=GetRecommendationStrategyResult)
    return __ret__.apply(lambda __response__: GetRecommendationStrategyResult(
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        compartment_id_in_subtree=pulumi.get(__response__, 'compartment_id_in_subtree'),
        id=pulumi.get(__response__, 'id'),
        items=pulumi.get(__response__, 'items'),
        name=pulumi.get(__response__, 'name'),
        recommendation_name=pulumi.get(__response__, 'recommendation_name')))
