# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ManagedInstanceUpdatePackagesManagementArgs', 'ManagedInstanceUpdatePackagesManagement']

@pulumi.input_type
class ManagedInstanceUpdatePackagesManagementArgs:
    def __init__(__self__, *,
                 managed_instance_id: pulumi.Input[builtins.str],
                 package_names: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 update_types: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 work_request_details: Optional[pulumi.Input['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs']] = None):
        """
        The set of arguments for constructing a ManagedInstanceUpdatePackagesManagement resource.
        :param pulumi.Input[builtins.str] managed_instance_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the managed instance.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] package_names: The list of package names.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] update_types: The types of updates to be applied.
        :param pulumi.Input['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs'] work_request_details: Provides the name and description of the job.
        """
        pulumi.set(__self__, "managed_instance_id", managed_instance_id)
        if package_names is not None:
            pulumi.set(__self__, "package_names", package_names)
        if update_types is not None:
            pulumi.set(__self__, "update_types", update_types)
        if work_request_details is not None:
            pulumi.set(__self__, "work_request_details", work_request_details)

    @property
    @pulumi.getter(name="managedInstanceId")
    def managed_instance_id(self) -> pulumi.Input[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the managed instance.
        """
        return pulumi.get(self, "managed_instance_id")

    @managed_instance_id.setter
    def managed_instance_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "managed_instance_id", value)

    @property
    @pulumi.getter(name="packageNames")
    def package_names(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The list of package names.
        """
        return pulumi.get(self, "package_names")

    @package_names.setter
    def package_names(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "package_names", value)

    @property
    @pulumi.getter(name="updateTypes")
    def update_types(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The types of updates to be applied.
        """
        return pulumi.get(self, "update_types")

    @update_types.setter
    def update_types(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "update_types", value)

    @property
    @pulumi.getter(name="workRequestDetails")
    def work_request_details(self) -> Optional[pulumi.Input['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs']]:
        """
        Provides the name and description of the job.
        """
        return pulumi.get(self, "work_request_details")

    @work_request_details.setter
    def work_request_details(self, value: Optional[pulumi.Input['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs']]):
        pulumi.set(self, "work_request_details", value)


@pulumi.input_type
class _ManagedInstanceUpdatePackagesManagementState:
    def __init__(__self__, *,
                 managed_instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 package_names: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 update_types: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 work_request_details: Optional[pulumi.Input['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs']] = None):
        """
        Input properties used for looking up and filtering ManagedInstanceUpdatePackagesManagement resources.
        :param pulumi.Input[builtins.str] managed_instance_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the managed instance.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] package_names: The list of package names.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] update_types: The types of updates to be applied.
        :param pulumi.Input['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs'] work_request_details: Provides the name and description of the job.
        """
        if managed_instance_id is not None:
            pulumi.set(__self__, "managed_instance_id", managed_instance_id)
        if package_names is not None:
            pulumi.set(__self__, "package_names", package_names)
        if update_types is not None:
            pulumi.set(__self__, "update_types", update_types)
        if work_request_details is not None:
            pulumi.set(__self__, "work_request_details", work_request_details)

    @property
    @pulumi.getter(name="managedInstanceId")
    def managed_instance_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the managed instance.
        """
        return pulumi.get(self, "managed_instance_id")

    @managed_instance_id.setter
    def managed_instance_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "managed_instance_id", value)

    @property
    @pulumi.getter(name="packageNames")
    def package_names(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The list of package names.
        """
        return pulumi.get(self, "package_names")

    @package_names.setter
    def package_names(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "package_names", value)

    @property
    @pulumi.getter(name="updateTypes")
    def update_types(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The types of updates to be applied.
        """
        return pulumi.get(self, "update_types")

    @update_types.setter
    def update_types(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "update_types", value)

    @property
    @pulumi.getter(name="workRequestDetails")
    def work_request_details(self) -> Optional[pulumi.Input['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs']]:
        """
        Provides the name and description of the job.
        """
        return pulumi.get(self, "work_request_details")

    @work_request_details.setter
    def work_request_details(self, value: Optional[pulumi.Input['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs']]):
        pulumi.set(self, "work_request_details", value)


@pulumi.type_token("oci:OsManagementHub/managedInstanceUpdatePackagesManagement:ManagedInstanceUpdatePackagesManagement")
class ManagedInstanceUpdatePackagesManagement(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 managed_instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 package_names: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 update_types: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 work_request_details: Optional[pulumi.Input[Union['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs', 'ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgsDict']]] = None,
                 __props__=None):
        """
        This resource provides the Managed Instance Update Packages Management resource in Oracle Cloud Infrastructure Os Management Hub service.

        Updates a package on a managed instance.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_managed_instance_update_packages_management = oci.os_management_hub.ManagedInstanceUpdatePackagesManagement("test_managed_instance_update_packages_management",
            managed_instance_id=test_managed_instance["id"],
            package_names=managed_instance_update_packages_management_package_names,
            update_types=managed_instance_update_packages_management_update_types,
            work_request_details={
                "description": managed_instance_update_packages_management_work_request_details_description,
                "display_name": managed_instance_update_packages_management_work_request_details_display_name,
            })
        ```

        ## Import

        ManagedInstanceUpdatePackagesManagement can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:OsManagementHub/managedInstanceUpdatePackagesManagement:ManagedInstanceUpdatePackagesManagement test_managed_instance_update_packages_management "id"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] managed_instance_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the managed instance.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] package_names: The list of package names.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] update_types: The types of updates to be applied.
        :param pulumi.Input[Union['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs', 'ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgsDict']] work_request_details: Provides the name and description of the job.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ManagedInstanceUpdatePackagesManagementArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource provides the Managed Instance Update Packages Management resource in Oracle Cloud Infrastructure Os Management Hub service.

        Updates a package on a managed instance.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_managed_instance_update_packages_management = oci.os_management_hub.ManagedInstanceUpdatePackagesManagement("test_managed_instance_update_packages_management",
            managed_instance_id=test_managed_instance["id"],
            package_names=managed_instance_update_packages_management_package_names,
            update_types=managed_instance_update_packages_management_update_types,
            work_request_details={
                "description": managed_instance_update_packages_management_work_request_details_description,
                "display_name": managed_instance_update_packages_management_work_request_details_display_name,
            })
        ```

        ## Import

        ManagedInstanceUpdatePackagesManagement can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:OsManagementHub/managedInstanceUpdatePackagesManagement:ManagedInstanceUpdatePackagesManagement test_managed_instance_update_packages_management "id"
        ```

        :param str resource_name: The name of the resource.
        :param ManagedInstanceUpdatePackagesManagementArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ManagedInstanceUpdatePackagesManagementArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 managed_instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 package_names: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 update_types: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 work_request_details: Optional[pulumi.Input[Union['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs', 'ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgsDict']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ManagedInstanceUpdatePackagesManagementArgs.__new__(ManagedInstanceUpdatePackagesManagementArgs)

            if managed_instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'managed_instance_id'")
            __props__.__dict__["managed_instance_id"] = managed_instance_id
            __props__.__dict__["package_names"] = package_names
            __props__.__dict__["update_types"] = update_types
            __props__.__dict__["work_request_details"] = work_request_details
        super(ManagedInstanceUpdatePackagesManagement, __self__).__init__(
            'oci:OsManagementHub/managedInstanceUpdatePackagesManagement:ManagedInstanceUpdatePackagesManagement',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            managed_instance_id: Optional[pulumi.Input[builtins.str]] = None,
            package_names: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            update_types: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            work_request_details: Optional[pulumi.Input[Union['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs', 'ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgsDict']]] = None) -> 'ManagedInstanceUpdatePackagesManagement':
        """
        Get an existing ManagedInstanceUpdatePackagesManagement resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] managed_instance_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the managed instance.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] package_names: The list of package names.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] update_types: The types of updates to be applied.
        :param pulumi.Input[Union['ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgs', 'ManagedInstanceUpdatePackagesManagementWorkRequestDetailsArgsDict']] work_request_details: Provides the name and description of the job.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ManagedInstanceUpdatePackagesManagementState.__new__(_ManagedInstanceUpdatePackagesManagementState)

        __props__.__dict__["managed_instance_id"] = managed_instance_id
        __props__.__dict__["package_names"] = package_names
        __props__.__dict__["update_types"] = update_types
        __props__.__dict__["work_request_details"] = work_request_details
        return ManagedInstanceUpdatePackagesManagement(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="managedInstanceId")
    def managed_instance_id(self) -> pulumi.Output[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the managed instance.
        """
        return pulumi.get(self, "managed_instance_id")

    @property
    @pulumi.getter(name="packageNames")
    def package_names(self) -> pulumi.Output[Optional[Sequence[builtins.str]]]:
        """
        The list of package names.
        """
        return pulumi.get(self, "package_names")

    @property
    @pulumi.getter(name="updateTypes")
    def update_types(self) -> pulumi.Output[Optional[Sequence[builtins.str]]]:
        """
        The types of updates to be applied.
        """
        return pulumi.get(self, "update_types")

    @property
    @pulumi.getter(name="workRequestDetails")
    def work_request_details(self) -> pulumi.Output['outputs.ManagedInstanceUpdatePackagesManagementWorkRequestDetails']:
        """
        Provides the name and description of the job.
        """
        return pulumi.get(self, "work_request_details")

