# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = ['SoftwareSourceReplacePackagesManagementArgs', 'SoftwareSourceReplacePackagesManagement']

@pulumi.input_type
class SoftwareSourceReplacePackagesManagementArgs:
    def __init__(__self__, *,
                 packages: pulumi.Input[Sequence[pulumi.Input[builtins.str]]],
                 software_source_id: pulumi.Input[builtins.str]):
        """
        The set of arguments for constructing a SoftwareSourceReplacePackagesManagement resource.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] packages: List of packages specified by the name of the package (N) or the full package name (NVRA or NEVRA).
        :param pulumi.Input[builtins.str] software_source_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the software source.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        pulumi.set(__self__, "packages", packages)
        pulumi.set(__self__, "software_source_id", software_source_id)

    @property
    @pulumi.getter
    def packages(self) -> pulumi.Input[Sequence[pulumi.Input[builtins.str]]]:
        """
        List of packages specified by the name of the package (N) or the full package name (NVRA or NEVRA).
        """
        return pulumi.get(self, "packages")

    @packages.setter
    def packages(self, value: pulumi.Input[Sequence[pulumi.Input[builtins.str]]]):
        pulumi.set(self, "packages", value)

    @property
    @pulumi.getter(name="softwareSourceId")
    def software_source_id(self) -> pulumi.Input[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the software source.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "software_source_id")

    @software_source_id.setter
    def software_source_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "software_source_id", value)


@pulumi.input_type
class _SoftwareSourceReplacePackagesManagementState:
    def __init__(__self__, *,
                 packages: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 software_source_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering SoftwareSourceReplacePackagesManagement resources.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] packages: List of packages specified by the name of the package (N) or the full package name (NVRA or NEVRA).
        :param pulumi.Input[builtins.str] software_source_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the software source.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        if packages is not None:
            pulumi.set(__self__, "packages", packages)
        if software_source_id is not None:
            pulumi.set(__self__, "software_source_id", software_source_id)

    @property
    @pulumi.getter
    def packages(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        List of packages specified by the name of the package (N) or the full package name (NVRA or NEVRA).
        """
        return pulumi.get(self, "packages")

    @packages.setter
    def packages(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "packages", value)

    @property
    @pulumi.getter(name="softwareSourceId")
    def software_source_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the software source.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "software_source_id")

    @software_source_id.setter
    def software_source_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "software_source_id", value)


@pulumi.type_token("oci:OsManagementHub/softwareSourceReplacePackagesManagement:SoftwareSourceReplacePackagesManagement")
class SoftwareSourceReplacePackagesManagement(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 packages: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 software_source_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        This resource provides the Software Source Replace Packages Management resource in Oracle Cloud Infrastructure Os Management Hub service.

        Replaces packages in a software source with the provided list of packages. This operation can only be done for custom software sources that are not created using filters.
        Packages can be of the format:
         * name (for example: git). If isLatestContentOnly is true, only the latest version of the package will be added, otherwise all versions of the package will be added.
         * name-version-release.architecture (for example: git-2.43.5-1.el8_10.x86_64)
         * name-epoch:version-release.architecture (for example: git-0:2.43.5-1.el8_10.x86_64)

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_software_source_replace_packages_management = oci.os_management_hub.SoftwareSourceReplacePackagesManagement("test_software_source_replace_packages_management",
            packages=software_source_replace_packages_management_packages,
            software_source_id=test_software_source["id"])
        ```

        ## Import

        SoftwareSourceReplacePackagesManagement can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:OsManagementHub/softwareSourceReplacePackagesManagement:SoftwareSourceReplacePackagesManagement test_software_source_replace_packages_management "id"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] packages: List of packages specified by the name of the package (N) or the full package name (NVRA or NEVRA).
        :param pulumi.Input[builtins.str] software_source_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the software source.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SoftwareSourceReplacePackagesManagementArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource provides the Software Source Replace Packages Management resource in Oracle Cloud Infrastructure Os Management Hub service.

        Replaces packages in a software source with the provided list of packages. This operation can only be done for custom software sources that are not created using filters.
        Packages can be of the format:
         * name (for example: git). If isLatestContentOnly is true, only the latest version of the package will be added, otherwise all versions of the package will be added.
         * name-version-release.architecture (for example: git-2.43.5-1.el8_10.x86_64)
         * name-epoch:version-release.architecture (for example: git-0:2.43.5-1.el8_10.x86_64)

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_software_source_replace_packages_management = oci.os_management_hub.SoftwareSourceReplacePackagesManagement("test_software_source_replace_packages_management",
            packages=software_source_replace_packages_management_packages,
            software_source_id=test_software_source["id"])
        ```

        ## Import

        SoftwareSourceReplacePackagesManagement can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:OsManagementHub/softwareSourceReplacePackagesManagement:SoftwareSourceReplacePackagesManagement test_software_source_replace_packages_management "id"
        ```

        :param str resource_name: The name of the resource.
        :param SoftwareSourceReplacePackagesManagementArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SoftwareSourceReplacePackagesManagementArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 packages: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 software_source_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SoftwareSourceReplacePackagesManagementArgs.__new__(SoftwareSourceReplacePackagesManagementArgs)

            if packages is None and not opts.urn:
                raise TypeError("Missing required property 'packages'")
            __props__.__dict__["packages"] = packages
            if software_source_id is None and not opts.urn:
                raise TypeError("Missing required property 'software_source_id'")
            __props__.__dict__["software_source_id"] = software_source_id
        super(SoftwareSourceReplacePackagesManagement, __self__).__init__(
            'oci:OsManagementHub/softwareSourceReplacePackagesManagement:SoftwareSourceReplacePackagesManagement',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            packages: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            software_source_id: Optional[pulumi.Input[builtins.str]] = None) -> 'SoftwareSourceReplacePackagesManagement':
        """
        Get an existing SoftwareSourceReplacePackagesManagement resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] packages: List of packages specified by the name of the package (N) or the full package name (NVRA or NEVRA).
        :param pulumi.Input[builtins.str] software_source_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the software source.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SoftwareSourceReplacePackagesManagementState.__new__(_SoftwareSourceReplacePackagesManagementState)

        __props__.__dict__["packages"] = packages
        __props__.__dict__["software_source_id"] = software_source_id
        return SoftwareSourceReplacePackagesManagement(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def packages(self) -> pulumi.Output[Sequence[builtins.str]]:
        """
        List of packages specified by the name of the package (N) or the full package name (NVRA or NEVRA).
        """
        return pulumi.get(self, "packages")

    @property
    @pulumi.getter(name="softwareSourceId")
    def software_source_id(self) -> pulumi.Output[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the software source.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "software_source_id")

