# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetConfigurationsResult',
    'AwaitableGetConfigurationsResult',
    'get_configurations',
    'get_configurations_output',
]

@pulumi.output_type
class GetConfigurationsResult:
    """
    A collection of values returned by getConfigurations.
    """
    def __init__(__self__, compartment_id=None, config_type=None, configuration_collections=None, configuration_id=None, db_version=None, display_name=None, filters=None, id=None, shape=None, state=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if config_type and not isinstance(config_type, str):
            raise TypeError("Expected argument 'config_type' to be a str")
        pulumi.set(__self__, "config_type", config_type)
        if configuration_collections and not isinstance(configuration_collections, list):
            raise TypeError("Expected argument 'configuration_collections' to be a list")
        pulumi.set(__self__, "configuration_collections", configuration_collections)
        if configuration_id and not isinstance(configuration_id, str):
            raise TypeError("Expected argument 'configuration_id' to be a str")
        pulumi.set(__self__, "configuration_id", configuration_id)
        if db_version and not isinstance(db_version, str):
            raise TypeError("Expected argument 'db_version' to be a str")
        pulumi.set(__self__, "db_version", db_version)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if shape and not isinstance(shape, str):
            raise TypeError("Expected argument 'shape' to be a str")
        pulumi.set(__self__, "shape", shape)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> Optional[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment that contains the configuration.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="configType")
    def config_type(self) -> Optional[builtins.str]:
        """
        The type of configuration. Either user-created or a default configuration.
        """
        return pulumi.get(self, "config_type")

    @property
    @pulumi.getter(name="configurationCollections")
    def configuration_collections(self) -> Sequence['outputs.GetConfigurationsConfigurationCollectionResult']:
        """
        The list of configuration_collection.
        """
        return pulumi.get(self, "configuration_collections")

    @property
    @pulumi.getter(name="configurationId")
    def configuration_id(self) -> Optional[builtins.str]:
        return pulumi.get(self, "configuration_id")

    @property
    @pulumi.getter(name="dbVersion")
    def db_version(self) -> Optional[builtins.str]:
        """
        Version of the PostgreSQL database.
        """
        return pulumi.get(self, "db_version")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[builtins.str]:
        """
        A user-friendly display name for the configuration. Avoid entering confidential information.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetConfigurationsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def shape(self) -> Optional[builtins.str]:
        """
        The name of the shape for the configuration. Example: `VM.Standard.E4.Flex`
        """
        return pulumi.get(self, "shape")

    @property
    @pulumi.getter
    def state(self) -> Optional[builtins.str]:
        """
        The current state of the configuration.
        """
        return pulumi.get(self, "state")


class AwaitableGetConfigurationsResult(GetConfigurationsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetConfigurationsResult(
            compartment_id=self.compartment_id,
            config_type=self.config_type,
            configuration_collections=self.configuration_collections,
            configuration_id=self.configuration_id,
            db_version=self.db_version,
            display_name=self.display_name,
            filters=self.filters,
            id=self.id,
            shape=self.shape,
            state=self.state)


def get_configurations(compartment_id: Optional[builtins.str] = None,
                       config_type: Optional[builtins.str] = None,
                       configuration_id: Optional[builtins.str] = None,
                       db_version: Optional[builtins.str] = None,
                       display_name: Optional[builtins.str] = None,
                       filters: Optional[Sequence[Union['GetConfigurationsFilterArgs', 'GetConfigurationsFilterArgsDict']]] = None,
                       shape: Optional[builtins.str] = None,
                       state: Optional[builtins.str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetConfigurationsResult:
    """
    This data source provides the list of Configurations in Oracle Cloud Infrastructure Psql service.

    Returns a list of configurations.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_configurations = oci.Psql.get_configurations(compartment_id=compartment_id,
        config_type=configuration_config_type,
        configuration_id=test_configuration["id"],
        db_version=configuration_db_version,
        display_name=configuration_display_name,
        shape=configuration_shape,
        state=configuration_state)
    ```


    :param builtins.str compartment_id: The ID of the compartment in which to list resources.
    :param builtins.str config_type: A filter to return only resources if their `configType` matches the given `configType`.
    :param builtins.str configuration_id: A unique identifier for the configuration.
    :param builtins.str db_version: Version of the PostgreSQL database, such as 14.9.
    :param builtins.str display_name: A filter to return only resources that match the entire display name given.
    :param builtins.str shape: The name of the shape for the configuration. Example: `VM.Standard.E4.Flex`
    :param builtins.str state: A filter to return only resources if their `lifecycleState` matches the given `lifecycleState`.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['configType'] = config_type
    __args__['configurationId'] = configuration_id
    __args__['dbVersion'] = db_version
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['shape'] = shape
    __args__['state'] = state
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Psql/getConfigurations:getConfigurations', __args__, opts=opts, typ=GetConfigurationsResult).value

    return AwaitableGetConfigurationsResult(
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        config_type=pulumi.get(__ret__, 'config_type'),
        configuration_collections=pulumi.get(__ret__, 'configuration_collections'),
        configuration_id=pulumi.get(__ret__, 'configuration_id'),
        db_version=pulumi.get(__ret__, 'db_version'),
        display_name=pulumi.get(__ret__, 'display_name'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        shape=pulumi.get(__ret__, 'shape'),
        state=pulumi.get(__ret__, 'state'))
def get_configurations_output(compartment_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                              config_type: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                              configuration_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                              db_version: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                              display_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                              filters: Optional[pulumi.Input[Optional[Sequence[Union['GetConfigurationsFilterArgs', 'GetConfigurationsFilterArgsDict']]]]] = None,
                              shape: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                              state: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetConfigurationsResult]:
    """
    This data source provides the list of Configurations in Oracle Cloud Infrastructure Psql service.

    Returns a list of configurations.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_configurations = oci.Psql.get_configurations(compartment_id=compartment_id,
        config_type=configuration_config_type,
        configuration_id=test_configuration["id"],
        db_version=configuration_db_version,
        display_name=configuration_display_name,
        shape=configuration_shape,
        state=configuration_state)
    ```


    :param builtins.str compartment_id: The ID of the compartment in which to list resources.
    :param builtins.str config_type: A filter to return only resources if their `configType` matches the given `configType`.
    :param builtins.str configuration_id: A unique identifier for the configuration.
    :param builtins.str db_version: Version of the PostgreSQL database, such as 14.9.
    :param builtins.str display_name: A filter to return only resources that match the entire display name given.
    :param builtins.str shape: The name of the shape for the configuration. Example: `VM.Standard.E4.Flex`
    :param builtins.str state: A filter to return only resources if their `lifecycleState` matches the given `lifecycleState`.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['configType'] = config_type
    __args__['configurationId'] = configuration_id
    __args__['dbVersion'] = db_version
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['shape'] = shape
    __args__['state'] = state
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:Psql/getConfigurations:getConfigurations', __args__, opts=opts, typ=GetConfigurationsResult)
    return __ret__.apply(lambda __response__: GetConfigurationsResult(
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        config_type=pulumi.get(__response__, 'config_type'),
        configuration_collections=pulumi.get(__response__, 'configuration_collections'),
        configuration_id=pulumi.get(__response__, 'configuration_id'),
        db_version=pulumi.get(__response__, 'db_version'),
        display_name=pulumi.get(__response__, 'display_name'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        shape=pulumi.get(__response__, 'shape'),
        state=pulumi.get(__response__, 'state')))
