# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = ['MonitoringTemplateMonitoringTemplateOnGivenResourcesManagementArgs', 'MonitoringTemplateMonitoringTemplateOnGivenResourcesManagement']

@pulumi.input_type
class MonitoringTemplateMonitoringTemplateOnGivenResourcesManagementArgs:
    def __init__(__self__, *,
                 enable_monitoring_template_on_given_resources: pulumi.Input[builtins.bool],
                 monitoring_template_id: pulumi.Input[builtins.str]):
        """
        The set of arguments for constructing a MonitoringTemplateMonitoringTemplateOnGivenResourcesManagement resource.
        :param pulumi.Input[builtins.bool] enable_monitoring_template_on_given_resources: (Updatable) A required field when set to `true` calls enable action and when set to `false` calls disable action.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        :param pulumi.Input[builtins.str] monitoring_template_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the monitoring template.
        """
        pulumi.set(__self__, "enable_monitoring_template_on_given_resources", enable_monitoring_template_on_given_resources)
        pulumi.set(__self__, "monitoring_template_id", monitoring_template_id)

    @property
    @pulumi.getter(name="enableMonitoringTemplateOnGivenResources")
    def enable_monitoring_template_on_given_resources(self) -> pulumi.Input[builtins.bool]:
        """
        (Updatable) A required field when set to `true` calls enable action and when set to `false` calls disable action.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "enable_monitoring_template_on_given_resources")

    @enable_monitoring_template_on_given_resources.setter
    def enable_monitoring_template_on_given_resources(self, value: pulumi.Input[builtins.bool]):
        pulumi.set(self, "enable_monitoring_template_on_given_resources", value)

    @property
    @pulumi.getter(name="monitoringTemplateId")
    def monitoring_template_id(self) -> pulumi.Input[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the monitoring template.
        """
        return pulumi.get(self, "monitoring_template_id")

    @monitoring_template_id.setter
    def monitoring_template_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "monitoring_template_id", value)


@pulumi.input_type
class _MonitoringTemplateMonitoringTemplateOnGivenResourcesManagementState:
    def __init__(__self__, *,
                 enable_monitoring_template_on_given_resources: Optional[pulumi.Input[builtins.bool]] = None,
                 monitoring_template_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering MonitoringTemplateMonitoringTemplateOnGivenResourcesManagement resources.
        :param pulumi.Input[builtins.bool] enable_monitoring_template_on_given_resources: (Updatable) A required field when set to `true` calls enable action and when set to `false` calls disable action.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        :param pulumi.Input[builtins.str] monitoring_template_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the monitoring template.
        """
        if enable_monitoring_template_on_given_resources is not None:
            pulumi.set(__self__, "enable_monitoring_template_on_given_resources", enable_monitoring_template_on_given_resources)
        if monitoring_template_id is not None:
            pulumi.set(__self__, "monitoring_template_id", monitoring_template_id)

    @property
    @pulumi.getter(name="enableMonitoringTemplateOnGivenResources")
    def enable_monitoring_template_on_given_resources(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (Updatable) A required field when set to `true` calls enable action and when set to `false` calls disable action.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "enable_monitoring_template_on_given_resources")

    @enable_monitoring_template_on_given_resources.setter
    def enable_monitoring_template_on_given_resources(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "enable_monitoring_template_on_given_resources", value)

    @property
    @pulumi.getter(name="monitoringTemplateId")
    def monitoring_template_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the monitoring template.
        """
        return pulumi.get(self, "monitoring_template_id")

    @monitoring_template_id.setter
    def monitoring_template_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "monitoring_template_id", value)


@pulumi.type_token("oci:StackMonitoring/monitoringTemplateMonitoringTemplateOnGivenResourcesManagement:MonitoringTemplateMonitoringTemplateOnGivenResourcesManagement")
class MonitoringTemplateMonitoringTemplateOnGivenResourcesManagement(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enable_monitoring_template_on_given_resources: Optional[pulumi.Input[builtins.bool]] = None,
                 monitoring_template_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        This resource provides the Monitoring Template Monitoring Template On Given Resources Management resource in Oracle Cloud Infrastructure Stack Monitoring service.

        Apply the Monitoring Template identified by the id

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_monitoring_template_monitoring_template_on_given_resources_management = oci.stack_monitoring.MonitoringTemplateMonitoringTemplateOnGivenResourcesManagement("test_monitoring_template_monitoring_template_on_given_resources_management",
            monitoring_template_id=test_monitoring_template["id"],
            enable_monitoring_template_on_given_resources=enable_monitoring_template_on_given_resources)
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.bool] enable_monitoring_template_on_given_resources: (Updatable) A required field when set to `true` calls enable action and when set to `false` calls disable action.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        :param pulumi.Input[builtins.str] monitoring_template_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the monitoring template.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MonitoringTemplateMonitoringTemplateOnGivenResourcesManagementArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource provides the Monitoring Template Monitoring Template On Given Resources Management resource in Oracle Cloud Infrastructure Stack Monitoring service.

        Apply the Monitoring Template identified by the id

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_monitoring_template_monitoring_template_on_given_resources_management = oci.stack_monitoring.MonitoringTemplateMonitoringTemplateOnGivenResourcesManagement("test_monitoring_template_monitoring_template_on_given_resources_management",
            monitoring_template_id=test_monitoring_template["id"],
            enable_monitoring_template_on_given_resources=enable_monitoring_template_on_given_resources)
        ```

        :param str resource_name: The name of the resource.
        :param MonitoringTemplateMonitoringTemplateOnGivenResourcesManagementArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MonitoringTemplateMonitoringTemplateOnGivenResourcesManagementArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enable_monitoring_template_on_given_resources: Optional[pulumi.Input[builtins.bool]] = None,
                 monitoring_template_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MonitoringTemplateMonitoringTemplateOnGivenResourcesManagementArgs.__new__(MonitoringTemplateMonitoringTemplateOnGivenResourcesManagementArgs)

            if enable_monitoring_template_on_given_resources is None and not opts.urn:
                raise TypeError("Missing required property 'enable_monitoring_template_on_given_resources'")
            __props__.__dict__["enable_monitoring_template_on_given_resources"] = enable_monitoring_template_on_given_resources
            if monitoring_template_id is None and not opts.urn:
                raise TypeError("Missing required property 'monitoring_template_id'")
            __props__.__dict__["monitoring_template_id"] = monitoring_template_id
        super(MonitoringTemplateMonitoringTemplateOnGivenResourcesManagement, __self__).__init__(
            'oci:StackMonitoring/monitoringTemplateMonitoringTemplateOnGivenResourcesManagement:MonitoringTemplateMonitoringTemplateOnGivenResourcesManagement',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            enable_monitoring_template_on_given_resources: Optional[pulumi.Input[builtins.bool]] = None,
            monitoring_template_id: Optional[pulumi.Input[builtins.str]] = None) -> 'MonitoringTemplateMonitoringTemplateOnGivenResourcesManagement':
        """
        Get an existing MonitoringTemplateMonitoringTemplateOnGivenResourcesManagement resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.bool] enable_monitoring_template_on_given_resources: (Updatable) A required field when set to `true` calls enable action and when set to `false` calls disable action.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        :param pulumi.Input[builtins.str] monitoring_template_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the monitoring template.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MonitoringTemplateMonitoringTemplateOnGivenResourcesManagementState.__new__(_MonitoringTemplateMonitoringTemplateOnGivenResourcesManagementState)

        __props__.__dict__["enable_monitoring_template_on_given_resources"] = enable_monitoring_template_on_given_resources
        __props__.__dict__["monitoring_template_id"] = monitoring_template_id
        return MonitoringTemplateMonitoringTemplateOnGivenResourcesManagement(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="enableMonitoringTemplateOnGivenResources")
    def enable_monitoring_template_on_given_resources(self) -> pulumi.Output[builtins.bool]:
        """
        (Updatable) A required field when set to `true` calls enable action and when set to `false` calls disable action.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "enable_monitoring_template_on_given_resources")

    @property
    @pulumi.getter(name="monitoringTemplateId")
    def monitoring_template_id(self) -> pulumi.Output[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the monitoring template.
        """
        return pulumi.get(self, "monitoring_template_id")

