# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetSubscriptionRedeemableUsersResult',
    'AwaitableGetSubscriptionRedeemableUsersResult',
    'get_subscription_redeemable_users',
    'get_subscription_redeemable_users_output',
]

@pulumi.output_type
class GetSubscriptionRedeemableUsersResult:
    """
    A collection of values returned by getSubscriptionRedeemableUsers.
    """
    def __init__(__self__, filters=None, id=None, redeemable_user_collections=None, subscription_id=None, tenancy_id=None):
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if redeemable_user_collections and not isinstance(redeemable_user_collections, list):
            raise TypeError("Expected argument 'redeemable_user_collections' to be a list")
        pulumi.set(__self__, "redeemable_user_collections", redeemable_user_collections)
        if subscription_id and not isinstance(subscription_id, str):
            raise TypeError("Expected argument 'subscription_id' to be a str")
        pulumi.set(__self__, "subscription_id", subscription_id)
        if tenancy_id and not isinstance(tenancy_id, str):
            raise TypeError("Expected argument 'tenancy_id' to be a str")
        pulumi.set(__self__, "tenancy_id", tenancy_id)

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetSubscriptionRedeemableUsersFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="redeemableUserCollections")
    def redeemable_user_collections(self) -> Sequence['outputs.GetSubscriptionRedeemableUsersRedeemableUserCollectionResult']:
        """
        The list of redeemable_user_collection.
        """
        return pulumi.get(self, "redeemable_user_collections")

    @property
    @pulumi.getter(name="subscriptionId")
    def subscription_id(self) -> builtins.str:
        return pulumi.get(self, "subscription_id")

    @property
    @pulumi.getter(name="tenancyId")
    def tenancy_id(self) -> builtins.str:
        return pulumi.get(self, "tenancy_id")


class AwaitableGetSubscriptionRedeemableUsersResult(GetSubscriptionRedeemableUsersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSubscriptionRedeemableUsersResult(
            filters=self.filters,
            id=self.id,
            redeemable_user_collections=self.redeemable_user_collections,
            subscription_id=self.subscription_id,
            tenancy_id=self.tenancy_id)


def get_subscription_redeemable_users(filters: Optional[Sequence[Union['GetSubscriptionRedeemableUsersFilterArgs', 'GetSubscriptionRedeemableUsersFilterArgsDict']]] = None,
                                      subscription_id: Optional[builtins.str] = None,
                                      tenancy_id: Optional[builtins.str] = None,
                                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSubscriptionRedeemableUsersResult:
    """
    This data source provides the list of Subscription Redeemable Users in Oracle Cloud Infrastructure Usage Proxy service.

    Provides the list of user summary that can redeem rewards for the given subscription ID.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_subscription_redeemable_users = oci.UsageProxy.get_subscription_redeemable_users(subscription_id=test_subscription["id"],
        tenancy_id=test_tenancy["id"])
    ```


    :param builtins.str subscription_id: The subscription ID for which rewards information is requested for.
    :param builtins.str tenancy_id: The OCID of the tenancy.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['subscriptionId'] = subscription_id
    __args__['tenancyId'] = tenancy_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:UsageProxy/getSubscriptionRedeemableUsers:getSubscriptionRedeemableUsers', __args__, opts=opts, typ=GetSubscriptionRedeemableUsersResult).value

    return AwaitableGetSubscriptionRedeemableUsersResult(
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        redeemable_user_collections=pulumi.get(__ret__, 'redeemable_user_collections'),
        subscription_id=pulumi.get(__ret__, 'subscription_id'),
        tenancy_id=pulumi.get(__ret__, 'tenancy_id'))
def get_subscription_redeemable_users_output(filters: Optional[pulumi.Input[Optional[Sequence[Union['GetSubscriptionRedeemableUsersFilterArgs', 'GetSubscriptionRedeemableUsersFilterArgsDict']]]]] = None,
                                             subscription_id: Optional[pulumi.Input[builtins.str]] = None,
                                             tenancy_id: Optional[pulumi.Input[builtins.str]] = None,
                                             opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetSubscriptionRedeemableUsersResult]:
    """
    This data source provides the list of Subscription Redeemable Users in Oracle Cloud Infrastructure Usage Proxy service.

    Provides the list of user summary that can redeem rewards for the given subscription ID.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_subscription_redeemable_users = oci.UsageProxy.get_subscription_redeemable_users(subscription_id=test_subscription["id"],
        tenancy_id=test_tenancy["id"])
    ```


    :param builtins.str subscription_id: The subscription ID for which rewards information is requested for.
    :param builtins.str tenancy_id: The OCID of the tenancy.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['subscriptionId'] = subscription_id
    __args__['tenancyId'] = tenancy_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:UsageProxy/getSubscriptionRedeemableUsers:getSubscriptionRedeemableUsers', __args__, opts=opts, typ=GetSubscriptionRedeemableUsersResult)
    return __ret__.apply(lambda __response__: GetSubscriptionRedeemableUsersResult(
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        redeemable_user_collections=pulumi.get(__response__, 'redeemable_user_collections'),
        subscription_id=pulumi.get(__response__, 'subscription_id'),
        tenancy_id=pulumi.get(__response__, 'tenancy_id')))
