# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'VbInstanceAlternateCustomEndpointArgs',
    'VbInstanceAlternateCustomEndpointArgsDict',
    'VbInstanceCustomEndpointArgs',
    'VbInstanceCustomEndpointArgsDict',
    'VbInstanceNetworkEndpointDetailsArgs',
    'VbInstanceNetworkEndpointDetailsArgsDict',
    'VbInstanceNetworkEndpointDetailsAllowlistedHttpVcnArgs',
    'VbInstanceNetworkEndpointDetailsAllowlistedHttpVcnArgsDict',
    'GetVbInstancesFilterArgs',
    'GetVbInstancesFilterArgsDict',
]

MYPY = False

if not MYPY:
    class VbInstanceAlternateCustomEndpointArgsDict(TypedDict):
        hostname: pulumi.Input[builtins.str]
        """
        (Updatable) A custom hostname to be used for the vb instance URL, in FQDN format.
        """
        certificate_secret_id: NotRequired[pulumi.Input[builtins.str]]
        """
        (Updatable) Optional OCID of a vault/secret containing a private SSL certificate bundle to be used for the custom hostname. All certificates should be stored in a single base64 encoded secret Note the update will fail if this is not a valid certificate.
        """
        certificate_secret_version: NotRequired[pulumi.Input[builtins.int]]
        """
        The secret version used for the certificate-secret-id (if certificate-secret-id is specified).
        """
elif False:
    VbInstanceAlternateCustomEndpointArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class VbInstanceAlternateCustomEndpointArgs:
    def __init__(__self__, *,
                 hostname: pulumi.Input[builtins.str],
                 certificate_secret_id: Optional[pulumi.Input[builtins.str]] = None,
                 certificate_secret_version: Optional[pulumi.Input[builtins.int]] = None):
        """
        :param pulumi.Input[builtins.str] hostname: (Updatable) A custom hostname to be used for the vb instance URL, in FQDN format.
        :param pulumi.Input[builtins.str] certificate_secret_id: (Updatable) Optional OCID of a vault/secret containing a private SSL certificate bundle to be used for the custom hostname. All certificates should be stored in a single base64 encoded secret Note the update will fail if this is not a valid certificate.
        :param pulumi.Input[builtins.int] certificate_secret_version: The secret version used for the certificate-secret-id (if certificate-secret-id is specified).
        """
        pulumi.set(__self__, "hostname", hostname)
        if certificate_secret_id is not None:
            pulumi.set(__self__, "certificate_secret_id", certificate_secret_id)
        if certificate_secret_version is not None:
            pulumi.set(__self__, "certificate_secret_version", certificate_secret_version)

    @property
    @pulumi.getter
    def hostname(self) -> pulumi.Input[builtins.str]:
        """
        (Updatable) A custom hostname to be used for the vb instance URL, in FQDN format.
        """
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter(name="certificateSecretId")
    def certificate_secret_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Updatable) Optional OCID of a vault/secret containing a private SSL certificate bundle to be used for the custom hostname. All certificates should be stored in a single base64 encoded secret Note the update will fail if this is not a valid certificate.
        """
        return pulumi.get(self, "certificate_secret_id")

    @certificate_secret_id.setter
    def certificate_secret_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "certificate_secret_id", value)

    @property
    @pulumi.getter(name="certificateSecretVersion")
    def certificate_secret_version(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The secret version used for the certificate-secret-id (if certificate-secret-id is specified).
        """
        return pulumi.get(self, "certificate_secret_version")

    @certificate_secret_version.setter
    def certificate_secret_version(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "certificate_secret_version", value)


if not MYPY:
    class VbInstanceCustomEndpointArgsDict(TypedDict):
        hostname: pulumi.Input[builtins.str]
        """
        (Updatable) A custom hostname to be used for the vb instance URL, in FQDN format.
        """
        certificate_secret_id: NotRequired[pulumi.Input[builtins.str]]
        """
        (Updatable) Optional OCID of a vault/secret containing a private SSL certificate bundle to be used for the custom hostname. All certificates should be stored in a single base64 encoded secret Note the update will fail if this is not a valid certificate.
        """
        certificate_secret_version: NotRequired[pulumi.Input[builtins.int]]
        """
        The secret version used for the certificate-secret-id (if certificate-secret-id is specified).
        """
elif False:
    VbInstanceCustomEndpointArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class VbInstanceCustomEndpointArgs:
    def __init__(__self__, *,
                 hostname: pulumi.Input[builtins.str],
                 certificate_secret_id: Optional[pulumi.Input[builtins.str]] = None,
                 certificate_secret_version: Optional[pulumi.Input[builtins.int]] = None):
        """
        :param pulumi.Input[builtins.str] hostname: (Updatable) A custom hostname to be used for the vb instance URL, in FQDN format.
        :param pulumi.Input[builtins.str] certificate_secret_id: (Updatable) Optional OCID of a vault/secret containing a private SSL certificate bundle to be used for the custom hostname. All certificates should be stored in a single base64 encoded secret Note the update will fail if this is not a valid certificate.
        :param pulumi.Input[builtins.int] certificate_secret_version: The secret version used for the certificate-secret-id (if certificate-secret-id is specified).
        """
        pulumi.set(__self__, "hostname", hostname)
        if certificate_secret_id is not None:
            pulumi.set(__self__, "certificate_secret_id", certificate_secret_id)
        if certificate_secret_version is not None:
            pulumi.set(__self__, "certificate_secret_version", certificate_secret_version)

    @property
    @pulumi.getter
    def hostname(self) -> pulumi.Input[builtins.str]:
        """
        (Updatable) A custom hostname to be used for the vb instance URL, in FQDN format.
        """
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter(name="certificateSecretId")
    def certificate_secret_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Updatable) Optional OCID of a vault/secret containing a private SSL certificate bundle to be used for the custom hostname. All certificates should be stored in a single base64 encoded secret Note the update will fail if this is not a valid certificate.
        """
        return pulumi.get(self, "certificate_secret_id")

    @certificate_secret_id.setter
    def certificate_secret_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "certificate_secret_id", value)

    @property
    @pulumi.getter(name="certificateSecretVersion")
    def certificate_secret_version(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The secret version used for the certificate-secret-id (if certificate-secret-id is specified).
        """
        return pulumi.get(self, "certificate_secret_version")

    @certificate_secret_version.setter
    def certificate_secret_version(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "certificate_secret_version", value)


if not MYPY:
    class VbInstanceNetworkEndpointDetailsArgsDict(TypedDict):
        network_endpoint_type: pulumi.Input[builtins.str]
        """
        (Updatable) The type of network endpoint.

        For private endpoint access
        """
        allowlisted_http_ips: NotRequired[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]
        """
        (Updatable) Source IP addresses or IP address ranges ingress rules. (ex: "168.122.59.5/32", "10.20.30.0/26") An invalid IP or CIDR block will result in a 400 response.
        """
        allowlisted_http_vcns: NotRequired[pulumi.Input[Sequence[pulumi.Input['VbInstanceNetworkEndpointDetailsAllowlistedHttpVcnArgsDict']]]]
        """
        (Updatable) Virtual Cloud Networks allowed to access this network endpoint.
        """
        network_security_group_ids: NotRequired[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]
        """
        (Updatable) Network Security Group OCIDs for the Private Endpoint.
        """
        private_endpoint_ip: NotRequired[pulumi.Input[builtins.str]]
        """
        The IP address to be assigned to Private Endpoint
        """
        subnet_id: NotRequired[pulumi.Input[builtins.str]]
        """
        (Updatable) The subnet OCID for the private endpoint.

        For public network access control
        """
elif False:
    VbInstanceNetworkEndpointDetailsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class VbInstanceNetworkEndpointDetailsArgs:
    def __init__(__self__, *,
                 network_endpoint_type: pulumi.Input[builtins.str],
                 allowlisted_http_ips: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 allowlisted_http_vcns: Optional[pulumi.Input[Sequence[pulumi.Input['VbInstanceNetworkEndpointDetailsAllowlistedHttpVcnArgs']]]] = None,
                 network_security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 private_endpoint_ip: Optional[pulumi.Input[builtins.str]] = None,
                 subnet_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        :param pulumi.Input[builtins.str] network_endpoint_type: (Updatable) The type of network endpoint.
               
               For private endpoint access
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] allowlisted_http_ips: (Updatable) Source IP addresses or IP address ranges ingress rules. (ex: "168.122.59.5/32", "10.20.30.0/26") An invalid IP or CIDR block will result in a 400 response.
        :param pulumi.Input[Sequence[pulumi.Input['VbInstanceNetworkEndpointDetailsAllowlistedHttpVcnArgs']]] allowlisted_http_vcns: (Updatable) Virtual Cloud Networks allowed to access this network endpoint.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] network_security_group_ids: (Updatable) Network Security Group OCIDs for the Private Endpoint.
        :param pulumi.Input[builtins.str] private_endpoint_ip: The IP address to be assigned to Private Endpoint
        :param pulumi.Input[builtins.str] subnet_id: (Updatable) The subnet OCID for the private endpoint.
               
               For public network access control
        """
        pulumi.set(__self__, "network_endpoint_type", network_endpoint_type)
        if allowlisted_http_ips is not None:
            pulumi.set(__self__, "allowlisted_http_ips", allowlisted_http_ips)
        if allowlisted_http_vcns is not None:
            pulumi.set(__self__, "allowlisted_http_vcns", allowlisted_http_vcns)
        if network_security_group_ids is not None:
            pulumi.set(__self__, "network_security_group_ids", network_security_group_ids)
        if private_endpoint_ip is not None:
            pulumi.set(__self__, "private_endpoint_ip", private_endpoint_ip)
        if subnet_id is not None:
            pulumi.set(__self__, "subnet_id", subnet_id)

    @property
    @pulumi.getter(name="networkEndpointType")
    def network_endpoint_type(self) -> pulumi.Input[builtins.str]:
        """
        (Updatable) The type of network endpoint.

        For private endpoint access
        """
        return pulumi.get(self, "network_endpoint_type")

    @network_endpoint_type.setter
    def network_endpoint_type(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "network_endpoint_type", value)

    @property
    @pulumi.getter(name="allowlistedHttpIps")
    def allowlisted_http_ips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        (Updatable) Source IP addresses or IP address ranges ingress rules. (ex: "168.122.59.5/32", "10.20.30.0/26") An invalid IP or CIDR block will result in a 400 response.
        """
        return pulumi.get(self, "allowlisted_http_ips")

    @allowlisted_http_ips.setter
    def allowlisted_http_ips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "allowlisted_http_ips", value)

    @property
    @pulumi.getter(name="allowlistedHttpVcns")
    def allowlisted_http_vcns(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VbInstanceNetworkEndpointDetailsAllowlistedHttpVcnArgs']]]]:
        """
        (Updatable) Virtual Cloud Networks allowed to access this network endpoint.
        """
        return pulumi.get(self, "allowlisted_http_vcns")

    @allowlisted_http_vcns.setter
    def allowlisted_http_vcns(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VbInstanceNetworkEndpointDetailsAllowlistedHttpVcnArgs']]]]):
        pulumi.set(self, "allowlisted_http_vcns", value)

    @property
    @pulumi.getter(name="networkSecurityGroupIds")
    def network_security_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        (Updatable) Network Security Group OCIDs for the Private Endpoint.
        """
        return pulumi.get(self, "network_security_group_ids")

    @network_security_group_ids.setter
    def network_security_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "network_security_group_ids", value)

    @property
    @pulumi.getter(name="privateEndpointIp")
    def private_endpoint_ip(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The IP address to be assigned to Private Endpoint
        """
        return pulumi.get(self, "private_endpoint_ip")

    @private_endpoint_ip.setter
    def private_endpoint_ip(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "private_endpoint_ip", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Updatable) The subnet OCID for the private endpoint.

        For public network access control
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "subnet_id", value)


if not MYPY:
    class VbInstanceNetworkEndpointDetailsAllowlistedHttpVcnArgsDict(TypedDict):
        id: pulumi.Input[builtins.str]
        """
        (Updatable) The Virtual Cloud Network OCID.
        """
        allowlisted_ip_cidrs: NotRequired[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]
        """
        (Updatable) Source IP addresses or IP address ranges ingress rules. (ex: "168.122.59.5/32", "10.20.30.0/26") An invalid IP or CIDR block will result in a 400 response.
        """
elif False:
    VbInstanceNetworkEndpointDetailsAllowlistedHttpVcnArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class VbInstanceNetworkEndpointDetailsAllowlistedHttpVcnArgs:
    def __init__(__self__, *,
                 id: pulumi.Input[builtins.str],
                 allowlisted_ip_cidrs: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None):
        """
        :param pulumi.Input[builtins.str] id: (Updatable) The Virtual Cloud Network OCID.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] allowlisted_ip_cidrs: (Updatable) Source IP addresses or IP address ranges ingress rules. (ex: "168.122.59.5/32", "10.20.30.0/26") An invalid IP or CIDR block will result in a 400 response.
        """
        pulumi.set(__self__, "id", id)
        if allowlisted_ip_cidrs is not None:
            pulumi.set(__self__, "allowlisted_ip_cidrs", allowlisted_ip_cidrs)

    @property
    @pulumi.getter
    def id(self) -> pulumi.Input[builtins.str]:
        """
        (Updatable) The Virtual Cloud Network OCID.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter(name="allowlistedIpCidrs")
    def allowlisted_ip_cidrs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        (Updatable) Source IP addresses or IP address ranges ingress rules. (ex: "168.122.59.5/32", "10.20.30.0/26") An invalid IP or CIDR block will result in a 400 response.
        """
        return pulumi.get(self, "allowlisted_ip_cidrs")

    @allowlisted_ip_cidrs.setter
    def allowlisted_ip_cidrs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "allowlisted_ip_cidrs", value)


if not MYPY:
    class GetVbInstancesFilterArgsDict(TypedDict):
        name: builtins.str
        values: Sequence[builtins.str]
        regex: NotRequired[builtins.bool]
elif False:
    GetVbInstancesFilterArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GetVbInstancesFilterArgs:
    def __init__(__self__, *,
                 name: builtins.str,
                 values: Sequence[builtins.str],
                 regex: Optional[builtins.bool] = None):
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "values", values)
        if regex is not None:
            pulumi.set(__self__, "regex", regex)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: builtins.str):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def values(self) -> Sequence[builtins.str]:
        return pulumi.get(self, "values")

    @values.setter
    def values(self, value: Sequence[builtins.str]):
        pulumi.set(self, "values", value)

    @property
    @pulumi.getter
    def regex(self) -> Optional[builtins.bool]:
        return pulumi.get(self, "regex")

    @regex.setter
    def regex(self, value: Optional[builtins.bool]):
        pulumi.set(self, "regex", value)


